#include "baptiall.h"
#include "cattoall.h"
#pragma hdrstop

#define MODULE_NAME "ctxoutil"
/**********************************************************************/
/*                       C T X O U T I L . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fonctions priphriques ( Loupe,... )	       */
/*--------------------------------------------------------------------*/
/*    Auteur         : Sbastien Delestaing          			      	 */
/*    Dvelopp le   : Avril 1996 - Septembre 1996	                   */
/*    Dernire modif.: 24/09/96                                       */
/**********************************************************************/
/*
#include <math.h>
#include <stdio.h>
#include <values.h>

//  Inclusions bibliothques Object Windows
#include <owl\applicat.h>
#include <owl\combobox.h>
#include <owl\color.h>
#include <owl\menu.h>
#include <owl\olewindo.h>
#include <owl\gdiobjec.h>
#include <owl\scroller.h>
*/
// Inclusion bibliothques Image
/*
#include "wsysutil.h"
#include "wappbase.rh"
//#pragma message "Insertion provisoire de wappbase.rc"
//#include "..\awgttsi\wappbase.rc"
#include "wappbase.h"
#include "wgttsi.h"
#include "wmain.h"
*/
//  Inclusions bibliothques Iris
#include "piadiv.h"

#include "anallec.h"
#include "base.h"
#include "contour.h"
#include "sysctr.h"
#include "scaltool.h"
#include "symbole.h"
#include "wgeometr.h"
#include "wintrac.h"
#include "wiris.h"

#include "ctxoutil.h"


#include "iris.rc"
#include "ctxoutil.rch"
//#include "analtex.h"

int fUnlockAggrand;
#if 0
/*------------------------------------------------------------------------*/
/*                   Nouvelle classe TPreview			                       */
/*--Systme---------------------------------------------------------------*/
/*#pragma message "Prototype et corps provisoire"
void Ev_ClicNouveauPoint(TPoint &,int etatsouris);
/*
void Ev_ClicNouveauPoint(TPoint &,int)
  {
  Indique_Fonction()->SendMessage(WM_COMMAND,CM_NouveauPoint);
  }
*/

//int Ev_ClicNouveauPoint(TPoint &,int etatsouris){Erreur("Should never run through this");}
DEFINE_RESPONSE_TABLE1( TPreview, TAssociatif )

	EV_COMMAND( ID_BOUTON, MiseAJour ),
	EV_WM_LBUTTONDOWN,
	EV_WM_MOUSEMOVE,

END_RESPONSE_TABLE;

TPreview::TPreview( TWindow* parent )
 : TAssociatif(parent, "Preview")
{	Attr.X = ((iLargeurEcran-590)>>1)-uLargeurBordureFine;
	Attr.Y = HAUTEUR_AFFIM+2;
	Attr.W = 590+2*uLargeurBordureFine;
	Attr.H = 80+2*uLargeurBordureFine+iHauteurTitre-1;
	pBouton=new TButton( this, ID_BOUTON,"", 580, 7, 8, 66, FALSE );
	FenPtr=parent;
}

void TPreview::SetupWindow()
{	unsigned char lut[1024];
	int x;

	TAssociatif::SetupWindow();

	FirstCall=TRUE;

	hloc = LocalAlloc(LMEM_ZEROINIT | LMEM_MOVEABLE,
	 sizeof(BITMAPINFOHEADER) + (1024));
	pbmi = (PBITMAPINFO) LocalLock(hloc);

	pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	pbmi->bmiHeader.biWidth = 64;
	pbmi->bmiHeader.biHeight = 64;
	pbmi->bmiHeader.biPlanes = 1;
	pbmi->bmiHeader.biCompression = BI_RGB;
	pbmi->bmiHeader.biBitCount = 8;
	pbmi->bmiHeader.biClrUsed=256;
	pbmi->bmiHeader.biClrImportant=256;
	pbmi->bmiHeader.biSizeImage=(pbmi->bmiHeader.biWidth*
	 pbmi->bmiHeader.biHeight)*pbmi->bmiHeader.biBitCount/8;

	for(x=0;x<1024;x+=4)             // Lut linaire
	{	lut[x]=x>>2;
		lut[x+1]=x>>2;
		lut[x+2]=x>>2;
		lut[x+3]=0;
	}
	memcpy( pbmi->bmiColors, lut, 1024);

	Reduit();
}

void TPreview::Paint( TDC& dc, BOOL , TRect& r )
{	TDib *dib;
	TPoint src;
	TRect dest;
	int i;

	dc.FillRect( r, TBrush( TColor::LtGray ) );
	for( i=0; i<8; i++ )
		dc.FrameRect( 7+i*72, 7, 73+i*72, 73, TBrush( TColor::Black ) );

	if( FirstCall )
	{	for( i=0; i<8; i++ )
			hBitmap[i] = CreateDIBitmap( dc,(BITMAPINFOHEADER FAR *) pbmi, 0,
			 NULL, NULL, DIB_RGB_COLORS );
		FirstCall=FALSE;
	}

	src = TPoint( 0, 0 );

	for( i=0; i<8; i++ )
	{	dest= TRect( 8+72*i, 8, 72*(i+1), 72 );
		SetDIBits( dc, hBitmap[i], 0, 64, ecran+4096*i, pbmi, DIB_RGB_COLORS );
		dib = new TDib( hBitmap[i], FALSE );
		if( dib->IsOK() )
			dc.SetDIBitsToDevice( dest, src, *dib );
		delete dib;
	}
}

void TPreview::Reduit()
{	unsigned char *ptr;
	int i, j;

	ptr=ecran;

	for( i=0; i<64; i++ )
		for( j=0; j<64; j++ )
		{	ptr[i+((63-j)<<6)]=image0[(i<<2)+(j<<10)];
			ptr[4096+i+((63-j)<<6)]=image1[(i<<2)+(j<<10)];
			ptr[8192+i+((63-j)<<6)]=image2[(i<<2)+(j<<10)];
			ptr[12288+i+((63-j)<<6)]=image3[(i<<2)+(j<<10)];
			ptr[16384+i+((63-j)<<6)]=image4[(i<<2)+(j<<10)];
			ptr[20480+i+((63-j)<<6)]=image5[(i<<2)+(j<<10)];
			ptr[24576+i+((63-j)<<6)]=image6[(i<<2)+(j<<10)];
			ptr[28672+i+((63-j)<<6)]=image7[(i<<2)+(j<<10)];
		}
}

void TPreview::MiseAJour()
{	Reduit();
	Invalidate();
}

void TPreview::EvLButtonDown( UINT, TPoint& )
{	if( ImagePointee!=255 )
	{	plan=ImagePointee;
		Calplans();
		((TFen *)FenPtr)->Visim( FenPtr, 0, source );
	}
}

void TPreview::EvMouseMove( UINT ,TPoint& p )
{	char string[20];

	if( TRect( 8, 8, 562, 72 ).Contains( p ) && (((p.x-8) % 72)<64) )
	{	ImagePointee=(p.x-8)/72;
		sprintf( string, "Image %i", ImagePointee );
	}else
	{	ImagePointee=255;
		sprintf( string, "        " );
	}
	pZ1->SetText( string );
}

TPreview::~TPreview()
{  int i;

	if( !FirstCall )
	{	for( i=0; i<8; i++ )
			DeleteObject( hBitmap[i] );
	}

	LocalUnlock(hloc);
	LocalFree(hloc);
}
#endif
/*------------------------------------------------------------------------*/
/*                   Nouvelle classe TLoupe			                       */
/*--Systme---------------------------------------------------------------*/
TLoupe *pLooper=NULL;

DEFINE_RESPONSE_TABLE1( TLoupe, TAssociatif)

	EV_WM_SYSCOMMAND,
  EV_COMMAND(CM_NouveauPoint, NouveauPoint),

END_RESPONSE_TABLE;

//TAgrandir *pUniqueAggrand=NULL;
TLoupe::TLoupe(TWindow* parent)
 : TAssociatif(parent, "Loupe"),sAgrandissoir( parent, this )
  {
  if (pLooper)
    pLooper->ShutDownWindow();
  fUnlockAggrand=FALSE;
  pLooper=this;
  Ajoute_Fonction(Ev_ClicNouveauPoint,0,RETIC,this);   // wmain
  	Attr.X = iLargeurEcran-128-2*uLargeurBordureFine;
	Attr.Y = 0;
	Attr.W = 128+2*uLargeurBordureFine;
	Attr.H = 128+2*uLargeurBordureFine+iHauteurTitre-1;

	pIcone=new TIcon(*GetApplication(), "IconeLoupe" );
//        if (pUniqueAggrand)

	pAgrandir=&sAgrandissoir;
        pAgrandir->Create();
}

void TLoupe::SetupWindow()
{	unsigned char lut[1024];
	int x;

	TAssociatif::SetupWindow();

	FirstCall=TRUE;
	Viseur=TRUE;

	hloc = LocalAlloc(LMEM_ZEROINIT | LMEM_MOVEABLE,
	 sizeof(BITMAPINFOHEADER) + (1024));
	pbmi = (PBITMAPINFO) LocalLock(hloc);

	pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	pbmi->bmiHeader.biWidth = 128;
	pbmi->bmiHeader.biHeight = 128;
	pbmi->bmiHeader.biPlanes = 1;
	pbmi->bmiHeader.biCompression = BI_RGB;
	pbmi->bmiHeader.biBitCount = 8;
	pbmi->bmiHeader.biClrUsed=256;
	pbmi->bmiHeader.biClrImportant=256;
	pbmi->bmiHeader.biSizeImage=(pbmi->bmiHeader.biWidth*
	 pbmi->bmiHeader.biHeight)*pbmi->bmiHeader.biBitCount/8;

	for(x=0;x<1024;x+=4)             // Lut linaire
	{	lut[x]=x>>2;
		lut[x+1]=x>>2;
		lut[x+2]=x>>2;
		lut[x+3]=0;
	}
	memcpy( pbmi->bmiColors, lut, 1024);
}

void TLoupe::NouveauPoint()
{    //	TUtilitaire::NouveauPoint();

	pAgrandir->Recalcule();
}

void TLoupe::Paint(TDC& dc, BOOL , TRect& )
{	TPoint src;
	TRect dest;
	TDib *dib;
	TPen Pen( TColor::Black, 1, PS_DOT );
	int i;

	if( FirstCall )
	{	hBitmap = CreateDIBitmap( dc,(BITMAPINFOHEADER FAR *) pbmi, 0,
			 NULL, NULL, DIB_RGB_COLORS );
		FirstCall=FALSE;
	}
	src = TPoint( 0, 0 );
	dest = TRect( 0, 0, 128, 128 );
	SetDIBits( dc, hBitmap, 0, 128, pAgrandir->ecran, pbmi, DIB_RGB_COLORS );
	dib = new TDib( hBitmap, FALSE );
	if( dib->IsOK() )
		dc.SetDIBitsToDevice( dest, src, *dib );
	delete dib;

	if( Viseur==TRUE )
	{  dc.SelectObject( Pen );
   	dc.SetROP2( R2_MERGEPENNOT );
		switch( pAgrandir->PtActionMode )
		{	case 0:
				i=(128/pAgrandir->vAgTaille)>>1;
				dc.MoveTo( 0, i );
				dc.LineTo( 128, i );
				dc.MoveTo( i, 0 );
				dc.LineTo( i, 128 );
				break;
			case 1:
				dc.MoveTo( 0, 64 );
				dc.LineTo( 128, 64 );
				dc.MoveTo( 64, 0 );
				dc.LineTo( 64, 128 );
				break;
			case 2:
				i=(128/pAgrandir->vAgTaille)>>1;
				dc.MoveTo( 0, 127-i );
				dc.LineTo( 128, 127-i );
				dc.MoveTo( 127-i, 0 );
				dc.LineTo( 127-i, 128 );
				break;
		}
	}
}

void TLoupe::GetWindowClass( WNDCLASS& wc )
{	TAssociatif::GetWindowClass( wc );
	wc.hIcon=*pIcone;
}

char far *TLoupe::GetClassName( )
{	return "LOUPE";
}

void TLoupe::EvMouseMove(UINT a, TPoint& point)
{	point.x = pAgrandir->newx + pAgrandir->index[ point.x ];
	point.y = pAgrandir->newy + pAgrandir->index[ point.y ];
	TAssociatif::EvMouseMove( a, point );
}

void TLoupe::EvSysCommand( UINT command, TPoint & )
{	switch( command )
	{	case SC_MINIMIZE:
			pAgrandir->ShowWindow( SW_HIDE );
			DefaultProcessing();
			break;
		case 0xf120:
			pAgrandir->ShowWindow( SW_SHOW );
			DefaultProcessing();
			break;
		default:
			DefaultProcessing();
	}
}

TLoupe::~TLoupe()
{

  Enleve_Fonction(this);   // wmain
  pLooper=NULL;
  fUnlockAggrand=TRUE;
//  pAgrandir->Destroy();
//  delete pAgrandir;
//  pAgrandir->ShutDownWindow();
//        int fRes;
	if( !FirstCall )
          DeleteObject( hBitmap );

	delete pIcone;
	 LocalUnlock(hloc);
     /*	HLOCAL h=*/LocalFree(hloc);
}
//----------------------------------------------------------------------------
/*------------------------------------------------------------------------*/
/*                   Nouvelle classe TAgrandir (Parametrage de la loupe)  */
/*--Systme---------------------------------------------------------------*/

DEFINE_RESPONSE_TABLE1(TAgrandir, TDialog)

  EV_CHILD_NOTIFY_ALL_CODES(IDC_HSCROLL1, EvHScroll),
  EV_COMMAND(IDC_RADIOBUTTON1, EvRadio1),
  EV_COMMAND(IDC_RADIOBUTTON2, EvRadio2),
  EV_COMMAND(IDC_RADIOBUTTON3, EvRadio3),

END_RESPONSE_TABLE;

TAgrandir::CanClose()
  {
  return fUnlockAggrand;
  }
TAgrandir::~TAgrandir()
  {
	delete AgTaille;
	delete AgCap1;
	delete AgCap2;
	delete AgCap3;
	delete AgRadio1;
	delete AgRadio2;
	delete AgRadio3;

  }

TAgrandir::TAgrandir( TWindow* parent, TLoupe *pL )
 : TDialog( parent, "Agrandir" )
{
	AgTaille=new TScrollBar( this, IDC_HSCROLL1 );
	AgCap1=new TStatic( this, ID_AGTAILLE );
	AgCap2=new TStatic( this, ID_AGXORG );
	AgCap3=new TStatic( this, ID_AGYORG );
	AgRadio1=new TRadioButton( this, IDC_RADIOBUTTON1  );
	AgRadio2=new TRadioButton( this, IDC_RADIOBUTTON2 );
	AgRadio3=new TRadioButton( this, IDC_RADIOBUTTON3 );

	pLoupe=pL;
	if( pLoupe==NULL )
		ShutDownWindow();
}

void TAgrandir::SetupWindow()
{	char string[12];

	TDialog::SetupWindow();

	vAgTaille=255;
	AgxOrg=0;
	AgyOrg=0;
	AgTaille->SetRange( 1, 255 );
	AgTaille->SetPosition( 255 );
	sprintf(string, "%d", vAgTaille);
	AgCap1->SetText(string);
	sprintf(string, "%d", AgxOrg);
	AgCap2->SetText(string);
	sprintf(string, "%d", AgyOrg);
	AgCap3->SetText(string);
	AgRadio1->Uncheck();
	AgRadio2->Check();
	AgRadio3->Uncheck();
	PtActionMode=1;
	Agrandir();
}

void TAgrandir::Recalcule()
{	char string[12];

	AgxOrg=posx;
	AgyOrg=posy;
	sprintf(string, "%d", AgxOrg);
	AgCap2->SetText(string);
	sprintf(string, "%d", AgyOrg);
	AgCap3->SetText(string);
	EvAppliquer();
}

void TAgrandir::EvHScroll(UINT)
{	char string[12];

	vAgTaille=AgTaille->GetPosition();
	sprintf(string, "%d", vAgTaille);
	AgCap1->SetText(string);

	EvAppliquer();
}

void TAgrandir::EvRadio1( void )
{	AgRadio1->Check();
	AgRadio2->Uncheck();
	AgRadio3->Uncheck();
	PtActionMode=0;
	EvAppliquer();
}

void TAgrandir::EvRadio2( void )
{	AgRadio1->Uncheck();
	AgRadio2->Check();
	AgRadio3->Uncheck();
	PtActionMode=1;
	EvAppliquer();
}

void TAgrandir::EvRadio3( void )
{	AgRadio1->Uncheck();
	AgRadio2->Uncheck();
	AgRadio3->Check();
	PtActionMode=2;
	EvAppliquer();
}

void TAgrandir::EvAppliquer( void )
{	Agrandir();
	pLoupe->Invalidate( FALSE );
}

void TAgrandir::Agrandir()
{	int i, x, y, Borne;
	float delta, accu;
	unsigned char *pSrcLine, *pDst;

	delta = (float)vAgTaille/128.0;
	switch( PtActionMode )
	{	case 0:
			newx=AgxOrg;
			newy=AgyOrg;
			accu = 0.0;
			break;
		case 1:
			newx=AgxOrg-vAgTaille/2;
			newy=AgyOrg-vAgTaille/2;
			if( vAgTaille & 0x1 )
			{	accu=0.0;
			}else
			{	accu = 0.5;
			}
			break;
		case 2:
			newx=AgxOrg-vAgTaille-1;
			newy=AgyOrg-vAgTaille-1;
			accu = 0.0;
			break;
		default:
			break;
	}
	pLoupe->Viseur=TRUE;
	if( newx<0 )
	{	newx=0;
		pLoupe->Viseur=FALSE;
	}
	if( newy<0 )
	{	newy=0;
		pLoupe->Viseur=FALSE;
	}
	Borne=255+(vAgTaille & 0x1);
	if( newx+vAgTaille>Borne )
	{	newx=Borne-vAgTaille;
		pLoupe->Viseur=FALSE;
	}
	if( newy+vAgTaille>Borne )
	{	newy=Borne-vAgTaille;
		pLoupe->Viseur=FALSE;
	}

	for( i=0; i<128; i++ )
	{	index[i] = min((int)accu, 255 );
		accu += delta;
	}

	pDst=ecran;
	pDst+=128*127;
	for( y=0; y<128; y++ )
	{	pSrcLine = source + ((newy+index[ y ])<<8);
		for( x=0; x<128; x++ )
			*pDst++ = pSrcLine[ newx+index[ x ] ];
		pDst-=256;
	}
}

/*TAgrandir::~TAgrandir()
{
}
*/
//----------------------------------------------------------------------------

BOOL DessinePolygone(unsigned char *puSource, TCoordonnee *pPtPoly,
 unsigned int wNbElem, unsigned char *puDestin, BOOL type)
{	int i;

	if( wNbElem>1 )
	{	for( i=0; i<wNbElem-1; i++ )
			if( DessineLigne( puSource, TBipoint( pPtPoly[i], pPtPoly[i+1] ),
			  puDestin)==ECHEC )
				return( ECHEC );
		if( (wNbElem>2) && (type==POLY_FERME) )
			if( DessineLigne( puSource, TBipoint( pPtPoly[i], pPtPoly[0] ),
			  puDestin)==ECHEC )
				return( ECHEC );

		return( SUCCES );
	}
	else
		return( ECHEC );
}

BOOL Reduction(unsigned char *pSource, int taille, unsigned char *pDestin)
{	int i, x, y;
	float delta, accu;
	unsigned char index[ 256 ], *pDstLine, *pSrcLine;

	if(!(taille))
		return( ECHEC );

	delta = 256.0/(float)taille;
	accu = 0.0;

	for( i=0; i<taille; i++ )
	{	index[i] = (unsigned char)accu;
		accu += delta;
	}

	pDstLine = pDestin;
	for( y=0; y<taille; y++ )
	{	pSrcLine = pSource + (index[ y ]<<8);
		for( x=0; x<taille; x++ )
			*pDstLine++ = pSrcLine[ index[ x ] ];
		for( ; x<256;x++)
			*pDstLine++ = 0;
	}
	for( ; y<256; y++ )
		for( x=0; x<256; x++ )
			*pDstLine++ = 0;

	return( SUCCES );
}


