/**********************************************************************/
/*                    C T X O U T I L . H			                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Header pour CTXOUTIL.CPP						       */
/*                     				                                     */
/*--------------------------------------------------------------------*/
/*    Auteur         : Sbastien Delestaing          			      	 */
/*    Dvelopp le   : Avril 1996 - Septembre 1996                    */
/*    Dernire modif.: 24/09/96                                       */
/**********************************************************************/

/*-----------------------------------------------------------------------*/
/*                     Constantes locales                                */
/*-----------------------------------------------------------------------*/

#define POLY_OUVERT 	0
#define POLY_FERME 	1

#define ID_STATIC		301
#define ID_BOUTON 	302
#define ID_A			303
#define ID_B			304

int DessinePolygone(unsigned char *, TCoordonnee *,unsigned int, unsigned char *, BOOL type=POLY_OUVERT);
BOOL Reduction( unsigned char *, int, unsigned char * );

//#define EV_TextureReplied 353
//extern TAssociatif *pTextureRequestor;
//extern TQuadrilatere qResTexture;

class TAgrandir;
class TLoupe;

#if 0
/*--TPreview-------------------------------------------------------------*/
class TPreview : public TAssociatif
{	unsigned char ecran[32768l];
	PBITMAPINFO pbmi;
	HBITMAP hBitmap[8];
	HANDLE hloc;
	TWindow *FenPtr;
	TButton *pBouton;
	bool FirstCall;
	int ImagePointee;
	public:
	TPreview(TWindow* parent);
	~TPreview();
	void MiseAJour( void );
	protected:
	void SetupWindow( void );
	void Reduit( void );
	void EvLButtonDown( UINT, TPoint& );
	void EvMouseMove( UINT, TPoint& );
	virtual void Paint( TDC&, BOOL, TRect& );

	DECLARE_RESPONSE_TABLE(TPreview);
};
#endif
/*-----------------------------------------------------------------------*/
/*--TLoupe-------------------------------------------------------------*/
class TAgrandir : public TDialog
{	TScrollBar *AgTaille;
	TStatic *AgCap1, *AgCap2, *AgCap3;
	TRadioButton *AgRadio1, *AgRadio2, *AgRadio3;
	TLoupe *pLoupe;
	public:
        ~TAgrandir();
	int vAgTaille, AgxOrg, AgyOrg, newx, newy;
	char PtActionMode;
	unsigned char index[ 128 ], ecran[16384];
	TAgrandir( TWindow *, TLoupe * );
//	~TAgrandir();
	void EvAppliquer( void );
	virtual void Recalcule();

	protected:
	void SetupWindow( void );
	void EvHScroll( WPARAM id );
	void EvRadio1( void );
	void EvRadio2( void );
	void EvRadio3( void );
   void Agrandir( void );
       int CanClose();
	DECLARE_RESPONSE_TABLE(TAgrandir);

};
class TLoupe : public TAssociatif
{	PBITMAPINFO pbmi;
	HBITMAP hBitmap;
	HANDLE hloc;
	TWindow *FenPtr;
	TIcon *pIcone;
	TAgrandir sAgrandissoir, *pAgrandir;
	bool FirstCall;
	public:
   bool Viseur;
	TLoupe(TWindow* parent);
	~TLoupe();
	char far *GetClassName( void );
	void GetWindowClass( WNDCLASS& );
	protected:
	void SetupWindow( void );
	void EvMouseMove(UINT , TPoint& );
	virtual void Paint( TDC&, BOOL, TRect& );
	void EvSysCommand( UINT, TPoint& );
	void NouveauPoint( void );

	DECLARE_RESPONSE_TABLE(TLoupe);

};
/*------------------------------------------------------------------------*/
/*--TAgrandir-------------------------------------------------------------*/
extern TLoupe *pLooper;

/*-----------------------------------------------------------------------*/


