#error Obsolete: use wcortex.cpp and analtex.cpp
#define MODULE_NAME "CORTEX.CPP"
/**********************************************************************/
/*                        C O R T E X . C P P	                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Localisation de code barre 2D par analyse      */
/*                     de texture et reconstruction gomtrique       */
/*--------------------------------------------------------------------*/
/*    Auteur         : Sbastien Delestaing          			      	 */
/*    Dvelopp le   : Avril 1996 - Septembre 1996	                   */
/*    Dernire modif.: 24/09/96                                       */
/**********************************************************************/

#include <math.h>
#include <stdio.h>
#include <values.h>

#include <owl\combobox.h>
#include <owl\gadgetwi.h>
#include <owl\gdiobjec.h>
#include <owl\menu.h>
#include <owl\olewindo.h>
#include <owl\opensave.h>
#include <owl\scroller.h>

#include "wsysutil.h"
#include "wappbase.h"
#include "wgttsi.h"
#include "wmain.h"                 // Librairies Image
#include "wlmodif.h"
#include "wlcarpro.h"

#include "wbase.h"

#include "wintrac.h"
//#include "wedtderv.h"
#include "wsystool.h"
#include "wgeometr.h"

#include "sysctr.h"
#include "scaltool.h"
#include "symbole.h"
#include "contour.h"
#include "wiris.h"
#include "wlfilt.h"
#include "piadiv.h"

#include "ctxoutil.h"
#include "cortex.h"
#include "ctxsup.h"
#include "cortex.rch"

// ---------------------- Variables Globales -------------------------
// Seuils parametrables pour l'analyse de texture
int seuilzc=60;
int seuil1=70;
int seuil2=140;
int seuil3=140;
TAssociatif *pTextureRequestor=NULL;
TQuadrilatere qResTexture(QuadrilatereErreur);
//Affichage des tapes de calcul 0:Non, 1:Source, 2:Destination
unsigned char far VisuDef[5]={ 0, 0, 0, 2, 2 }, Visu[5]=VisuDef;
//0:Contour de l'objet basse rsolution
//1:Rsultat du dcodage de la chaine de Freeman
//2:Rsultat de la slection du quadrilatre
//3:Rsultat de la correction du quadrilatre
//4:Rsultat de la dtection
unsigned char FondVisu=1;	//0:Noir, 1:Source, 2:Blanc

TTexture 			far *pTx=new TTexture;
void VisuTextureMap(unsigned char uVisuMode, unsigned char puTextureMap[32*32], TRect r=TRect(0,0,31,31));

//---------------- Classe TTexture

TTexture::TTexture()
{
}

TTexture::~TTexture()
{
}

// Slectionne l'image de texture source
void TTexture::SetTsrc( int i )
{	switch( i )
	{	case 1:
			Tsrc=TI1;
			break;
		case 2:
			Tsrc=TI2;
			break;
		case 3:
			Tsrc=TI3;
			break;
		case 4:
			Tsrc=TI4;
			break;
		default:
			break;
	}
}

// Slectionne l'image de texture destination
void TTexture::SetTdst( int i )
{
  Trace("SetTdst ",i,104);
	switch( i )
	{	case 1:
			Tdst=TI1;
			break;
		case 2:
			Tdst=TI2;
			break;
		case 3:
			Tdst=TI3;
			break;
		case 4:
			Tdst=TI4;
			break;
		default:
			break;
	}
}

void TTexture::CmTexture( WPARAM id )
  {
  if( id != CM_COMPACITE )
    {
    pContour=PlanSuiv( destin );
    CalculeZCLaplacien( source, pContour, LAPLACIEN_CHAR_4, seuilzc );
    }
	switch( id )
	{	case CM_DENSITE:
			Densite();
			SetTsrc(1);
			Tdst=destin;
			ShowTI();
			break;
		case CM_GRANULARITE:
			Granularite();
			SetTsrc(1);
			Tdst=destin;
			ShowTI();
			break;
		case CM_DISCONTINUITE:
			Discontinuite();
			SetTsrc(1);
			Tdst=destin;
			ShowTI();
			break;
		case CM_CONTINUITE:
			Continuite();
			SetTsrc(1);
			Tdst=destin;
			ShowTI();
			break;
		case CM_COMPACITE:
			Compacite();
			SetTsrc(1);
			Tdst=destin;
			ShowTI();
			break;
		case CM_PROXIMITE:
			Proximite();
			SetTsrc(1);
			Tdst=destin;
			ShowTI();
			break;
		case CM_VRAISSEMBLANCE:
                  CmVraissemblance(2);
                  break;
/*
			SetTdst(1);
			Continuite();			// TI1=Carte de continuit
			SetTdst(2);
			Densite();				// TI2=Carte de densit
			SetTdst(3);
			Proximite();			// TI3=Carte de Proximite
	                Vraisemblance();
  VisuTextureMap(2, TI4); break;
*/

		case CM_DETECTION:
                  MTrace("Start detection",166);
			SetTdst(1);
			Continuite();			// TI1=Carte de continuit
			SetTdst(2);
			Densite();				// TI2=Carte de densit
			SetTdst(3);
                  MTrace("Enter Proximit",173);
			Proximite();			// TI3=Carte de Proximite
                  MTrace("Enter Detection",173);
			Detection();
                        if (pTextureRequestor) pTextureRequestor->PostMessage(WM_COMMAND,EV_TextureReplied);

			Fenetre->Visim( Fenetre, 0, source );
                  MTrace("End detection",175);
			break;
		case CM_CONTOUR:
		default:
			break;
	}
}

void TTexture::Detection()
{	int i, j, k, l, nobj, nDroite, nFreeman;
	int iLongmax;
	long int LongueurTotale, AccLong, Longmax, Offset;
	unsigned char nmax, max;
	TVecteur Coin1, Coin2, milieu;
	TQuadrilatere Quadrilatere=QuadrilatereErreur;/* PositionCode*/
        qResTexture=QuadrilatereErreur;
// Visualisation: Initialisation du fond
	for( Offset=0; Offset<65536l; Offset++ )
		switch( FondVisu )
		{	case 0:	destin[(int)Offset]=0;
						break;
			case 1:	destin[(int)Offset]=source[(int)Offset];
						break;
			case 2:	destin[(int)Offset]=255;
						break;
			default:	break;
		}
//

// Calcul de la carte de dtection
	Vraisemblance();
    MTrace("Follow-up Vraisemblance",208);

// Etiquetage et tri des objets
	nobj=Etiquetage();

//	Slection de l'objet de plus grande surface
	if( nobj )
	{	nmax=0;
		max=code[0][1];
		for( i=0; i<nobj; i++ )
			if( code[i][1]>max )
			{	nmax=i;
				max=code[i][1];
			}
		for( i=0; i<32*32; i++ )
			TI4[i] = (TI4[i]==code[nmax][0])?255:0;

// Traitement morphologique
		for( i=0; i<32*32; i++ )		// ATTENTION: Init. du buffer OBLIGATOIRE
			TIm[i]=0;

		Tsrc=TI4;
		Morphologie();

// Contours de l'objet basse rsolution
		Tsrc=TI4;
		Tdst=TI1;
		TErosion( 128, 2 );

		for( i=0; i<32*32; i++ )
			TI4[i] &= ~TI1[i];

//Visualisation: Contour en texels de 8*8
VisuTextureMap(Visu[0],TI4);
/*
		if( Visu[0] )
		{	if( Visu[0]==1 )
			{	Tdst=source;
			}else
			{	Tdst=destin;
			}
			for( i=0; i<32; i++ )
				for( j=0; j<32; j++)
					for( k=0; k<8; k++ )
						for( l=0; l<8; l++ )
						{	Offset=(i<<3)+k + (((j<<3)+l)<<8);
							Tdst[(int)Offset]=TI4[i+(j<<5)]?~Tdst[(int)Offset]:Tdst[(int)Offset];
						}
		}
*/
//

//Interruption ventuelle avant calcul de la chaine de Freeman
//		return;

// Calcul de la chane de Freeman
		nFreeman=Freeman();
                Trace("Freeman: ",nFreeman,262);
                if (nFreeman <=1)
                  return;   // Rajout par BM.

// Vectorisation de la chane de Freeman
		nDroite=Vectorisation( nFreeman );
                Trace("Nombre de droites: ",nDroite,268);

		if( nDroite>3 )
		{

                	LongueurTotale=0;
			for( j=0; j<nDroite; j++ )
			{
                Trace("    Action sur droite: ",j,273);
                        	Coin1=(Droite[j].droite).Intersection(Droite[(j+1)%nDroite].droite);
				Coin2=(Droite[(j+1)%nDroite].droite).Intersection(Droite[(j+2)%nDroite].droite);
// Bug: a7n11h15 ->  Coin2 intersec de droites confondues.
//Visualisation: Rsultat du dcodage de la chaine de Freeman
				if( Visu[1] )
				{	if( Visu[1]==1 )
					{	DessineLigne( source, TBipoint( Coin1, Coin2 ), source );
					}else
					{	DessineLigne( destin, TBipoint( Coin1, Coin2 ), destin );
					}
				}
//
				Droite[(j+1)%nDroite].A=Coin1;
				Droite[(j+1)%nDroite].B=Coin2;
				Droite[(j+1)%nDroite].vecteur=TVecteur(Coin2-Coin1);
				Droite[(j+1)%nDroite].orglong=(Droite[(j+1)%nDroite].vecteur).Module();
				LongueurTotale+=Droite[(j+1)%nDroite].orglong;
				Droite[j].indice=j;
			}

// Slection du quadrilatre approch
MTrace("Processed droites",295);
			LongueurTotale=LongueurTotale>>2;
			i=0;
			l=0;
			AccLong=0;
			for( j=0; j<4; j++ )
			{	while( (AccLong<LongueurTotale*(j+1)) && (l<nDroite) )
					AccLong+=Droite[l++].orglong;
				if( l>1 )
					if( labs(AccLong-LongueurTotale*((long)j+1))>labs(AccLong-Droite[l-1].orglong-LongueurTotale*((long)j+1)))
					{  l--;
						AccLong-=Droite[l].orglong;
					}
				Longmax=Droite[i].orglong;
				iLongmax=i;
				k=i;
				milieu=TVecteur(0,0);
				for(;i<l;i++)
				{	if(Droite[i].orglong>Longmax)
					{	Longmax=Droite[i].orglong;
						iLongmax=i;
					}
					milieu=milieu+Droite[i].A;
				}
// Si ce cot est morcel, on utilise le vecteur moyenne
				if( Longmax<(LongueurTotale>>1) )
				{	milieu=milieu+Droite[i-1].B;
					milieu=milieu/(l-k+1);
					Droite[j].droite=TDroite(milieu, TVecteur(Droite[l-1].B-Droite[k].A)
					 , DROITE_POINT_VECTEUR);
				}else
				{	Droite[j]=Droite[iLongmax];
				}
			}
MTrace("Processed quad",329);
			for( j=0; j<4; j++ )
			{
                        Trace("\n    --Intersection j=",j,332);
                        Trace("    Droite 1 ",Droite[j].droite,333);
                        Trace("    Droite 2 ",Droite[(j+1)%4].droite,334);
                        }
MTrace("Action for intersections: ",339);
			for( j=0; j<4; j++ )
			{
                        Trace("    Intersection j=",j,338);
                        Trace("    Droite 1 ",Droite[j].droite,343);
                        Trace("    Droite 2 ",Droite[(j+1)%4].droite,340);
//                        Erreur("Intersection j=",j,341);
                        if ((Droite[j].droite).Paralleles(Droite[(j+1)%4].droite))
                          Erreur("Paralllisme  j=",j,347);

                        	Coin1=(Droite[j].droite).Intersection(Droite[(j+1)%4].droite);
				Coin2=(Droite[(j+1)%4].droite).Intersection(Droite[(j+2)%4].droite);

//Visualisation: Rsultat de la slection des 4 droites principales
				if( Visu[2] )
				{	if( Visu[2]==1 )
					{	DessineLigne( source, TBipoint( Coin1, Coin2 ), source );
					}else
					{	DessineLigne( destin, TBipoint( Coin1, Coin2 ), destin );
					}
				}
//
				Droite[(j+1)%4].A=Coin1;
				Droite[(j+1)%4].B=Coin2;
				Droite[(j+1)%4].vecteur=TVecteur(Coin2-Coin1);
				Droite[(j+1)%4].longueur=(Droite[(j+1)%4].vecteur).Module();
			}

//
MTrace("Call correction",350);

// Correction des angles du quadrilatre
			Correction();
MTrace("Follow-up correction",350);

			for( j=0; j<4; j++ )
			{	Droite[j].vecteur=TVecteur(Droite[j].B-Droite[j].A);
				Droite[j].longueur=(Droite[j].vecteur).Module();
			}
			Quadrilatere.A=Droite[0].A;
			Quadrilatere.B=Droite[1].A;
			Quadrilatere.C=Droite[2].A;
			Quadrilatere.D=Droite[3].A;

//Dbug: Rsultat de la correction du quadrilatere
MTrace("Res correction",366);

			if( Visu[3] )
				for( j=0; j<4; j++ )
				{	Coin1=(Droite[j].droite).Intersection(Droite[(j+1)%4].droite);
					Coin2=(Droite[(j+1)%4].droite).Intersection(Droite[(j+2)%4].droite);
					if( Visu[3]==1 )
					{	DessineLigne( source, TBipoint( Coin1, Coin2 ), source );
					}else
					{	DessineLigne( destin, TBipoint( Coin1, Coin2 ), destin );
					}
				}
//


// Recherche des coins
			RechercheCoins( Quadrilatere, pContour, &qResTexture );
MTrace("Follow-up RechercheCoins",350);

//Visualisation du rsultat de la dtection
			if( Visu[4]==1 )
			{	DessineRetic( source, qResTexture.A, source );
				DessineRetic( source, qResTexture.B, source );
				DessineRetic( source, qResTexture.C, source );
				DessineRetic( source, qResTexture.D, source );
			}else
				if( Visu[4]==2 )
				{	DessineRetic( destin, qResTexture.A, destin );
					DessineRetic( destin, qResTexture.B, destin );
					DessineRetic( destin, qResTexture.C, destin );
					DessineRetic( destin, qResTexture.D, destin );
				}
MTrace("Follow-up Visu-Dtect",350);
		}
	}
}

// Calcule la carte de dtection  partir des images de critre
// source: TI1, TI2, TI3
// destination: TI4
unsigned int TTexture::Vraisemblance( TRect r )
  {
  unsigned int wSom=0;
  TPoint pt;
  for(pt.y=r.top; pt.y <= r.bottom; pt.y++ )
    for(pt.x=r.left; pt.x <= r.right; pt.x++ )
      {
      unsigned int w=(pt.y << 5) +pt.x;
      if( (TI1[w]>seuil1) && (TI2[w]<seuil2) && (TI3[w]<seuil3) )
	{wSom++;	TI4[w]=255;}
      else
	TI4[w]=0;
      }
  return wSom;
  }
// Etiquette les objets dans la carte de dtection (TI4)
int TTexture::Etiquetage()
{	int i, j, nobj=0;
	unsigned char etiquette=2;
	double excentricite;
	TGeo a;
	TGeo2 b;

	for( j=0; j<32; j++ )
		for( i=0; i<32; i++ )
			if( TI4[i+(j<<5)]==255 )
			{	a=TRemplis_CGravite( i, j );
				if( a.m00>TSEUIL )
				{	xcg=(float)a.m10/(float)a.m00;
					ycg=(float)a.m01/(float)a.m00;
					b=TRemplis_Inertie_Etiquette( i, j, etiquette );
					if( b.mu20 )
					{	excentricite=b.mu02/b.mu20;
						if( excentricite>0.8 && excentricite<1.4 )
						{  code[nobj][0]=etiquette;
							code[nobj++][1]=a.m00;
						}
					}
					etiquette++;
				}
			}
	return( nobj );
}

// Traitement morphologique
void TTexture::Morphologie( void )
{			Tdst=TIm;
			TDilatation( 128, 2 );
			Tdst=Tsrc;
			Tsrc=TIm;
			TErosion( 128, 2 );
			Tsrc=Tdst;
			Tdst=TIm;
			TErosion( 128, 2 );
			Tdst=Tsrc;
			Tsrc=TIm;
			TDilatation( 128, 2 );
}

// ATTENTION: On cherche la chaine de Freeman sur un contour FIN et FERME
// c'est  dire qu'un texel du contour a deux voisins (8-voisins), et qu'ils
// ne sont pas eux mmes voisins.
// source: TI4
// destin: unsigned char freeman[]
int TTexture::Freeman()
{	int i=0,	j=0, nstx, nsty;
// Tableaux de conversion ( DeltaX, DeltaY )<=> ( Freeman )
// Attention: DX=Xdest-Xsource+1 et DY=Ydest-Ysource+1
	unsigned char DXDYToFreeman[3][3]={{5, 4, 3},{6, 0, 2},{7, 0, 1}};

	while(!TI4[i+(j<<5)])
		if(!(i=(i+1)%32))
			j++;
	firstx=i;
	firsty=j;
	nstx=i;
	nsty=j;
	i=0;
voisin_trouve:
	TI4[nstx+(nsty<<5)]=200;
	if( (nstx!=31) && (TI4[nstx+1+(nsty<<5)]==255) )
	{	freeman[i++]=0;
		nstx++;
		goto voisin_trouve;
	}
	if( (nsty!=31) && (TI4[nstx+((nsty+1)<<5)]==255) )
	{	freeman[i++]=2;
		nsty++;
		goto voisin_trouve;
	}
	if( nstx && (TI4[nstx-1+(nsty<<5)]==255) )
	{	freeman[i++]=4;
		nstx--;
		goto voisin_trouve;
	}
	if( nsty && (TI4[nstx+((nsty-1)<<5)]==255) )
	{	freeman[i++]=6;
		nsty--;
		goto voisin_trouve;
	}
	if( (nstx!=31) && (nsty!=31) && (TI4[nstx+1+((nsty+1)<<5)]==255) )
	{	freeman[i++]=1;
		nstx++;
		nsty++;
		goto voisin_trouve;
	}
	if( nstx && (nsty!=31) && (TI4[nstx-1+((nsty+1)<<5)]==255) )
	{	freeman[i++]=3;
		nstx--;
		nsty++;
		goto voisin_trouve;
	}
	if( nstx && nsty && (TI4[nstx-1+((nsty-1)<<5)]==255) )
	{	freeman[i++]=5;
		nstx--;
		nsty--;
		goto voisin_trouve;
	}
	if( (nstx!=31) && nsty && (TI4[nstx+1+((nsty-1)<<5)]==255) )
	{	freeman[i++]=7;
		nstx++;
		nsty--;
		goto voisin_trouve;
	}

	freeman[i++]=DXDYToFreeman[firstx-nstx+1][firsty-nsty+1];
	return(i);
}

// Segmentation de la chaine de Freeman
// source: freeman[]
// destin: TDrt Droite[]
int TTexture::Vectorisation( int nFreeman )
{	int j, k, l;
	unsigned char Code, Code1, Code2;
	unsigned char N, NCPrec, NCC;
	float DrtA, DrtB, MoyX, MoyY, DeltaX, DeltaY, Sxx, Sxy;
	char DeltaCode;
	TCoordonnee Points[100];
	TCoordonnee Moyenne, Delta;

	char FreemanToDX[8]={ 1, 1, 0, -1, -1, -1, 0, 1 };
	char FreemanToDY[8]={ 0, 1, 1, 1, 0, -1, -1, -1 };

	j=0;
	k=0;
	N=1;
	Points[0]=TCoordonnee( (firstx<<3)+4, (firsty<<3)+4 );
	Moyenne=Points[0];
// Recherche des points membres du contour
	do
	{	Code1=freeman[j%nFreeman];
		Delta=TCoordonnee(FreemanToDX[Code1]<<3,FreemanToDY[Code1]<<3);
		NCC=0;
		while( freeman[j%nFreeman]==Code1 )
		{	Points[N]=Points[N-1]+Delta;
			Moyenne+=Points[N++];
			j++;
			NCC++;
		}
		Code2=freeman[j%nFreeman];
		DeltaCode=abs(Code1-Code2);
		if( DeltaCode>4 )
			DeltaCode=8-DeltaCode;
		if( (DeltaCode==1) &&
                    ( (NCC>1) || (freeman[(j+1)%nFreeman]!=Code2) ) )
		{	for(;;)
			{	Code=freeman[j%nFreeman];
				if( (Code!=Code1) && (Code!=Code2) )
					break;
				NCPrec=NCC;
				NCC=0;
				while( freeman[j%nFreeman]==Code )
				{	j++;
					NCC++;
				}
				if( (NCPrec!=1) && (NCC!=1) )
				{	j-=NCC;
					 break;
				}
				if( (freeman[j%nFreeman]!=Code1) && (freeman[j%nFreeman]!=Code2) )
					if( (NCC==1) && (NCPrec>1) )
					{	j-=NCC;
						break;
					}
				Delta=TCoordonnee(FreemanToDX[Code]<<3,FreemanToDY[Code]<<3);
				for( l=j-NCC; l<j; l++ )
				{	Points[N]=Points[N-1]+Delta;
					Moyenne+=Points[N++];
				}
			}
		}
// Interpolation linaire des points membres du contour

		MoyX=(float)Moyenne.x/(float)N;
		MoyY=(float)Moyenne.y/(float)N;
		Sxx=0.0;
		Sxy=0.0;
		for( l=0; l<N; l++)
		{	DeltaX=((float)Points[l].x-MoyX);
			DeltaY=((float)Points[l].y-MoyY);
			Sxy+=DeltaX*DeltaY;
			Sxx+=DeltaX*DeltaX;
		}
		if( Sxx!=0.0 )
		{	DrtA=Sxy/Sxx;
			DrtB=MoyY-DrtA*MoyX;
			Droite[k++].droite=TDroite( DrtA, -1.0, DrtB );
		}else
			Droite[k++].droite=TDroite( 1.0, 0.0, -MoyX );
		Points[0]=Points[N-1];
		N=1;
		Moyenne=Points[0];
	}while( j<nFreeman );

	if( j>nFreeman )
	{	k--;
		Droite[0]=Droite[k];
	}
	return(k);
}

// Correction des angles du quadrilatere
// source: TDrt Droite[4]
// destin: TDrt Droite[4]
void TTexture::Correction()
{	int i, j;
	TVecteur Coin1, Coin2;
	double Correction[4];

	for( j=0; j<4; j++ )
	{	Correction[j]=Droite[j].vecteur*Droite[(j+1)%4].vecteur/
		 (2.0*Droite[(j+1)%4].longueur);
	}

	j=0;
	while( (abs(Correction[j])>TOLERANCE) && (j<4)) j++;
	if( j!=4 )
	{	i=j+1;
		while( (abs(Correction[i%4])<=TOLERANCE) && ((i%4)!=j) ) i++;
		switch( (i-j)%4 )
		{  case 0:
				break;
			case 1:
				if( abs(Correction[(i+1)%4])<=TOLERANCE )
				{	if( Droite[i%4].orglong<Droite[(i+2)%4].orglong )
						i+=2;
				}
				i=i%4;
				Coin1=Droite[i].A+Droite[i].vecteur*(1.0+Correction[i]/Droite[i].longueur);
				Coin2=Droite[(i+3)%4].B-Droite[(i+3)%4].vecteur*(1.0+Correction[(i+2)%4]/Droite[(i+3)%4].longueur);
				Droite[i].B=Coin1;
				Droite[(i+1)%4].A=Coin1;
				Droite[(i+3)%4].A=Coin2;
				Droite[(i+2)%4].B=Coin2;
				Droite[(i+1)%4].droite=TDroite(Coin1, Droite[(i+3)%4].vecteur,
				 DROITE_POINT_VECTEUR);
				Droite[(i+2)%4].droite=TDroite(Coin2, Droite[i].vecteur,
				 DROITE_POINT_VECTEUR);
				Droite[(i+2)%4].A=(Droite[(i+1)%4].droite).Intersection(Droite[(i+2)%4].droite);
				Droite[(i+1)%4].B=Droite[(i+2)%4].A;
				break;
			case 2:
				i=i%4;
				Coin1=Droite[i].A+Droite[i].vecteur*(1.0+Correction[i]/Droite[i].longueur);
				Coin2=Droite[(i+2)%4].B-Droite[(i+2)%4].vecteur*(1.0+Correction[(i+1)%4]/Droite[(i+2)%4].longueur);
				Droite[(i+1)%4].droite=TDroite((Coin2+Coin1)/2,
				 Droite[(i+3)%4].vecteur, DROITE_POINT_VECTEUR);
				Droite[(i+1)%4].A=(Droite[(i+1)%4].droite).Intersection(Droite[i].droite);
				Droite[(i+1)%4].B=(Droite[(i+1)%4].droite).Intersection(Droite[(i+2)%4].droite);
				Droite[i].B=Droite[(i+1)%4].A;
				Droite[(i+2)%4].A=Droite[(i+1)%4].B;
				break;
			case 3:
			default:
				break;
		}
	}
}

// Carte de densite
// source: pContour
// destin: Tdst
void TTexture::Densite( TRect r )
{	int i, j;
	unsigned char nagglo;

  TPoint pt;
  for(pt.y=r.top; pt.y <= r.bottom; pt.y++ )
    for(pt.x=r.left; pt.x <= r.right; pt.x++ )
		{  nagglo=0;
			for( i=0; i<8; i++ )
				for( j=0; j<8; j++ )
					if(pContour[(pt.x<<3)+i + (((pt.y<<3)+j)<<8)] && ((pt.x<<3)+i<255) && ((pt.y<<3)+j<255))
						if(pContour[(pt.x<<3)+i+1+(((pt.y<<3)+j)<<8)] && pContour[(pt.x<<3)+i+(((pt.y<<3)+j+1)<<8)]
						 && pContour[(pt.x<<3)+i+1+(((pt.y<<3)+j+1)<<8)])
							nagglo ++;
			Tdst[pt.x+(pt.y<<5)] = min( 40*nagglo, 255 );
		}
}

// Carte de granularite
// idem
void TTexture::Granularite( void )
{	int x, y, i, j, ngr;

	for( x=0; x<32; x++ )
		for( y=0; y<32; y++)
//		Pour chaque texel (8*8)
		{
//       Comptage des contours de longueur <=2
			ngr = 0;
			for( i=0; i<8; i++ )
				for( j=0; j<8; j++ )
				{	switch( pix_test( x*8+i, y*8+j ) & 0x01ff )
					{		case 0x0001:
								ngr++;
								break;
							case 0x0003:
								if( !(pix_test( x*8+i, y*8+j-1 ) & 0x0400) )
									ngr++;
								break;
							case 0x0005:
								if( !(pix_test( x*8+i+1, y*8+j-1 ) & 0x0400) )
									ngr++;
								break;
							case 0x0009:
								if( !(pix_test( x*8+i+1, y*8+j ) & 0x0400)  )
									ngr++;
								break;
							case 0x0011:
								if( !(pix_test( x*8+i+1, y*8+j+1 ) & 0x0400) )
									ngr++;
								break;
							case 0x0021:
								if( !(pix_test( x*8+i, y*8+j+1 ) & 0x0400) )
									ngr++;
								break;
							case 0x0041:
								if( !(pix_test( x*8+i-1, y*8+j+1 ) & 0x0400) )
									ngr++;
								break;
							case 0x0081:
								if( !(pix_test( x*8+i-1, y*8+j ) & 0x0400) )
									ngr++;
								break;
							case 0x0101:
								if( !(pix_test( x*8+i-1, y*8+j-1 ) & 0x0400) )
									ngr++;
								break;
							default:
								break;
					}
				}
			Tdst[x+(y<<5)] = (unsigned char)min( 50*ngr, 255 );
		}
}

// Carte de discontinuit
// idem
void TTexture::Discontinuite( void )
{	int x, y, i, j, nxt;

	for( x=0; x<32; x++ )
		for( y=0; y<32; y++)
//		Pour chaque texel (8*8)
		{
//       Comptage des extrmits de contour >2
			nxt = 0;
			for( i=0; i<8; i++ )
				for( j=0; j<8; j++ )
				{	switch( pix_test( x*8+i, y*8+j ) & 0x01ff )
					{		case 0x0003:
								if( pix_test( x*8+i, y*8+j-1 ) & 0x0400 )
									nxt++;
								break;
							case 0x0005:
								if( pix_test( x*8+i+1, y*8+j-1 ) & 0x0400 )
									nxt++;
								break;
							case 0x0009:
								if( pix_test( x*8+i+1, y*8+j ) & 0x0400 )
									nxt++;
								break;
							case 0x0011:
								if( pix_test( x*8+i+1, y*8+j+1 ) & 0x0400 )
									nxt++;
								break;
							case 0x0021:
								if( pix_test( x*8+i, y*8+j+1 ) & 0x0400 )
									nxt++;
								break;
							case 0x0041:
								if( pix_test( x*8+i-1, y*8+j+1 ) & 0x0400 )
									nxt++;
								break;
							case 0x0081:
								if( pix_test( x*8+i-1, y*8+j ) & 0x0400 )
									nxt++;
								break;
							case 0x0101:
								if( pix_test( x*8+i-1, y*8+j-1 ) & 0x0400 )
									nxt++;
								break;
							default:
								break;
					}
				}
			Tdst[x+(y<<5)] = (unsigned char)min( 50*nxt, 255 );
		}
}

// Carte de continuit
// idem
void TTexture::Continuite(  TRect r )
  {
  int i, j, ngr, nctr, pix_status;
  TPoint pt;
  for(pt.y=r.top; pt.y <= r.bottom; pt.y++ )
    for(pt.x=r.left; pt.x <= r.right; pt.x++ )
//		Pour chaque texel (8*8)
		{
//       Comptage des contours de longueur >2
			ngr = 0;
			nctr = 0;
			for( i=0; i<8; i++ )
				for( j=0; j<8; j++ )
				{	pix_status=pix_test( (pt.x<<3)+i, (pt.y<<3)+j );
					if( !(pix_status & 0x0200) )
					{	nctr++;
						switch( pix_status & 0x01ff )
						{		case 0x0001:
									ngr++;
									break;
								case 0x0003:
									if( !(pix_test( (pt.x<<3)+i, (pt.y<<3)+j-1 ) & 0x0400) )
										ngr++;
									break;
								case 0x0005:
									if( !(pix_test( (pt.x<<3)+i+1, (pt.y<<3)+j-1 ) & 0x0400) )
										ngr++;
									break;
								case 0x0009:
									if( !(pix_test( (pt.x<<3)+i+1, (pt.y<<3)+j ) & 0x0400)  )
										ngr++;
									break;
								case 0x0011:
									if( !(pix_test( (pt.x<<3)+i+1, (pt.y<<3)+j+1 ) & 0x0400) )
										ngr++;
									break;
								case 0x0021:
									if( !(pix_test( (pt.x<<3)+i, (pt.y<<3)+j+1 ) & 0x0400) )
										ngr++;
									break;
								case 0x0041:
									if( !(pix_test( (pt.x<<3)+i-1, (pt.y<<3)+j+1 ) & 0x0400) )
										ngr++;
									break;
								case 0x0081:
									if( !(pix_test( (pt.x<<3)+i-1, (pt.y<<3)+j ) & 0x0400) )
										ngr++;
									break;
								case 0x0101:
									if( !(pix_test( (pt.x<<3)+i-1, (pt.y<<3)+j-1 ) & 0x0400) )
										ngr++;
									break;
								default:
									break;
						}
					}
				}
/*			if( nctr>32 )
			{	Tdst[x+(y<<5)] = 0;
			}
			else
*/				Tdst[pt.x+(pt.y<<5)] = (unsigned char)min( 15*(nctr-ngr), 255 );
//                                       ^^^ -> mult par 32
		}
}

// Carte de proximit
// idem
void TTexture::Proximite( TRect r )
{	int i, j, nisol, pix_status;
  TPoint pt;
  for(pt.y=r.top; pt.y <= r.bottom; pt.y++ )
    for(pt.x=r.left; pt.x <= r.right; pt.x++ )
		{	nisol=0;
			for( i=0; i<8; i++ )
				for( j=0; j<8; j++ )
				{	pix_status=pix_test( (pt.x<<3)+i, (pt.y<<3)+j );
					if( !(pix_status & 0x0001) )
					{	if( (pix_status & 0x0022)==0x0022 )
							nisol++;
/*						if( (pix_status & 0x0044)==0x0044 )
							nisol++;
*/						if( (pix_status & 0x0088)==0x0088 )
							nisol++;
/*						if( (pix_status & 0x0110)==0x0110 )
							nisol++;
*/					}
				}
			Tdst[pt.x+(pt.y<<5)] = (unsigned char)min( 15*nisol, 255 );
		}
}

// Carte de compacit
// source: source
// destin: Tdst
void TTexture::Compacite( void )
{	int x, y, a;

	for( x=0; x<32; x++ )
		for( y=0; y<32; y++ )
		{	a=RemplisTexel( x, y );
			Tdst[x+(y<<5)] = (unsigned char)min( 40*a, 255 );
		}
}

int TTexture::RemplisTexel( int x, int y )
{	int i, j;
	unsigned char nremplis, npix;
	unsigned char buffer[10*10];

	for( i=0; i<10; i++ )
		for( j=0; j<10; j++ )
			if( (i==0) || (j==0) || (i==9) || (j==9) )
				buffer[i+j*10] = 128;
			else
				buffer[i+j*10] = source[(x<<3)+i+(((y<<3)+j)<<8)]>CSEUIL?255:0;

	npix=0;
	nremplis=0;

	for( i=1; i<9; i++ )
		for( j=1; j<9; j++ )
		{	if( buffer[ i+j*10 ]!=128 )
			{	npix+=remplis( buffer, i, j, buffer[ i+j*10 ] );
				nremplis++;
			}
		}

	return(nremplis);
}

unsigned char TTexture::remplis( unsigned char *buffer, int i, int j, unsigned char color )
{	unsigned char npix;

	buffer[ i+j*10 ]=128;
	npix=1;

	if( buffer[ i+(j-1)*10 ]==color )
		npix+=remplis( buffer, i, j-1, color );
	if( buffer[ i+1+j*10 ]==color )
		npix+=remplis( buffer, i+1, j, color );
	if( buffer[ i+(j+1)*10 ]==color )
		npix+=remplis( buffer, i, j+1, color );
	if( buffer[ i-1+j*10 ]==color )
		npix+=remplis( buffer, i-1, j, color );

	return(npix);
}

//******* Teste si un pixel et son 8-voisinage appartiennent au contour
//******* ( gestion des effets de bord )
//
//	appel: 	x,y = coordonnes du pixel
// retour =	0x 0000 0MF8 7654 3210 ( bit  bit )
//
// Signification des bits:
//			M: Mutliple, le pixel + plusieurs voisins
//			F: Failed, le pixel n'appartient pas au contour
//			876543210: carte du contour dans la rgion du pixel:
//								8  1  2
//								7  0  3
//								6  5  4
//
int TTexture::pix_test( int x, int y )
{	unsigned char *ptr_src, pix_attr, voisins;
	unsigned int retour;

	pix_attr=0xff;
	ptr_src = pContour + ( x + (y<<8) );
	voisins=0;

	if( *ptr_src )
		retour=0x0001;
	else
		retour=0x0200;

	if( x == 0 )
		pix_attr &= 0xf7;
	if( x == 255 )
		pix_attr &= 0xfd;
	if( y == 0 )
		pix_attr &= 0xfe;
	if( y == 255 )
		pix_attr &= 0xfb;

	if( pix_attr & 0x01 )
	{	if( *(ptr_src-256) )
		{	voisins++;
			retour |= 0x0002;
		}
		if( (pix_attr & 0x08) && (*(ptr_src-257)) )
		{	voisins++;
			retour |= 0x0100;
		}
		if( (pix_attr & 0x02) && (*(ptr_src-255)) )
		{	voisins++;
			retour |= 0x0004;
		}
	}
	if( (pix_attr & 0x02) && (*(ptr_src+1)) )
	{	voisins++;
		retour |= 0x0008;
	}
	if( pix_attr & 0x04 )
	{	if( *(ptr_src+256) )
		{	voisins++;
			retour |= 0x0020;
		}
		if( (pix_attr & 0x08) && (*(ptr_src+255)) )
		{	voisins++;
			retour |= 0x0040;
		}
		if( (pix_attr & 0x02) && (*(ptr_src+257)) )
		{	voisins++;
			retour |= 0x0010;
		}
	}
	if( (pix_attr & 0x08) && (*(ptr_src-1)) )
	{	voisins++;
		retour |= 0x0080;
	}
	if( voisins>1 )
		retour |= 0x0400;

	return( retour );
}

// Routine de remplissage non rcursive
// ( Probleme de pile sinon )
TGeo TTexture::TRemplis_CGravite( unsigned char i, unsigned char j )
{	TGeo a;
	int x, yoff, stack[40*2];
	unsigned char spin, spout;
	unsigned char u_done, l_done;

	spout=0;	       	// Index de la premiere racine ( buffer circulaire )
	spin=1;				// Index de la racine a venir  (    '        '     )
	stack[0]=(int)i;
	stack[1]=j<<5;

	a.m00=0;
	a.m10=0;
	a.m01=0;

	while( spin!=spout )
	{	u_done=1;
		l_done=1;
		x=stack[ spout<<1 ];
		yoff=stack[(spout<<1)+1];
		spout=(spout+1)%40;
		while( x )
		{	if( TI4[x-1+yoff]==255 )
				x--;
			else
				break;
		}
		while( (x<32) && (TI4[x+yoff]==255) )
		{	TI4[x+yoff]=1;
			a.m00++;
			a.m10+=x;
			a.m01+=(yoff>>5);
			if( yoff )
				if( TI4[x+yoff-32]==255 )
				{  if( u_done )
					{	stack[(spin<<1)]=x;
						stack[(spin<<1)+1]=yoff-32;
						spin=(spin+1)%40;
						u_done=0;
					}
				}else
				{	u_done=1;
				}
			if( yoff!=992 )				//31*32=992
				if( TI4[x+yoff+32]==255 )
				{  if( l_done )
					{	stack[(spin<<1)]=x;
						stack[(spin<<1)+1]=yoff+32;
						spin=(spin+1)%40;
						l_done=0;
					}
				}else
				{	l_done=1;
				}
			x++;
		}
	}
	return(a);
}

TGeo2 TTexture::TRemplis_Inertie_Etiquette( unsigned char i, unsigned char j, unsigned char etiquette )
{	TGeo2 a;
	int x, y, yoff, stack[40*2];
	unsigned char spin, spout;
	unsigned char u_done, l_done;

	spout=0;	       	// Index de la premiere racine ( buffer circulaire )
	spin=1;				// Index de la racine a venir  (    '        '     )
	stack[0]=(int)i;
	stack[1]=j<<5;

	a.mu11=0;
	a.mu20=0;
	a.mu02=0;

	while( spin!=spout )
	{	u_done=1;
		l_done=1;
		x=stack[ spout<<1 ];
		yoff=stack[(spout<<1)+1];
		spout=(spout+1)%40;
		while( x )
		{	if( TI4[x-1+yoff]==1 )
				x--;
			else
				break;
		}
		while( (x<32) && (TI4[x+yoff]==1) )
		{	TI4[x+yoff]=etiquette;
			y=yoff>>5;
			a.mu11+=((float)x-xcg)*((float)y-ycg);
			a.mu20+=((float)x-xcg)*((float)x-xcg);
			a.mu02+=((float)y-ycg)*((float)y-ycg);
			if( yoff )
				if( TI4[x+yoff-32]==1 )
				{  if( u_done )
					{	stack[(spin<<1)]=x;
						stack[(spin<<1)+1]=yoff-32;
						spin=(spin+1)%40;
						u_done=0;
					}
				}else
				{	u_done=1;
				}
			if( yoff!=992 )				//31*32=992
				if( TI4[x+yoff+32]==1 )
				{  if( l_done )
					{	stack[(spin<<1)]=x;
						stack[(spin<<1)+1]=yoff+32;
						spin=(spin+1)%40;
						l_done=0;
					}
				}else
				{	l_done=1;
				}
			x++;
		}
	}
	return(a);
}

//
// Erosion et  dilatation:
//
// type 1: 8-voisinage
// type 2: 4-voisinage
//
void TTexture::TErosion( int seuil, char type )
{	int x,y;
	unsigned char p0,p1,p2,p3,p4,p5,p6,p7,p8;  /* pixels */
	unsigned char *pointim,*pointim1;

	for(y=0;y<30;y++)
	{	 for(x=0;x<30;x++)
		{	pointim=Tsrc+((y<<5)+x);
			p0=*pointim++;
			p1=*pointim++;
			p2=*pointim;
			pointim+=30;
			p3=*pointim++;
			p4=*pointim++;
			p5=*pointim;
			pointim+=30;
			p6=*pointim++;
			p7=*pointim++;
			p8=*pointim;
			pointim1=Tdst+(((y+1)<<5)+x+1);
			if( type == 1 )
			{	if((p0<seuil)||(p1<seuil)||(p2<seuil)||(p3<seuil)||(p5<seuil)
				 ||(p6<seuil)||(p7<seuil)||(p8<seuil))
				{	*pointim1=0;
				}else
				{	*pointim1=p4;
				}
			}else
			{	if((p1<seuil)||(p3<seuil)||(p5<seuil)||(p7<seuil))
					*pointim1=0;
				else
					*pointim1=p4;
			}
		}
	}
}

void TTexture::TDilatation( int seuil, char type )
{	int x,y;
	unsigned char p0,p1,p2,p3,p4,p5,p6,p7,p8;  /* pixels */
	unsigned char *pointim,*pointim1;

	for(y=0;y<30;y++)
	{  for(x=0;x<30;x++)
		{	pointim=Tsrc+((y<<5)+x);
			p0=*pointim++;
			p1=*pointim++;
			p2=*pointim;
			pointim+=30;
			p3=*pointim++;
			p4=*pointim++;
			p5=*pointim;
			pointim+=30;
			p6=*pointim++;
			p7=*pointim++;
			p8=*pointim;
			pointim1=Tdst+(((y+1)<<5)+x+1);
			if( type == 1 )
			{	if((p0>=seuil)||(p1>=seuil)||(p2>=seuil)||(p3>=seuil)
				 ||(p5>=seuil)||(p6>=seuil)||(p7>=seuil)||(p8>=seuil))
				{	*pointim1=255;
				}else
				{	*pointim1=p4;
				}
			}else
			{	if((p1>=seuil)||(p3>=seuil)||(p5>=seuil)||(p7>=seuil))
				{	*pointim1=255;
				}else
				{	*pointim1=p4;
				}
			}
		}
	}
}

// Affiche une carte de texture 32*32
// dans une image 256*256
void TTexture::ShowTI()
{  int x, y, i, j;

	for( x=0; x<32; x++ )
		for( y=0; y<32; y++)
			for( i=0; i<8; i++ )
				for( j=0; j<8; j++ )
					Tdst[ (x<<3)+i + (((y<<3)+j)<<8) ] = Tsrc[x+(y<<5)];
}

/*------------------------------------------------------------------------*/
/*                   Nouvelle classe TParametres 	                       */
/*--Systme---------------------------------------------------------------*/

DEFINE_RESPONSE_TABLE1(TParametres, TDialog)

  EV_CHILD_NOTIFY_ALL_CODES(IDC_HSCROLL1, EvA),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_HSCROLL2, EvB),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_HSCROLL3, EvC),
  EV_CHILD_NOTIFY_ALL_CODES(IDC_HSCROLL4, EvD),
  EV_COMMAND(IDC_PUSHBUTTON1, EvAppliquer),
  EV_COMMAND(IDC_PUSHBUTTON3, EvClose),

END_RESPONSE_TABLE;

TParametres::TParametres(TWindow* parent)
 : TDialog(parent, "Parametres")
{
	ReSeuil1=new TScrollBar(this, IDC_HSCROLL1);
	ReSeuil2=new TScrollBar(this, IDC_HSCROLL2);
	ReSeuil3=new TScrollBar(this, IDC_HSCROLL3);
	ReSeuil4=new TScrollBar(this, IDC_HSCROLL4);
	ReCap1=new TStatic(this, ID_AGSEUIL1);
	ReCap2=new TStatic(this, ID_AGSEUIL2);
	ReCap3=new TStatic(this, ID_AGSEUIL3);
	ReCap4=new TStatic(this, ID_AGSEUIL4);
//	pParametres=this;
}

void TParametres::SetupWindow()
{	char string[12];

	TDialog::SetupWindow();
	ReSeuil1->SetRange( 1, 256 );
	ReSeuil1->SetPosition( seuil1 );
	ReSeuil2->SetRange( 1, 256 );
	ReSeuil2->SetPosition( seuil2 );
	ReSeuil3->SetRange( 1, 256 );
	ReSeuil3->SetPosition( seuil3 );
	ReSeuil4->SetRange( 1, 256 );
	ReSeuil4->SetPosition( seuilzc );
	vReSeuil1=seuil1;
	vReSeuil2=seuil2;
	vReSeuil3=seuil3;
	vReSeuilzc=seuilzc;
	sprintf(string, "%d", vReSeuil1);
	ReCap1->SetText(string);
	sprintf(string, "%d", vReSeuil2);
	ReCap2->SetText(string);
	sprintf(string, "%d", vReSeuil3);
	ReCap3->SetText(string);
	sprintf(string, "%d", vReSeuilzc);
	ReCap4->SetText(string);
	EvAppliquer();
}

void TParametres::EvA(UINT)
{	char string[12];

	vReSeuil1=ReSeuil1->GetPosition();
	sprintf(string, "%d", vReSeuil1);
	ReCap1->SetText(string);
}

void TParametres::EvB(UINT)
{	char string[12];

	vReSeuil2=ReSeuil2->GetPosition();
	sprintf(string, "%d", vReSeuil2);
	ReCap2->SetText(string);
}

void TParametres::EvC(UINT)
{	char string[12];

	vReSeuil3=ReSeuil3->GetPosition();
	sprintf(string, "%d", vReSeuil3);
	ReCap3->SetText(string);
}
void TParametres::EvD(UINT)
{	char string[12];

	vReSeuilzc=ReSeuil4->GetPosition();
	sprintf(string, "%d", vReSeuilzc);
	ReCap4->SetText(string);
}

void TParametres::EvAppliquer( void )
{	seuilzc=vReSeuilzc;
	seuil1=vReSeuil1;
	seuil2=vReSeuil2;
	seuil3=vReSeuil3;
	pTx->pContour=PlanSuiv( destin );
	CalculeZCLaplacien( source, pTx->pContour, LAPLACIEN_CHAR_4, seuilzc );
	pTx->SetTdst(1);
	pTx->Continuite();			// TI1=Carte de continuit
	pTx->SetTdst(2);
	pTx->Densite();				// TI2=Carte de densit
	pTx->SetTdst(3);
	pTx->Proximite();				// TI3=Carte de Proximite
	pTx->Vraisemblance();
	pTx->SetTsrc(4);
	pTx->Tdst=destin;
	pTx->ShowTI();
	Fenetre->Visim(this,1,destin);
}

/*void TParametres::EvClose( void )
{	TParametres::~TParametres();
} */

/*TParametres::~TParametres()
{	pParametres=NULL;
} */
/*------------------------------------------------------------------------*/
/*                   Nouvelle classe TOptions		                       */
/*--Systme---------------------------------------------------------------*/

DEFINE_RESPONSE_TABLE1( TOptions, TDialog)

  EV_COMMAND(IDC_RADIOBUTTON4, EvRB1),
  EV_COMMAND(IDC_RADIOBUTTON5, EvRB2),
  EV_COMMAND(IDC_RADIOBUTTON6, EvRB3),
  EV_COMMAND(IDC_RADIOBUTTON7, EvRB4),
  EV_COMMAND(IDC_RADIOBUTTON8, EvRB5),
  EV_COMMAND(IDC_RADIOBUTTON9, EvRB6),
  EV_COMMAND(IDC_RADIOBUTTON10, EvRB7),
  EV_COMMAND(IDC_RADIOBUTTON11, EvRB8),
  EV_COMMAND(IDC_RADIOBUTTON12, EvRB9),
  EV_COMMAND(IDC_RADIOBUTTON13, EvRB10),
  EV_COMMAND(IDC_RADIOBUTTON14, EvRB11),
  EV_COMMAND(IDC_RADIOBUTTON15, EvRB12),
  EV_COMMAND(IDC_RADIOBUTTON16, EvRB13),
  EV_COMMAND(IDC_RADIOBUTTON17, EvRB14),
  EV_COMMAND(IDC_RADIOBUTTON18, EvRB15),
  EV_COMMAND(IDC_PUSHBUTTON6, EvClose),
  EV_CHILD_NOTIFY(IDC_COMBOBOX2, CBN_SELCHANGE, EvCombo),

END_RESPONSE_TABLE;

TOptions::TOptions(TWindow* parent)
 : TDialog(parent, "Options")
{	int i;

	for( i=0; i<15; i++ )
		pRB[i]=new TRadioButton( this, IDC_RADIOBUTTON4+i );

	ReCombo=new TComboBox(this, IDC_COMBOBOX2);

//	pOptions=this;
}

void TOptions::SetupWindow()
{	int i;

	TDialog::SetupWindow();

	for( i=0; i<5; i++ )
		pRB[3*i+Visu[i]]->Check();

	ReCombo->AddString("Noir");
	ReCombo->AddString("Source");
	ReCombo->AddString("Blanc");
	ReCombo->SetSelIndex(FondVisu);

}

void TOptions::EvCombo()
{	FondVisu=ReCombo->GetSelIndex();
}

void TOptions::EvRB1()
{	Visu[0]=0;
}
void TOptions::EvRB2()
{	Visu[0]=1;
}
void TOptions::EvRB3()
{	Visu[0]=2;
}
void TOptions::EvRB4()
{	Visu[1]=0;
}
void TOptions::EvRB5()
{	Visu[1]=1;
}
void TOptions::EvRB6()
{	Visu[1]=2;
}
void TOptions::EvRB7()
{	Visu[2]=0;
}
void TOptions::EvRB8()
{	Visu[2]=1;
}
void TOptions::EvRB9()
{	Visu[2]=2;
}
void TOptions::EvRB10()
{	Visu[3]=0;
}
void TOptions::EvRB11()
{	Visu[3]=1;
}
void TOptions::EvRB12()
{	Visu[3]=2;
}
void TOptions::EvRB13()
{	Visu[4]=0;
}
void TOptions::EvRB14()
{	Visu[4]=1;
}
void TOptions::EvRB15()
{	Visu[4]=2;
}

void TOptions::EvClose()
{	TOptions::~TOptions();
}

/*TOptions::~TOptions()
{	pOptions=NULL;
} */

/*-------------------------------------------*/
//Visualisation: Contour en texels de 8*8
void VisuTextureMap(unsigned char uVisuMode,
    unsigned char puTextureMap[32*32],TRect r
    )
  {

       if( uVisuMode )
		{
                unsigned char *puDest;
                	if( uVisuMode==1 )
			{	puDest=source;
			}else
			{	puDest=destin;
			}
			for(unsigned int i=r.left; i<=r.right; i++ )
				for(unsigned int j=r.top; j<r.bottom; j++)
					for(unsigned int k=0; k<8; k++ )
						for(unsigned int l=0; l<8; l++ )
						{	unsigned int wOffset=(i<<3)+k + (((j<<3)+l)<<8);
							puDest[(unsigned int)wOffset]=puTextureMap[i+(j<<5)]?~puDest[(unsigned int)wOffset]:puDest[(unsigned int)wOffset];
						}
		}
  }

unsigned int TTexture::CmVraissemblance(unsigned char uVisuMode, TRect r)
  {
  SetTdst(1);
  Continuite(r);			// TI1=Carte de continuit
  SetTdst(2);
  Densite(r);				// TI2=Carte de densit
  SetTdst(3);
  Proximite(r);			// TI3=Carte de Proximite
  unsigned int w=Vraisemblance(r);
  VisuTextureMap(uVisuMode, TI4,r);
  return w;
  }



