#error Obsolete: use anallec.*
/*******************|*******************************************/
/*                  L T A T O U     . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonctions de travail de Tatou.C.        */
/*                                                             */
/*                                                             */
/* Fichier prototype LTATOU  .H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : hivers 1994/1995                        */
/***************************************************************/
#ifndef WANALLEC_H
#define WANALLEC_H

#include "base.h"
#include "wgeometr.h"
#include "symbole.h"
/*-------------------------------------------------------------*/
/*			   constantes                                         */
/*-------------------------------------------------------------*/
#define QUAD_PERSPECTIVE_REGULIERE          0
#define QUAD_PERSPECTIVE_HYPERBOLIQUE_IMAGE 1
#define PERSPECTIVE_HYPERBOLIQUE_SYMBOLE    2
#define GRILLE_2COTES_CONNUS                3


/*-------------------------------------------------------------*/
/*		    nouveaux types  exporter                  */
/*-------------------------------------------------------------*/
typedef struct ECHANTILLONNEUR
  {
  TVecteur position;
  float rayon;
  float ndg;
  float surf_cumulee;
  } echantillonneur;
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
extern echantillonneur echantillonneurnul;
/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                    */
/*-------------------------------------------------------------*/
BOOL LectureSymboleConnuPerspHF(TQuadrilatere ABCD, TDataMatrix *pSymbole,
                               unsigned char *puSource,
                               unsigned char *puCible,
                               unsigned int wFrequenceForcee=0,
                               unsigned char uPerpType=PERSPECTIVE_HYPERBOLIQUE_SYMBOLE);
echantillonneur ResetEchantillonneur();
BOOL TransformationRaideVersMatriceCarree(TQuadrilatere ABCD,
                               unsigned char *puSource, // image source 256*256
                               unsigned char *puCible, // matrice cible f*f
                               unsigned int wF);

#endif // WANALLEC_H
