/*******************|*******************************************/
/*                    P I A D I V   . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonctions d'affichage sur visu          */
/*                                                             */
/*                                                             */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : hivers 1995/1996                        */
/***************************************************************/
#if !defined PIADIV_H
#define PIADIV_H

#include "wgeometr.h"
/*-------------------------------------------------------------*/
/*			   constantes                                         */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*		    nouveaux types  exporter                  */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
extern TBipoint cBipFenImage;
/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                    */
/*-------------------------------------------------------------*/
BOOL DessineLigne(unsigned char *puSource, TBipoint AB, unsigned char *puCible,
    unsigned int *pwLongueur=NULL);
BOOL EcritLigne(TBipoint AB, unsigned char *puMemo, unsigned char *puCible,
    unsigned int *pwLongueur=NULL);
BOOL MemoLigne(unsigned char *puImage, TBipoint AB, unsigned char *puMemo,
    unsigned int *pwLongueur=NULL);
BOOL DessineDroite(unsigned char *puSource, TDroite D, unsigned char *puCible);
void DessineRetic(unsigned char *puSource,TCoordonnee pt,
    unsigned char *puCible, unsigned int wRayon=2); // wRayon peut-tre 0, 1 ou 2.
void EcritRetic(unsigned char *image,unsigned char bufretic[9],TCoordonnee ptRetic);
void MemoRetic(unsigned char *image,unsigned char bufretic[9],TCoordonnee ptRetic);
BOOL DessineQuadrilatere(unsigned char *puSource, TQuadrilatere ABCD,
    unsigned char *puCible, TRect *prInvalidated=NULL);
void DessineFleche(unsigned char *puSource, TBipoint AB,
    unsigned char *puCible);
BOOL AffichageDeLignesGTTSI(unsigned char long_lim,
                           unsigned char *puSource,
                           unsigned char *puCible,
                           ligne_AB *table_lignes_user,
                           unsigned int wNbl_user);
BOOL AcquisitionQuad (TQuadrilatere *pq, TCoordonnee NouvPoint,
                     unsigned char *puSource,
                     TRect *prInvalidated);
BOOL AcquisitionLigne (TLigne *plgn, TCoordonnee NouvPoint);
BOOL AcquisitionPolygone(TCoordonnee *aptPolygone, unsigned char uNbPoints,
    TCoordonnee NouvPoint, unsigned char *puSource, TRect *prInvalidated=NULL);
BOOL DessinePolygone(unsigned char *puSource, TCoordonnee *aptPolygone,
    unsigned char uNbPoints,  unsigned char *puCible, TRect *prInvalidated);
void UseRotat(TReperage repTransfo, unsigned char *puVictim);
void UseRotat(TReperage repTransfo, unsigned char *puSource, unsigned char *puTarget);

void PavageParRectangle(unsigned char *puSource, unsigned char *puCible, TRect rZone, TRect rRef);

/*-------------------------------------------------------------*/
#endif // PIADIV_H

