/**********************************************************************/
/*                       W B I N C O N V . H		                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 22/01/1996 21/05/96                            */
/*    Dernire modif.: 02/01/1998                               		 */
/**********************************************************************/
#if !defined(WBINCONV_H)
#define WBINCONV_H

#include <io.h>
#include "wlsytbin.h"
												 // Pointeurs sur les fentres
extern TFramePrint* TAffseqPtr;      	// Fentre sequence

//----------------------------------------------------------------------------
//						Programme TSequence
//----------------------------------------------------------------------------

class TSequence : public TFrameWindow {
  public:

	TSequence(TWindow* parent,char titre[]);
	~TSequence();

	 virtual int EvCommun(char c);
	 virtual void Reconnais();
	 virtual void Aff_Recon();
	 virtual void SetupWindow();
	 virtual void Affim();
	 virtual void Goto(long numim);
	 virtual void Goto_Anim(long numim);

	 long numimag;
	 int stop;
	 int pas;
	 int modboucle;

  protected:

	 void EvTimer(UINT timerId);
	 void Paint(TDC& dc, BOOL, TRect&);
	 void EvLButtonDown(UINT, TPoint&);
	 void EvLButtonUp(UINT, TPoint&);
	 void EvMouseMove(UINT, TPoint&);
	 void EvMButtonDown(UINT, TPoint&);
	 void EvA(WPARAM id);
	 void EvB(WPARAM id);
	 void EvC(WPARAM id);
	 void EvD(WPARAM id);
	 void EvE(WPARAM id);
	 void EvF(WPARAM id);
	 void EvG(WPARAM id);
	 void EvH(WPARAM id);
	 void EvI(WPARAM id);
	 void EvJ(WPARAM id);
	 void Calnum(char file[],char nomgen[],long *num);
	 void Edit();
	 void Calimsuiv();
	 void Affcarim();
    void Arret();
	//BOOL modefich;
	long t0,t1,n0,n1;
	long nbptmin;
	TStatic *Aseq,*Bseq,*Cseq,*Dseq,*Eseq,*Fseq,*Gseq,*Hseq;
	TEdit *Hseq1;
	TGauge *SolidGauge;
	int flagsequence;                  // Pour souris
	TOpenSaveDialog::TData FileData2;
	TOpenSaveDialog::TData FileData5; // Pour dition
	int flagrec;
	int modanim;                  // mode pour animation  0 normal 1 auto
	char nomgen2[12];
	char driveseq2[MAXDRIVE];
	char dirseq2[MAXDIR];
	char fileseq2[MAXFILE];
	char extseq2[MAXEXT];

  DECLARE_RESPONSE_TABLE(TSequence);
};

extern TSequence* TSequencePtr;		  	// Fentre sequence

//----------------------------------------------------------------------------
//						Programme TAffseq
//----------------------------------------------------------------------------

class TAffseq : public TFramePrint {
  public:

	 TAffseq(TWindow* parent,char titre[]);
	~TAffseq();
  protected:
	 void Paint(TDC& dc, BOOL, TRect&);
	 void EvSize(UINT sizeType, TSize& size);
	 void Aff_datim(TDC& dc,struct ftime *tc);
	 void Aff_identseq(TDC& dc,identseq *id);

  DECLARE_RESPONSE_TABLE(TAffseq);
};

//----------------------------------------------------------------------------
#endif  // WBINCONV_H
