/**********************************************************************/
/*                       W C A R C O N V . H	                         */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 13/11/1995  07/02/1996                         */
/*    Dernire modif.: 10/10/1997                                     */
/**********************************************************************/
#if !defined(WCARCONV_H)
#define WCARCONV_H

//----------------------------------------------------------------------------
//						Programme TSeuilFFT
//----------------------------------------------------------------------------

class TSeuilFFT : public TSeuil{
  public:

	TSeuilFFT(TWindow* parent,char titre[],int smin,int smax,int sinit);

	~TSeuilFFT();
	 virtual void EvCommun(int);

	};
//----------------------------------------------------------------------------
//						Programme TSeuilPoly
//----------------------------------------------------------------------------

class TSeuilPoly : public TSeuil{
  public:

	TSeuilPoly(TWindow* parent,char titre[],int smin,int smax,int sinit);

	~TSeuilPoly();
	 virtual void EvCommun(int);

	};

//----------------------------------------------------------------------------
//						Programme TConvcarobj
//----------------------------------------------------------------------------

 class TConvcarobj : public TChoixMenu {
  public:

	 TConvcarobj(TWindow* parent);
	~TConvcarobj();
	 void EvCommun(char c);
};

extern TConvcarobj* TConvcarobjPtr;      // Fentre carobj

//----------------------------------------------------------------------------
//						Programme TConvcarac
//----------------------------------------------------------------------------

 class TConvcarac : public TChoixMenu {
  public:

	 TConvcarac(TWindow* parent);
	~TConvcarac();
	 void ShowCarvis(TWindow* parent,int modecar);
	 void EvCommun(char c);
};

extern TConvcarac* TConvcaracPtr;     	 // Fentre carac

//----------------------------------------------------------------------------
//						Programme TCarvis
//----------------------------------------------------------------------------

class TCarvis : public TFramePrint {
  public:

	 TCarvis(TWindow* parent,char far titre[],int mode);
	~TCarvis();
	int modecar;
  protected:
	 void Paint(TDC& dc, BOOL, TRect&);
	 void EvSize(UINT sizeType, TSize& size);
  	 void EvMouseMove(UINT, TPoint&);

  DECLARE_RESPONSE_TABLE(TCarvis);
};

extern TCarvis* TCarvisPtr;          // Fentre visu carac

//----------------------------------------------------------------------------
#endif  //WCARCONV_H
