/**********************************************************************/
/*                       W C O M C O N V . H	                         */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC			                  			      	 */
/*    Dvelopp le   : 13/11/1995 07/02/1996                          */
/*    Dernire modif.: 03/10/1997                                     */
/**********************************************************************/
#if !defined(WCOMCONV_H)
#define WCOMCONV_H

												 // Pointeurs sur les fentres
extern TChoixMenu* TChoixcompPtr;     	 // Fentre comp

//----------------------------------------------------------------------------
//						Programme TCompvis
//----------------------------------------------------------------------------

class TCompvis : public TFramePrint {
  public:

	 TCompvis(TWindow* parent,char far titre[],int mode,BOOL affichinit);
	 ~TCompvis();
	 int modecomp;

  protected:
	 void Paint(TDC& dc, BOOL, TRect&);
	 void EvSize(UINT sizeType, TSize& size);
	 void EvMouseMove(UINT, TPoint&);
	 float im[8][8];
	 long imint[8][8];
	 BOOL fConsistanceComp;

  DECLARE_RESPONSE_TABLE(TCompvis);
};

extern TCompvis* TCompvisPtr;         // Fentre visu compression

//----------------------------------------------------------------------------
//						Programme TConvcomp
//----------------------------------------------------------------------------

 class TConvcomp : public TChoixMenu {
  public:

	 TConvcomp(TWindow* parent);
	~TConvcomp();
	 virtual void NouveauPoint();
	 void EvCommun(char c);
};
extern TConvcomp* TConvcompPtr;    	 // Fentre choix comp

//----------------------------------------------------------------------------
//						Programme TChoixcomp
//----------------------------------------------------------------------------

 class TChoixcomp : public TChoixMenu {
  public:

	 TChoixcomp(TWindow* parent);
	~TChoixcomp();
	 void EvCommun(char c);
};

//----------------------------------------------------------------------------
#endif  //WCOMCONV_H
