/*----------------------------------------------*/
/*						*/
/*		Procdures du programme         */
/*                      WLFFT.C                  */
/*						*/
/*----------------------------------------------*/
#if !defined(WLFFT_H)
#define WLFFT_H

typedef struct{ float re,im ;} scomplex ;
typedef struct{ int re,im ;} complex_entier ;
typedef struct{ double re,im ;} complex ;

extern int far fft(int N, scomplex *in, scomplex *out);
extern int far ifft(int N, scomplex *in, scomplex *out);

extern float far re_m(scomplex x);
extern float far im_m(scomplex x);
extern scomplex far adf_m( scomplex x,    	     /* addition complexe */
		scomplex y );
extern scomplex far sousf_m( scomplex x,             /* soustraction complexe */
		  scomplex y );
extern scomplex far multcf_m( scomplex x,           /* multiplication complexe */
		   scomplex y );
extern scomplex far divcf_m( scomplex x,            /* division complexe */
		  scomplex y );
extern scomplex far mulf_m( scomplex x,         /* multiplication complexe par reel */
		  float a );
extern scomplex far divrf_m(scomplex x,float a);    /* division complexe par reel */
extern float far modf_m(scomplex x);                        /* Module d'un complexe */
extern float far modcf_m(scomplex x);               /* module carre d'un complexe */
extern scomplex far conjf_m(scomplex x);            /* complexe conjugue */

//----------------------------------------------------------------------------
#endif  //WLFFT_H
