//----------------------------------------------------------------------------
//											WLSYTBIN.H
// Dernire modif :09/01/97
//----------------------------------------------------------------------------
#if !defined(WLSYTBIN_H)
#define WLSYTBIN_H

typedef struct {
		char ident[4];    // identificateur
		long nbtotimage;  // nombre total d'images
		int xmin,xmax,ymin,ymax,seuil; // param fentre et seuil
		int modevit,parite;            // vitesse et parit
		char reserve[256-(4*sizeof(char)+sizeof(long)+7*sizeof(int))];
		} identseq;

typedef struct
		{
		long nbtot,totcod,nbptmax;
		float histseq[512],codmoyen,vitesse;
		} caracseq;

typedef struct
		{
		int nbcod;
		long nbpt;
		} carimagseq;

//----------------------------------------------------------------------------

extern FILE *in;                      // Fichier squence
//extern struct ftime ft,tc;            // date & heure
extern identseq id;                   // Identification squence
extern caracseq carseq;                 // Car. squence
extern carimagseq carimseq;           // Car. image squence
extern int ident;                     // ident. seq

//----------------------------------------------------------------------------

extern int far Animabin(FILE *in,long numero,carimagseq *carimseq);
extern int far Animabin1(FILE *in,long numero,carimagseq *carimseq,
						unsigned char far bufdest[]);
extern int far Animabin2(FILE *in,long numero,carimagseq *carimseq,
						unsigned char far bufdest[]);
extern int far Carseqbin(FILE *in,identseq *id,caracseq *carseq);
extern void far Cal_datim(struct ftime *ft,struct ftime *tc,long nbimage,
						float vitesse,long nbtot);
extern int far Lect_identseq(identseq *id,FILE *in);
extern float far Cal_vitesse(identseq *id);
extern long far Recimsuiv(FILE *in,long nbptmin);
extern long far Recimprec(FILE *in,long nbptmin);

//----------------------------------------------------------------------------
#endif  //WLSYTBIN_H
