/**********************************************************************/
/*                       W T P I M A G   . H                          */
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions.                        */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC 			                  			      	 */
/*    Dvelopp le   : 28/03/96                                       */
/*    Dernire modif.: 15/10/97                                       */
/**********************************************************************/
#if !defined(WTPIMAG_H)
#define WTPIMAG_H

class TFenPerso : public TFen
  {
  void SetupWindow();
public:
  TFenPerso(TWindow *Parent=0);
  protected:
  void CmHough();
  void CmComp();
  void CmColor();
  void CmSegcoul();
  void CmSegredui();
  DECLARE_RESPONSE_TABLE(TFenPerso);
  };

//**********************************************************************

class TCadPerso : public TCad
  {
public :
  TCadPerso(TWindow *Parent, char far *Title, TWindow *Client,
				BOOL trackMenuSelection=FALSE);
	void EvInitMenuPopup(HMENU hPopupMenu,UINT index,BOOL sysMenu);
  DECLARE_RESPONSE_TABLE(TCadPerso);
  };

//**********************************************************************

class TAppPerso : public TApp
  {
public:
  TAppPerso();
  void InitMainWindow();
  };

//**********************************************************************
// Variables externes
//**********************************************************************

extern TFenPerso *fenetre;
extern TAppPerso *application;
extern TCadPerso *cadre;

//**********************************************************************
#endif  //WTPIMAG_H
