/*******************|*******************************************/
/*                  B A S E         . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Gnralits                             */
/*                                                             */
/* Fichier prototype BASE    .H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : t 1994/1995                           */
/***************************************************************/
#ifndef BASE_H
#define BASE_H
/*-------------------------------------------------------------*/
/*			   constantes                          */
/*-------------------------------------------------------------*/
#define VRAI 1
#define FAUX 0
#define TRUE 1
#define FALSE 0
#define MARCHE 1
#define ARRET 0
#define ON 1
#define OFF 0
#define USUALMAXLENSTRING 256
#define ECHEC 0
#define FAILURE 0
#define SUCCES 1
#define SUCCESS 1
#define OBLIQUE 0
#define DROIT 1
/* DROITE et GAUCHE compatible avec la fonction char
TVecteur::DroiteOuGaucheDroite(TVecteur A, TVecteur B) */
#define DROITE 1
#define GAUCHE -1

#define SIZE_OF_PICTURES 256
#define MAX_DIAGONAL     363 // 256*sqrt(2)
#define IMG256           (SIZE_OF_PICTURES==256)

#define SwitchManyCheckers 1 // Autorise ou non des tests en gnral superflus A installer en cas d'incertitude sur des bugs bizarres.
#define BIT unsigned char

//
// Plages pour les valeurs des exceptions
#define EXCEPT_CONTOUR 100 // 100-199
//
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
extern char szTestExt[10];
/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                    */
/*-------------------------------------------------------------*/
inline void SetBitWise(unsigned int *pw, unsigned int wMask, int f);

/* Set or unset the bits contained in the mask to TRUE or UNTRUE
  according to the flag bool falue of f. */

inline void SetBitWise(unsigned int *pw, unsigned int wMask, int f)
  {
  if (f)
    *pw |= wMask;
  else
    *pw &= ~wMask;
  }
#endif // WBASE_H
