#error Obsolete. Use dnitrate
/////////////////////////////////////////////////////////////////
//                    N I T R A T E   . C P P
/////////////////////////////////////////////////////////////////
//    Fonction       :
/////////////////////////////////////////////////////////////////
//    Auteur         :  Baptiste Marcel (marce@len7.enseeiht.fr)
//        Written in Toulouse, France
//        All rights copyrighted
//    Cr le        : fin septembre 1996
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//                   Headers
/////////////////////////////////////////////////////////////////
#ifndef NITBASIS_H
#define NITBASIS_H

#if _Windows
#include <osl/point.h>
#else

#include "Dpoint.h"
  #endif
/*
#include <classlib\listimp.h>
#include <classlib\date.h>
#include <io.h>
#include <owl\decframe.h>
#include <owl\inputdia.h>
#include <stdlib.h>
#include <string.h>

#include "wsysutil.h"

#include "base.h"
#include "sysctr.h"
#include "wedtderv.h"
#include "wlstutil.h"
#include "wsystool.h"

#include "nitrate.rc"
*/

#include "dnitrate.h"
#include "strutil.h"
/////////////////////////////////////////////////////////////////
//                   Constantes du programme
/////////////////////////////////////////////////////////////////
#define MAX_FOCUSER            20 // Max number of TControl objects in the Focuser list.
#define STRLEN_Label          15
#define STRLEN_VideonKey      256
#define STRLEN_Key            STRLEN_VideonKey+9 // ???|...|????
#define STRLEN_Gender           4
#define STRLEN_RecordKey       14 // 5 (tape) + ':' +3 (record) +'\0'
#define STRLEN_TapeKey         11 // 5 (word "tape-") + 5 (number) +'\'
#define STRLEN_Mesure          23
#define STRLEN_Flag             5
#define STRLEN_VersionLanguage 16
#define STRLEN_HasBeenSeen     STRLEN_Flag+4+STRLEN_VersionLanguage+1
#define STRLEN_Title           256
#define STRLEN_Author          128
#define STRLEN_SeriesShortName 10
#define STRLEN_Quality         5
#define STRLEN_StringNumber    16


#define ED_Offset                   300
#define CM_CW_AutoSaveOptions       ED_Offset+ 0
#define CM_CW_SaveOptionsNow        ED_Offset+ 1

#define CM_ED_LoadEntity            ED_Offset+10
#define CM_ED_SaveEntity            ED_Offset+11
#define CM_ED_EditEntity            ED_Offset+12
#define CM_ED_NewEntity             ED_Offset+13

#define ES_OldExist  1
#define ES_NewExist  2
#define ES_ChangeKey 4


extern unsigned char uLabeledWidth;
/////////////////////////////////////////////////////////////////
//                   Small classes (declarations)
//                   Structures
/////////////////////////////////////////////////////////////////
#define CHRONO       '='
#define MESURO       '~'
#define ESTIMO       '?'
#define PREC_UNKNOWN '!'
/*#define CHRONO_Typo       '='
#define MESURO_Typo       '~'
#define ESTIMO_Typo       '?'*/
typedef char lenght_precision;
enum videon_gender {SERIES, DOCUMENT, EPISODE, VOID_RECORD, DEFECT_TAPE, UNKNOWN} ;
#define qA 'A'
#define qB 'B'
#define qC 'C'
typedef char quality ;
//enum quality {qA, qB, qC} ;
#define VL_Unknown          0
#define VL_VONoST           1
#define VL_VF               2
#define VL_VOSTF            3
#define VL_VOtherLangageSTF 4
#define VL_SpecialSilent    5
#define VL_SpecialVersion   6
typedef unsigned char version_language;
/*enum version_language {VL_VONoST, VL_VF, VL_VOSTF, VL_VOtherLangageSTF,
    VL_SpecialSilent, VL_SpecialVersion};*/
enum vcr_type {EDISON, TOSHIBA, FIRSTLINE, OTHER};
struct has_been_seen {int fHasBeen; quality cQ ; version_language uVL  ;};
extern has_been_seen hsbNull;
// Special classes
class TEpisodeNumeration;

extern TMesure mesNul,mesMinimumSpace;


typedef int tape_number;
typedef int record_number;// within a tape


// Keys for each kind of entity
typedef tape_number     tape_key;
typedef char*           videon_key;// full videon key, ie:type code+title key
//typedef char*           series_key;// full videon key, ie:type code+title key
typedef TPoint       record_key ;
/*
class /*tape+record*//* record_key : public TPoint
  {
  public :
    record_key();
    record_key(int iTape,int iRecord);
    record_key(TPoint p);
  };
*/
class TEntity
  {
  public :
    TEntity(); // Default constructor, set all parameters to null.
//    int CallErase(char *szKey);// Set the database's value of the given entity to null. Call for virtual functions.
    int CallLoad(char *szKnownKey); // Load from database.
    int CallSave(char *szOldKey, char *szKnownKey=NULL); // Save to database, buid key if needed. Call for virtual function.
    int Reload(); // Call load on itself after building the key.
    int CheckExistence();
    int TEntity::CheckExistence(char *sz);
    virtual int IsDeletionCode();

    virtual int BuildStringKey(char *szKey, unsigned int wLen); // Fill the string with the key according to the values if the object.
//    virtual int CrawlForChangeKey(char *szOldKey,char *szNewKey);  // Inspect and process in the database to change the links.
// The object has the value of its new key at this point.
//    virtual int Erase(char *szKey, char *szFile); // Set the database's value of the given entity to null ('Window' does not provide real erase functions)  :(   (virtual)
    virtual int IsConsistant(char *sz, unsigned int wLen); // Reply if the entity is different from null.
    virtual int Load(char *szKey, char *szFile); // Load from database.
    virtual int Save(char *szOldKey, char *szNewKey, char *szFile, unsigned int fChangeKey); // Save to database (virtual)
    virtual void Reset(); // Set the fields to 0.
    virtual char *StoringFile(); // Reply the associated file.
  };



class TRecord : public TEntity
  {
  public :
    record_number iNumber; // within a tape
    tape_key  iTape;
    videon_key szVideon;
    TMesure mesRelPos, mesAbsPos, mesRelLen,mesAbsLen;
    char *szNote;

    TRecord(tape_key iTape_in=0, record_number iNumber_in=0,
        TMesure mesRelPos_in=mesNul, TMesure mesAbsPos_in=mesNul, TMesure mesRelLen_in=mesNul,
        TMesure mesAbsLen_in=mesNul);
    TRecord(TPoint pt,
        TMesure mesRelPos_in=mesNul, TMesure mesAbsPos_in=mesNul, TMesure mesRelLen_in=mesNul,
        TMesure mesAbsLen_in=mesNul);
    ~TRecord();
    virtual int IsDeletionCode();
    inline void TRecord::SetVideon(videon_key szNewVideon=NULL)
      {
      SetString(&szVideon,szNewVideon);
      }
    int LinkTape(); // Notify the tape the link to it
    virtual int Save(char *szOldKey, char *szNewKey, char *szFile, unsigned int fChangeKey); // Save to database (virtual)
    virtual int Load(char *szKey, char *szFile);
    virtual void Reset(); // Set the fields to 0.
    virtual int IsConsistant(char *sz, unsigned int wLen);
    virtual char *StoringFile();
    virtual int BuildStringKey(char *szKey, unsigned int wLen);
    void HarmonizePositions(int fTwistedRel, int fTwistedAbs,
      int fTwistedRelPos, int fTwistedAbsPos);
      // Check and correct mesures for coherence.
  };





/*
struct private_profile_data
  {
  char *szSection;
  char *szEntry;
  char *szFileName;
  };
*/
char *Item2String(has_been_seen hsb, char *sz);

int InterpretKey(char *szBuffer,unsigned int wLen, videon_gender e);
inline char *RecordKey2String(record_key key, char *sz)
  {
  return Point2String(key,sz);
  }
//record_key String2RecordKey(char *sz)
inline int String2RecordKeyEF(char *sz, record_key *prk)
  {
  return String2PointEF(sz,(TPoint *)prk);
  }
inline record_key String2RecordKey(char *sz)
  {
  record_key rk;
  if (String2RecordKeyEF(sz, &rk))
    return rk;
  else
    return record_key(0,0);
  }

//char *Gender2String(videon_gender eValue, char *szValue, unsigned int wLen);
//int String2GenderEF(char *szValue, videon_gender *pe);
int ExtractValue(char *szValue, videon_gender *pe, char **pcNext=NULL);
char *Item2String(videon_gender eValue, char *szValue, unsigned int wLen=0);
inline videon_gender String2Gender(char *szValue)
  {
  videon_gender e;
  if (!ExtractValue(szValue, &e))
    return UNKNOWN;
  else
    return e;
  }

int String2QualityEF(char *sz, quality *pcQ);
inline quality String2Quality(char *sz)
  {
  quality q=qC;
  String2QualityEF(sz,&q);
  return q;
  }
inline char *Quality2String(quality cQ, char *sz)
  {
  if (sz)
    sprintf(sz,"q%c",cQ);
  return sz;
  }
//char *HasBeenSeen2String(has_been_seen hsb, char *sz);
//int String2HasBeenSeenEF(char *sz, has_been_seen *phsb);
int ExtractValue(char *sz, has_been_seen *phbs, char **pcNext=NULL);
inline has_been_seen String2HasBeenSeen(char *sz)
  {
  has_been_seen hsb;
  ExtractValue(sz, &hsb);
  return hsb;
  }

int ExtractValue_VersionLanguage(char *sz, version_language *pu,
     char **pszNext=NULL);
/*
char *VersionLanguage2String(version_language u, char *sz);
int String2VersionLanguageEF(char *sz, version_language *pu);
*/
char *ItemVersionLanguage2String(version_language u, char *sz);
inline version_language String2VersionLanguage(char *sz)
  {
  version_language u;
  ExtractValue_VersionLanguage(sz,&u);
  return u;
  }


extern char szDefaultFile[MAXPATH];
extern char szTapeFile[MAXPATH];
extern char szVideonFile[MAXPATH];
extern char szRecordFile[MAXPATH];
extern char szSeriesFile[MAXPATH];
extern char cDefaultMesureType;
extern int iLastTape;
#endif
