#error Obsolete. Use wsysutil istead.
/* (contient les objets internes                               */
/*  et les corps des objets  exporter)                        */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/***************************************************************/

// Inclusions bibliothques standards
#include <stdio.h>
#include <values.h>

//  Inclusions bibliothques Object Windows
#include <owl\combobox.h>
#include <owl\edit.h>


// Inclusion bibliothques Image
#include "wsysutil.h"

//  Inclusions bibliothques Iris
#include "wedtderv.h"
#include "strtool.h"

/*-------------------------------------------------------------*/
/*		       constantes locales                      */
/*-------------------------------------------------------------*/
#define INKEY_Return   13
#define INKEY_Backward  8
#define INKEY_Tab       9
/*-------------------------------------------------------------*/
/*              prototypes des fonctions locales               */
/*-------------------------------------------------------------*/
TControl *pFocusedControl=NULL;
/*-------------------------------------------------------------*/
/*                   Nouvelle classe TEditCR                   */
/*--Systme----------------------------------------------------*/
DEFINE_RESPONSE_TABLE1(TEditCR, TEdit)
 EV_WM_CHAR,
 EV_WM_KEYUP,
 EV_WM_GETDLGCODE,
END_RESPONSE_TABLE;

TEditCR::TEditCR(TWindow *Parent, int Id, char far *Texte, int X, int Y,
			  int W, int H, UINT Taille, BOOL Multi)
	 : TEdit(Parent, Id, Texte, X, Y, W, H, Taille, Multi)
  {
  code=Id;
  pt=Parent;
  fInhibRC=0;
  fInhibTab=0;
  }
TEditCR::TEditCR(TWindow *Parent, int Id, char far *Texte,
                 TRect rPosition, UINT Taille, BOOL Multi)
	 : TEdit(Parent, Id, Texte, rPosition.left, rPosition.top, rPosition.Width(), rPosition.Height(), Taille, Multi)
  {
  code=Id;
  pt=Parent;
  fInhibRC=0;
  }

void TEditCR::EvKeyUp(UINT key, UINT repeatCount, UINT flags)
  {
  switch(key)
    {
    case VK_RETURN :
      EvChar(key, repeatCount, flags);
      break;
    default :
      TEdit::EvKeyUp(key, repeatCount, flags);
      break;
    }
  }

void TEditCR::EvChar(UINT key, UINT repeatCount, UINT flags)
  {
  static unsigned char f=0;
// Compteur semi inhibiteur : f pair => envoi
  if (key==INKEY_Return && !fInhibRC)
    {
    if (f++ & 0x01) // Just one out of 2!
      {
      pFocusedControl=NULL;
      pt->SendMessage(WM_COMMAND,code,0);       // RC
      }
    }
 else if (key==INKEY_Tab && !fInhibTab)
    {
    pFocusedControl=this;
    pt->SendMessage(WM_COMMAND,GetKeyState(VK_SHIFT)<0?CM_PredFocus:CM_NextFocus,0);       // Tab
    }
  else
    TEdit::EvChar(key, repeatCount, flags);
  }

UINT TEditCR::EvGetDlgCode(MSG far *)
	 {
	 return DLGC_WANTALLKEYS;
	 }
/*-------------------------------------------------------------*/
/*                   Nouvelle classe TEditNumCR                */
/*--Systme----------------------------------------------------*/
// classe pour zone numrique

void TEditNumCR::EvChar(UINT key, UINT repeatCount, UINT flags)
  {
  if (IsNumericFloat(key)
    || key==INKEY_Backward ||  key==INKEY_Return ||  key==INKEY_Tab
    || key==' ')
    TEditCR::EvChar(key, repeatCount, flags);
  else
    MessageBeep(-1);
  }

char far szStringMeaningValueBuffer[25];
char *StringMeaningValue(float xValue)
  {
  sprintf(szStringMeaningValueBuffer,"%g",xValue);
  return szStringMeaningValueBuffer;
  }

inline void ConstructTEditNumCR(TEditNumCR *p, float x)
  {
  if (x!=MINFLOAT)
    p->SetValue(x);
  }
TEditNumCR::TEditNumCR(TWindow *Parent, int Id, float xValue, int X, int Y,
           int W, int H, UINT Taille, BOOL Multi)
    : TEditCR(Parent, Id, "", X, Y, W, H, Taille, Multi)
  {
  ConstructTEditNumCR(this,xValue);
  }
TEditNumCR::TEditNumCR(TWindow *Parent, int Id, float xValue, TRect r,
                   UINT Taille, BOOL Multi)
    : TEditCR(Parent, Id,"", r.left, r.top, r.Width(), r.Height(), Taille,
            Multi)
  {
  ConstructTEditNumCR(this,xValue);
  }
DEFINE_RESPONSE_TABLE1(TEditNumCR, TEditCR)
 EV_WM_CHAR,
END_RESPONSE_TABLE;
/*--Nouvelles fonctionnalits----------------------------------*/

void TEditNumCR::SetValue(float xyValue)
  {
  TEdit::SetText(StringMeaningValue(xyValue));
  }
BOOL TEditNumCR::GetValue(unsigned int *pwValue)
  {
  if (!pwValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,pwValue);
  }
BOOL TEditNumCR::GetValue(int *piValue)
  {
  if (!piValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,piValue);
  }
BOOL TEditNumCR::GetValue(char *pcValue)
  {
  if (!pcValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,pcValue);
  }
BOOL TEditNumCR::GetValue(unsigned char *puValue)
  {
  if (!puValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,puValue);
  }
BOOL TEditNumCR::GetValue(float *pxyValue)
  {
  if (!pxyValue)
    return 0;
  char szTamp0[1024];
  TEdit::GetText(szTamp0,sizeof(szTamp0)-1);
  return ExtractValue(szTamp0,pxyValue);
  }
/*-------------------------------------------------------------*/
/*                   Nouvelle classe TComboBoxItems            */
/*--Systme----------------------------------------------------*/
TComboBoxItems::TComboBoxItems(TWindow* parent, int id, int x, int y,
      int w, int h, uint32 style, uint textLen, TModule* module):
                  TComboBox(parent, id, x, y, w, h, style, textLen,module){}
TComboBoxItems::TComboBoxItems(TWindow* parent, int id, TRect rPosition,
      uint32 style, uint textLen, TModule* module):
                  TComboBox(parent, id, rPosition.left, rPosition.top,
                    rPosition.Width(), rPosition.Height(), style, textLen,module){}
/*--Nouvelles fonctionnalits----------------------------------*/
DWORD TComboBoxItems::GetSelItem (void)
  {
  return GetItemData(GetSelIndex());
  }

int TComboBoxItems::AddItem(DWORD dItemValue, const char * string)
  {
  int iIndex=0;
  SetItemData(iIndex=AddString(string),dItemValue);
  return iIndex;
  }

int TComboBoxItems::SetSelItem(DWORD dItemValue)
  {
  int iN=GetCount();
  for (int k=0;k<iN;k++)
    {
    if (GetItemData(k)==dItemValue)
      return SetSelIndex(k);
    }
  return iN ? -iN:-1;
  }

