#error This should not be compiled. Use sysctr instead.
/**********************************************************************/
/*                       W I R I S C T R . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fonctions de contrle pour Iris dtournables   */
/*                     pour d'autres applications.                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste MARCEL       			      	       */
/*    Dvelopp le   : Printemps 1996                                 */
/**********************************************************************/
// Inclusions bibliothques standards
//#include <stdio.h>

//  Inclusions bibliothques Object Windows
#include <owl\framewin.h>
#include <owl\point.h>
// Inclusions bibliothques DOS

// Inclusion bibliothques Image
#include "wsysutil.h"
//#include "wmain.h"

//  Inclusions bibliothques Iris
#include "base.h"
#include "sysctr.h"
#include "wsystool.h"
/*-----------------------------------------------------------------------*/
/*                     Constantes locales                                */
/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                     Variables globales                                */
/*-----------------------------------------------------------------------*/
unsigned int wMessOK=MB_OK, wMessIconExclamation=MB_ICONEXCLAMATION, wMessSystemModal=MB_SYSTEMMODAL;
unsigned int wErrorIcons= wMessOK | wMessIconExclamation | wMessSystemModal;
/*-----------------------------------------------------------------------*/
/*                     Classes  exporter                                */
/*--TRuban---------------------------------------------------------------*/
class TRuban : public TFrameWindow
  {
  unsigned char uPct;              // pourcentage d'affichage
  virtual void TRuban::Paint(TDC& dc, BOOL, TRect&);
  public :
    TRuban(TWindow *Parent, char *szTitre);
    ~TRuban();
    void Maj(unsigned char uPct_user);
  };

TRuban  far *pRuban=NULL;
/*-----------------------------------------------------------------------*/
/*                   Nouvelle classe TRuban                              */
/*--Systme--------------------------------------------------------------*/
TRuban::TRuban(TWindow *Parent, char *szTitre)
 : TFrameWindow(Parent,szTitre)
  {
  Attr.Style =WS_BORDER | WS_CAPTION |WS_VISIBLE | WS_OVERLAPPED |WS_POPUP;
  Attr.W = 200;
  Attr.H = 50+iHauteurTitre;
  Attr.X = Parent->Attr.W/2-Attr.W/2;
  Attr.Y = Parent->Attr.H/2-Attr.H/2;
  uPct = 0;
  Create();
  }
/*-----------------------------------------------------------------------*/
TRuban::~TRuban()
  {
  CloseWindow();
  }
/*-----------------------------------------------------------------------*/
void TRuban::Paint(TDC& dc, BOOL erase, TRect& rect)
  {
  TFrameWindow::Paint(dc, erase,rect);
  unsigned char uHaut=(Attr.H-iHauteurTitre)/3, uBas=(Attr.H-iHauteurTitre)*2/3, uGauche=16, uDroit=Attr.W-16;
  unsigned char uAbscisse=0;
  TSize  sTailleCadreBande(uDroit-uGauche+1,uBas-uHaut+1);

  dc.SelectStockObject(NULL_BRUSH);
  dc.Rectangle(TRect(uGauche,uHaut,uDroit,uBas));
  uAbscisse=(sTailleCadreBande.cx-2)*uPct/100;
  dc.FillRect(TRect(uGauche+1,uHaut+1,uGauche+1+uAbscisse,uBas-1),TBrush(TColor(118,190,243)));
  dc.FillRect(TRect(uGauche+1+uAbscisse,uHaut+1,uDroit-1,uBas-1),TBrush(TColor::White));
  dc.SetBkMode(TRANSPARENT); dc.SetTextAlign(TA_CENTER | TA_BOTTOM);
  char buf[10]; wsprintf(buf, "%d %%", uPct);
  dc.TextOut(Attr.W/2, uBas-1, buf);
  }
/*--Nouvelles fonctionalits---------------------------------------------*/
void TRuban::Maj(unsigned char uPct_user)
  {
  TClientDC dc(*this);
  uPct = uPct_user;
  Paint(dc,FALSE,TRect(0, 0, Attr.W, Attr.H));
  }
/*-----------------------------------------------------------------------*/
/*       		Fonctions  exporter                             */
/*-----------------------------------------------------------------------*/
int Erreur (char *message)
  {
  if (!szErrorHeader)
    SetErrorHeader(szErrorDefaultHeader);
  if (pFenetreControle)
    pFenetreControle->MessageBox(message, szErrorHeader, wErrorIcons);
  else
    ::MessageBox(NULL,message, szErrorHeader, wErrorIcons);
  return ECHEC;
  }
/*-----------------------------------------------------------------------*/
int ActiveRubanLocal(char szTitre[])
  {
  pRuban=new TRuban(pFenetreControle, szTitre);
  return SUCCES;
  }
/*-----------------------------------------------------------------------*/
int AvanceRubanLocal(unsigned char uAv)
  {
  if (!pRuban)
    return FAILURE;
  else
    {
    pRuban->Maj(uAv);
    return SUCCES;
    }
  }
/*-----------------------------------------------------------------------*/
int FermeRubanLocal()
  {
  if (!pRuban) return Erreur("Ruban dja ferm. (131)");
  delete pRuban;
  pRuban=NULL;
  return SUCCES;
  }

