/**********************************************************************/
/*                     C O R T E X . H   	       			             */
/*--------------------------------------------------------------------*/
/*    Fonction       : Prototype de fonctions.                        */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Sbastien Delestaing          			      	 */
/*    Dvelopp le   : Avril - Septembre 1996                         */
/*    Dernire modif.: 24/09/96                                       */
/**********************************************************************/
#ifndef WCORTEX_H
#define WCORTEX_H

#include <owl/scrollba.h>
#include <owl/radiobut.h>

//#include "wgeometr.h"
#include "analtex.h"

/*---------------------*/
/*--TParametres-------------------------------------------------------------*/
class TParametres : public TDialog
{	TScrollBar *ReSeuil1, *ReSeuil2, *ReSeuil3, *ReSeuil4;
	TStatic *ReCap1, *ReCap2, *ReCap3, *ReCap4;
	int vReSeuil1, vReSeuil2, vReSeuilzc, vReSeuil3;
	public:
	TParametres(TWindow* parent);
//	~TParametres();
	protected:
	void SetupWindow( void );
	void EvA(WPARAM id);
	void EvB(WPARAM id);
	void EvC(WPARAM id);
	void EvD(WPARAM id);
	void EvAppliquer( void );
//	void EvClose( void );

	DECLARE_RESPONSE_TABLE(TParametres);
};
/*-----------------------------------------------------------------------*/
/*--TOptions-------------------------------------------------------------*/
class TOptions : public TDialog
{  TRadioButton *pRB[15];
	TComboBox *ReCombo;
	public:
	TOptions(TWindow* parent);
//	~TOptions();
	protected:
	void SetupWindow( void );
	void EvCombo( void );
	void EvRB1( void );
	void EvRB2( void );
	void EvRB3( void );
	void EvRB4( void );
	void EvRB5( void );
	void EvRB6( void );
	void EvRB7( void );
	void EvRB8( void );
	void EvRB9( void );
	void EvRB10( void );
	void EvRB11( void );
	void EvRB12( void );
	void EvRB13( void );
	void EvRB14( void );
	void EvRB15( void );
	void EvClose( void );

	DECLARE_RESPONSE_TABLE(TOptions);
};
/*-----------------------------------------------------------------------*/

#endif // Header unicity  WCORTEX_H
