//----------------------------------------------------------------------------
//						Programme TUtil
//----------------------------------------------------------------------------

DEFINE_RESPONSE_TABLE1(TUtil, TFramePrint)
	EV_WM_SIZE,
	EV_WM_MOUSEMOVE,

  END_RESPONSE_TABLE;

TUtil::TUtil(TWindow* parent, char far titre[],int mode)
  : TFramePrint(parent,titre)
		{
		Attr.Style =
		WS_VISIBLE | WS_POPUP | WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL;
		Attr.X = 256+8;
		Attr.Y = OFFSET;
		Attr.W = 376;
		Attr.H = 256+27+106;
		Scroller = new TScroller(this, 5, 5, 640/5, 480/5);  // 640/5, 1000
		Scroller->SetSBarRange();
		//fConsistanceUtil=FALSE;
		modeutil=mode;
		}

void TUtil::EvMouseMove(UINT , TPoint& point)
{
 char buf[20];
 long a,b;

 int decx,decy;

 a=(Scroller->YPos)*5+point.y;
 b=(Scroller->XPos)*5+point.x;

 switch(modeutil)
	{
	case 2:             // Ligne
	case 3:             // Colonne
			decx=10;decy=5;
			b-=decx;
			a=-a+256+decy;
	if(a>=0&&a<256&&b>=0&&b<256) SetCursor(GetApplication(), RETIC);
	else SetCursor(GetApplication(), IDC_ARROW);
	break;

	case 7:             // Histogramme
			decx=50;decy=300;
			b-=decx;
			a=-a+decy;
	if(a>=0&&a<256&&b>=0&&b<256) SetCursor(GetApplication(), RETIC);
	else SetCursor(GetApplication(), IDC_ARROW);
	break;
	}
 wsprintf(buf, "X=%ld   Y=%ld", b, a);
 pZ1->SetText(buf);   // affichage dans le deuxime compartiment
}

void TUtil::EvSize(UINT sizeType, TSize& size)
{
	TWindow::EvSize(sizeType, size);
	ShowScrollBar(SB_HORZ);
	ShowScrollBar(SB_VERT);
	Scroller->SetSBarRange();
}

void TUtil::Paint(TDC& dc, BOOL, TRect&)
{

unsigned char buf[256];
unsigned char far *pointim;
int i,j,taillex=16,tailley=16,px0=0,py0=0;
char s[80],string[80];
int decx,decy,py;
long a;
int pasx=1,pasy=1;
int x,y,z,u,v,u0,v0,ymax=255,xmax=255,zmax=255;
int tabmin[512],tabmax[512],aut,autprec;
int deltax=35,deltay=16;

float Var,Moy;
double Ectype;
int min,max;

//if (!fConsistanceUtil) return;
switch(modeutil)
	{
	case 1:             // Fentre

			dc.MoveTo(px0,py0+(2*deltay)-5);
			dc.LineTo(px0+deltax-5+(16*deltax),py0+(2*deltay)-5);
			dc.MoveTo(px0+deltax-5,py0);
			dc.LineTo(px0+deltax-5,py0+(2*deltay)-5+(16*deltay));

			for(i=0;i<tailley;i++)
			{
				for(j=0;j<taillex;j++)
				{
				 if(posx+j<256&&posy+i<256)
					{
					pointim=source+((posy<<8)+posx+j+(i<<8));
					buf[j+i*tailley]=*pointim;
					itoa(*pointim,s,10);
					//dc.SetTextColor(TColor::Black);
					dc.TextOut(px0+deltax+(j*deltax),py0+(2*deltay)+(i*deltay),s);
					}
				}
				// Coordonnes
				//dc.SetTextColor(TColor::LtBlue);
				itoa(posx+i,s,10);
				dc.TextOut(px0+deltax+(i*deltax),py0, s);
				itoa(posy+i,s,10);
				dc.TextOut(px0,py0+(2*deltay)+(i*deltay), s);
			}
			//dc.SetTextColor(TColor::Black);

			break;

	case 2:             // Ligne
	case 3:             // Colonne

			decx=10;decy=5;

			if(modeutil==2)
			{
			pointim=source+posy*256;
			for(i=0;i<256;i++) buf[i]=*pointim++;
			}
			else
			{
			pointim=source+posx;
			for(i=0;i<256;i++) {buf[i]=*pointim;pointim+=256;}
			}
			dc.Rectangle(decx-1,decy-1,decx+256+1,decy+256+1);

			for(i=0;i<=8;i++)                // Graduations x
			{
			dc.MoveTo(decx+i*32,decy+1+256);
			dc.LineTo(decx+i*32,1+decy+5+256);
			itoa(i*32,string,10);
			dc.TextOut(decx+i*32-4*strlen(string),decy+10+256,string);
			}

			for(i=1;i<=8;i++)                 // Graduations y
			{
			py=decy+256-(i*32);
			dc.MoveTo(decx+256+1,py);
			dc.LineTo(1+decx+256+1+5,py);
			itoa(i*32,string,10);
			dc.TextOut(decx+256+13,py-3,string);
			}

			dc.MoveTo(decx+0,decy+256-buf[0]);

			for(i=0;i<256;i++)
			{
			dc.LineTo(decx+i,decy+256-buf[i]);
			}
			break;

			case 4:             // Perspective

			decx=0;decy=0;

			for(u=0;u<=511;u++){tabmax[u]=-1;tabmin[u]=256;}

			for(y=ymax;y>=0;y-=pasy)
			{
			for(x=xmax;x>=0;x-=pasx)
			{
			pointim=source+x+(y<<8);
			z=(int)*pointim;
			u=x+128-(y>>1);
			v=(y-z+256)>>1;

			if(x==xmax) {u0=u;v0=v;autprec=0;}
			aut=0;
			if(v>tabmax[u]){tabmax[u]=v;aut=1;}
			if(v<tabmin[u]){tabmin[u]=v;aut=1;}
			if(aut==1)
				{
				if(autprec==0) {u0=u;v0=v;}
				dc.MoveTo(decx+u0,decy+v0);
				dc.LineTo(decx+u,decy+v);
				dc.LineTo(decx+u+1,decy+v);
				autprec=1;
				}
			else autprec=0;
			u0=u;v0=v;
			}
			}

			for(y=ymax;y>=0;y--)         	// synthse plans 0 et max
			{
				for(x=xmax;x>=0;x--)
				{
			if(x==xmax||y==ymax||x==0||y==0)
			{
			z=0;
			u=x+128-(y>>1);
			v=(y-z+256)>>1;
			dc.SetPixel(decx+u,decy+v,TColor::LtBlue);
			z=zmax;
			u=x+128-(y>>1);
			v=(y-z+256)>>1;
			dc.SetPixel(decx+u,decy+v,TColor::LtGreen);
			}
			}
			}
													// Axes
			dc.TextOut(decx+384+10,decy+128,"X");
			dc.TextOut(decx,decy+256+10,"Y");
			dc.TextOut(decx+128-28,decy,"Z");

			break;

	case 5:             // Statistique

		  dc.TextOut(1,0,"MOYENNE    : ");
		  dc.TextOut(1,15,"ECART TYPE : ");
		  dc.TextOut(1,30,"ENTROPIE   : ");
		  dc.TextOut(1,45,"MINIMUM    : ");
		  dc.TextOut(1,60,"MAXIMUM    : ");
		  gcvt(moy_image,6,string);
		  dc.TextOut(120,0,string);
		  gcvt(ec_type_image,6,string);
		  dc.TextOut(120,15,string);
		  gcvt(entropie_image,6,string);
		  dc.TextOut(120,30,string);
		  itoa(min_image,string,10);
		  dc.TextOut(120,45,string);
		  itoa(max_image,string,10);
		  dc.TextOut(120,60,string);

			break;

	case 6:             // Covariance

			for(i=0;i<8;i++)
			{
				for(j=0;j<8;j++)
				{
				gcvt((double)cov[i][j],6,string);
				dc.TextOut(1+j*80,i*20,string);
				}
			}
			break;

	case 7:             // Histogramme

			decx=50;
			decy=300;

			dc.Rectangle(decx-1,decy-256,decx+256+1,decy+1);
			dc.SetTextColor(TColor::Black);
			dc.TextOut(decx,decy-256-20,"HISTOGRAMME");
			dc.SetTextColor(TColor::LtBlue);
			dc.TextOut(decx+112,decy-256-20,"HISTOGRAMME CUMULE");

			dc.SetTextColor(TColor::Black);

			for(i=0;i<=8;i++)                // Graduations x
			{
			dc.MoveTo(decx+i*32,decy+1);
			dc.LineTo(decx+i*32,1+decy+5);
			itoa(i*32,string,10);
			dc.TextOut(decx+i*32-4*strlen(string),decy+10,string);
			}

			for(i=1;i<=8;i++)                 // Graduations histo
			{
			a=8192*(long)i;
			py=decy-(int)sqrt((double)a);
			dc.MoveTo(decx-5-1,py);
			dc.LineTo(1+decx-1,py);
			itoa(i,string,10);
			strcat(string,"/8");
			dc.TextOut(decx-13-8*strlen(string),py-3,string);
			}

			dc.SetTextColor(TColor::LtBlue);

			for(i=1;i<=8;i++)                 // Graduations F.repa
			{
			a=8192*(long)i;
			py=decy-(int)(a>>8);
			dc.MoveTo(decx+256+1,py);
			dc.LineTo(1+decx+256+1+5,py);
			itoa(i,string,10);
			strcat(string,"/8");
			dc.TextOut(decx+256+13,py-3,string);
			}

			for(i=0;i<256;i++)                // Trac histo
			{
			y=(int)sqrt((double)bufhist[i]);
			dc.MoveTo(decx+i,decy);
			dc.LineTo(decx+i,decy-y);
			dc.LineTo(decx+i+1,decy-y);
			}

			for(i=0;i<256;i++)                // Trac F.repa
			{
			dc.SetPixel(decx+i,decy-(bufrepa[i]>>8),TColor::LtBlue);
			}

			break;

	}// switch

							// Affichage commun min max moyenne & ec.type

			if((posx+j<256&&posy+i<256&&modeutil==1)||modeutil==2||modeutil==3)
			{
			if(modeutil==1) Min_max(buf,&min,&max,(long)(taillex*tailley));
			else Min_max(buf,&min,&max,256);
			strcpy(s,"Minimum = ");
			itoa(min,string,10);
			strcat(s,string);
			dc.TextOut(px0+10,py0+256+33, s);
			strcpy(s,"Maximum = ");
			itoa(max,string,10);
			strcat(s,string);
			dc.TextOut(px0+10,py0+256+33+20, s);
			Moy=Moyenne_courbe(buf,(long)(taillex*tailley));
			gcvt((double)Moy,6,string);
			strcpy(s,"Moyenne = ");
			strcat(s,string);
			dc.TextOut(px0+150,py0+256+33, s);
			Var=Variance_courbe(buf,(long)(taillex*tailley));
			Ectype=sqrt((double)Var);
			gcvt(Ectype,6,string);
			strcpy(s,"Ecart type = ");
			strcat(s,string);
			dc.TextOut(px0+150,py0+256+33+20,s);

			if(modeutil==2)
			{
			 itoa(posy,string,10);
			 strcpy(s,"Position en Y = ");
			 strcat(s,string);
			 dc.TextOut(px0+100,py0+256+33+40, s);
			}
			if(modeutil==3)
			{
			 itoa(posx,string,10);
			 strcpy(s,"Position en X = ");
			 strcat(s,string);
			 dc.TextOut(px0+100,py0+256+33+40, s);
			}
			}
}

TUtil::~TUtil()
{
	TUtilPtr=0;
  //	modeutil=0;
	//fConsistanceUtil=FALSE;
}
