#error Obsolete: use anallec.*
#define MODULE_NAME "wANALLEC.CPP"
/*******************|*******************************************/
/*                  W A N A L L E C . C                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonction de traitement d'image pour     */
/*                     Anagnostes.                             */
/*                                                             */
/* (contient les objets internes                               */
/*  et les corps des objets  exporter)                        */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : hivers 1994/1995                        */
/***************************************************************/
// Inclusions bibliothques standards
#include <math.h>
#include <values.h>
// Inclusions bibliothques Object Windows
#include <owl/point.h>
// Inclusions bibliothques DOS

// Inclusion bibliothques Image
#include "wgttsi.h"

//  Inclusions bibliothques Iris
#include "wanallec.h"
#include "wanlfreq.h"
#include "base.h"
#include "sysctr.h"
#include "wgeometr.h"
#include "piadiv.h"
#include "scaltool.h"
#include "wsymbole.h"


/*-------------------------------------------------------------*//*
/*		       constantes locales                      *//*
/*-------------------------------------------------------------*//*
/*-------------------------------------------------------------*//*
/*	              variables  exporter                     *//*
/*-------------------------------------------------------------*/
echantillonneur echantillonneurnul=ResetEchantillonneur();
/*-------------------------------------------------------------*//*
/*		      nouveaux types locaux                    *//*
/*-------------------------------------------------------------*//*
/*-------------------------------------------------------------*//*
/*		       variables locales                       *//*
/*-------------------------------------------------------------*//*
/*-------------------------------------------------------------*//*
/*              prototypes des fonctions locales               *//*
/*-------------------------------------------------------------*//*
data_matrix Lecture_symboleF_BF(unsigned int f, bipoint fenetre, unsigned char *source)
char Lecture_symbole_bar_HF(unsigned int f, wwQuadrilatere ABCD, data_matrix DM, echantillonneur *img_mat);
*/
char Lecture_symbole_persp_HF
       (unsigned int f,TQuadrilatere ABCD,TDataMatrix *pDM,
       echantillonneur *img_mat, char type, unsigned char *puSource,
       unsigned char *puCible,
       float *axCellBearer_AB, float *axCellTableC2,
       TBipoint pbipCellBearerC1, TBipoint pbipCellBearerC2);
echantillonneur *ech (echantillonneur *img_mat, int i, int j);
void RaZech(echantillonneur *img_mat, unsigned int f);
int Charge_mat_Echantillonneur(TDataMatrix *pDM, echantillonneur *img_mat);
int EchantillonnageDirect(echantillonneur *img_mat,
                          unsigned int f);
int CalcAbscisseHyperboliqueDansABCD(TVecteur xyM, TVecteur xyPf,
    TDroite drAB, TDroite drAD, TDroite drBC, int fConverge, float xNorme,
    int fVerrouBF,
    float *pxNh);
BOOL DegrillageSymbole(
       TVecteur A, TVecteur B, TVecteur D,
       TDroite AB, TDroite AD, TVecteur Pf_AB, TVecteur Pf_AD,
       unsigned int f,
       char fAB_Converge, char fAD_Converge, void *pArg,
       int (*fProcessCell)(TVecteur xyM, unsigned int wI, unsigned int wJ,
           void *pArg));

float CalcAbscisseHyperbolique(TDroite drAxe, TVecteur xyPf, TVecteur xyM0,
  TVecteur xyM1, TVecteur xyM, int fCV);
int Lecture_symbole_persp_hyp_CV_HF(
  unsigned int f,
  TQuadrilatere ABCD,
  TVecteur Pf_AB, TVecteur Pf_AD,
  int fAD_Converge, int fAB_Converge,
  echantillonneur *img_mat,
  TDroite AB, TDroite BC, TDroite CD, TDroite AD, unsigned char *puSource);
BOOL Degrillage_symbole(TVecteur xyA, TVecteur xyB,
    TBipoint pbipCellBearerC1, TBipoint pbipCellBearerC2,
    TVecteur Pf_AB, TVecteur Pf_BC,
    unsigned int f,
    char fAB_Converge, char BC_converge, echantillonneur *img_mat,
    float *axCellTableC1, float *axCellTableC2);
BOOL Degrillage_symbole(
       TVecteur A, TVecteur B, TVecteur D,
       TDroite AB, TDroite AD, TVecteur Pf_AB, TVecteur Pf_AD,
       unsigned int f,
       char fAB_Converge, char fAD_Converge, echantillonneur *img_mat);
char Decoupage_axe_fuyant(
       TVecteur A, TVecteur B, TDroite droite_AB, TVecteur Pf, float *hyperabs,
       char convergence, unsigned int f);
float DeterminePeriodeSpatialeMin(TVecteur A, TVecteur B, TVecteur C, TVecteur D, unsigned int f);

char Lecture_symbole_persp_hyp_CV_HF_balay_smb(
  unsigned int f,
  TQuadrilatere ABCD,
  TVecteur Pf_AB, TVecteur Pf_AD,
  char fAB_Converge, char fAD_Converge,
  echantillonneur *img_mat,
  TDroite AB, TDroite BC, TDroite CD, TDroite AD,
  unsigned char *puSource=NULL, unsigned char *puCible=NULL,
  float *axCellTableC1=NULL, float *axCellTableC2=NULL,
  TBipoint pbipCellBearerC1=bipNul, TBipoint pbipCellBearerC2=bipNul);
int TransformationRaideVersMatriceCarree(
  unsigned int f, // Ct de la matrice
  TQuadrilatere ABCD,  //  Quadrilatre
  TVecteur Pf_AB, TVecteur Pf_AD, /* Points ou directions de fuites */
  char fAB_Converge, char fAD_Converge,
  TDroite AB, TDroite BC, TDroite CD, TDroite AD,  /* Droites supports du quad. */
  unsigned char *puSource, // Image source de taille 256*256
  unsigned char *puCible  // Table cible de taille f*f
  );
int MatriceurEchantillonneur(TVecteur xyM, unsigned int wI, unsigned int wJ,
           void *paArg);
/*-------------------------------------------------------------*/
/*    	              fonctions  exporter                     */
/*-------------------------------------------------------------*/
echantillonneur ResetEchantillonneur()
  {
  echantillonneur E;
  E.position=TVecteur(0.0,0.0);
  E.rayon=0.0;
  E.ndg=0.0;
  E.surf_cumulee=0.0;
  return E;
  }

BOOL LectureSymboleConnuPerspHF(TQuadrilatere ABCD, TDataMatrix *pSymbole,
                               unsigned char *puSource,
                               unsigned char *puCible,
                               unsigned int wFrequenceForcee,
                               unsigned char uPerpType)
  {
  if (!pSymbole)
    return MErreur("Pointeur nul",111);
  echantillonneur *img_mat;
  BIT fRes=ECHEC;
  unsigned int wf;
  float axCellTableC1[MAX_DIAGONAL];
  float axCellTableC2[MAX_DIAGONAL];
  TBipoint pbipCellBearerC1, pbipCellBearerC2;
//  float *axCellTable=NULL;
  ABCD.ReOrgQuadMaxMax();
  if (wFrequenceForcee)
    wf=wFrequenceForcee;
  else if (!AnalFreqQuadGenerique (ABCD, &wf, puSource,QUAD_APPLICATION,
      NULL,NULL,NULL,
      axCellTableC1, axCellTableC2, &pbipCellBearerC1, &pbipCellBearerC2))
/*
  AnalFreqQuadGenerique a balay le symbole selon 2 directions.
Le premier balayage dans la direction D1 du plus long ct a permis
de trouver la ligne de cellules C1 pseudo-parallle  l'autre direction D2.

  Donc. Si C est le plus long ct, C2 et C seront quasi-parallle.

  L'appel tant prcd de "ABCD.ReOrgQuadMaxMax()", AB est C.
C1 est quasi-parallle  BC et C2  AB. 

*/
    return ECHEC;

  Trace("Analyse de frquence russie avec wf=",(int)wf,121);
  pSymbole->Set(wf);
  if (pSymbole->Matrice==NULL)
    return ErreurAllocation(139);
  if ((img_mat=(echantillonneur *)malloc((wf+2)*(wf+2)*sizeof(echantillonneur)))==NULL)
    {
    pSymbole->Set();
    return MErreur("Allocation refuse.", 305);
    }
  RaZech(img_mat,wf);
  fRes=Lecture_symbole_persp_HF(wf,ABCD, pSymbole, img_mat,
                                uPerpType,
                                puSource,
                                  puCible,
                                  axCellTableC1, axCellTableC2,
                                  pbipCellBearerC1, pbipCellBearerC2);
// C1 est quasi-parallle  BC et C2 est quasi-parallle  AB.
  if (!fRes)
    pSymbole->Set();
  free(img_mat);
  return fRes;
  }
BOOL TransformationRaideVersMatriceCarree(TQuadrilatere ABCD,
                               unsigned char *puSource, // image source 256*256
                               unsigned char *puCible, // matrice cible f*f
                               unsigned int wF)
  {
//  int iDeform=4, iDirect=ABCD.IsParcoursTrigo()?1:-1;
//  ABCD.ReOrgQuadMaxMax(&iDeform);  // Indique la transformation impose  l'animal.
  ABCD.FlipParcoursTrigo();
//  Trace ("Trans Quad iDeform= ",iDeform,199);
  TDroite drAB, drBC, drCD, drAD;
  TVecteur xyPF_AB, xyPF_AD;
  int fAB_Converge, fAD_Converge;

  if (!wF || ABCD.Pervers() || !puSource || !puCible)
    return MErreur("Starting spec unresolved",209);
  else if (!ABCD.DroitesPorteuses(&drAB, &drBC, &drCD, &drAD))
    return MErreur("Echec interne (porteuses quadrilatre).", 211);
  else if (!TDroite::CalculeFuiteFaisceau(drAB, drCD, &xyPF_AB, &fAB_Converge) ||
           !TDroite::CalculeFuiteFaisceau(drAD, drBC, &xyPF_AD, &fAD_Converge))
    return MErreur("Echec interne (fuites).", 214);
  else
    {
    TransformationRaideVersMatriceCarree(wF,ABCD,xyPF_AB,xyPF_AD,
	        fAB_Converge, fAD_Converge,drAB,drBC,drCD,drAD,
                puSource, puCible);
    if (Numeroplan(puCible))
      {
/*      unsigned char *puMemSource=source, *puMemTarget=destin,
          *puBuff=PlanSuiv(puCible);
      source=puCible;destin=puBuff;
      TReperage repS=iDeform>0?repSymetrieCentrale:repID;
      TReperage repRot, repTransfo; */
      TReperage repRot, repRot1, repRot2, repRot3;

      repRot.SetRotat(-M_PI/2);
      repRot1= repRot2= repRot;
      repRot3=repRot1 * repRot2;
      UseRotat(repRot,puCible);
/*      repTransfo=repS*repRot;
      complex zG, zC;
      double dAlphaX, dAlphaY;
      repTransfo.TellTGeom(&zG,&dAlphaX,&dAlphaY,&zC);

      Rotat(dAlphaX,real(zC),imag(zC),real(zG),imag(zG),0);
      source=puMemSource;destin=puMemTarget;
//      unsigned char *puBuff=NextPlan(puCible);
      memcpy(puBuff,puCible,SIZE_OF_PICTURES*SIZE_OF_PICTURES);
//      RotationMod90Matrice(puCible,puBuff,SIZE_OF_PICTURES,);
*/
      }
    }
  return SUCCES;
  }

/* ech (echantillon)
  Accs au contenu d'une image de data-matrix (tableau d'chantillonneurs)
ayant chantillon un cadre de cases extrieurs  la matrice.
  Utilis avec un pointeur NULL, la fonction initialise la frquence de la
matrice avec le premier paramtre.
  Renvoit un pointeur sur l'chantillonneur dsign.
  La taille du tableau est en fait (f+2)*(f+2), et l'adresse d'un lment
de la case (i,j) est en fait (i+1, j+1).
*/
echantillonneur *ech (echantillonneur *img_mat, int i, int j)
  {
  static unsigned int f;
  if (img_mat==NULL)
    {
    f=i;
    return NULL;
    }
  if (i< -1 || i>(int)f || j< -1 || j>(int)f)
    {
    MErreur("Les goules sont sorties du cimetierre. (LANLLECT)",326);
    return NULL;
    }
  return img_mat+(i+1)*(f+2)+(j+1);
  }

/*-------------------------------------------------------------*/
// C1 est quasi-parallle  BC et C2 est quasi-parallle  AB.
char Lecture_symbole_persp_HF(
       unsigned int f,TQuadrilatere ABCD,
       TDataMatrix *pDM, echantillonneur *img_mat, char cType,
       unsigned char *puSource, unsigned char *puCible,
       float *axCellTableC1, float *axCellTableC2,
       TBipoint pbipCellBearerC1, TBipoint pbipCellBearerC2)
  {
  TDroite AB, BC, CD, AD;
  TVecteur Pf_AB, Pf_AD;
  int fAB_Converge, fAD_Converge;

  if (!pDM->wFrequence || ABCD.Pervers() || f!=pDM->wFrequence || !pDM->Matrice
    || ((!axCellTableC1)!=(!axCellTableC1))) // both nuls or notnuls
    return MErreur("Problme trange.",430);
  else if (!ABCD.DroitesPorteuses(&AB, &BC, &CD, &AD))
    return MErreur("Echec interne (porteuses quadrilatre).", 431);
  else if (!TDroite::CalculeFuiteFaisceau(AB, CD, &Pf_AB, &fAB_Converge) ||
           !TDroite::CalculeFuiteFaisceau(AD, BC, &Pf_AD, &fAD_Converge))
    return MErreur("Echec interne (fuites).", 435);
  MTrace("Faisceaux calculs.",484);
/* Si un faisceau ne converge pas, le vecteur Pf renvoy correspond  un
  vecteur directeur de la direction de fuite. */
  switch (cType)
    {
    case QUAD_PERSPECTIVE_REGULIERE :
  /* Perspective rgulire (barycentrique, bugue.) */
      return MErreur("Procdure condamne", 441);
/*
    if (!Lecture_symbole_persp_reg_CV_HF(f, ABCD,
	 Pf_AB, Pf_AD, fAB_Converge, fAD_Converge, img_mat))
      {
      MErreur("Echec interne (lecture perspective)", 356);
      return ECHEC;
      }
     break; */
    case QUAD_PERSPECTIVE_HYPERBOLIQUE_IMAGE :
  /* Perspective hyperbolique (balayage d'image, trs long). */
      return MErreur("Procdure condamne", 441); /*
    if (!Lecture_symbole_persp_hyp_CV_HF(f, ABCD,
	 Pf_AB, Pf_AD, fAB_Converge, fAD_Converge, img_mat, AB, BC, CD, AD))
      {
      MErreur("Echec interne (lecture perspective hyperbolique)", 373);
      return ECHEC;
      }
    break;                                        */
// Rajouter un code pour grille connue (2 "CellTable"). Les deux grilles seraint celles de BC et CD par convention.
    case GRILLE_2COTES_CONNUS :
      if (!Lecture_symbole_persp_hyp_CV_HF_balay_smb(f,ABCD,Pf_AB,Pf_AD,
          fAB_Converge, fAD_Converge,img_mat,AB,BC,CD,AD,puSource, puCible,
          axCellTableC1,axCellTableC2,pbipCellBearerC1,pbipCellBearerC2))
        return MErreur("Echec interne (lecture rapide avec grille pr-calcule)", 531);
      break;
    case PERSPECTIVE_HYPERBOLIQUE_SYMBOLE :
    /* Perspective hyperbolique (balayage de symbole, rapide). */
      if (!Lecture_symbole_persp_hyp_CV_HF_balay_smb(f,ABCD,Pf_AB,Pf_AD,
	        fAB_Converge, fAD_Converge,img_mat,AB,BC,CD,AD,puSource, puCible))
        return MErreur("Echec interne (lecture rapide perspective hyperbolique)", 464);
      break;
  default :
    return MErreur("Echec interne (perspective non dfinie)", 468);
    }
  /* Calcul de la valeur de chaque bit en fonction de l'chantillonnage. */
  if (!Charge_mat_Echantillonneur(pDM,img_mat))
    return MErreur("Erreur  l'chantillonage");
  if (!EchantillonnageDirect(img_mat,f))
    pDM->Transpositon();
  return pDM->PivoteHorlogeRail();
  }

int EchantillonnageDirect(echantillonneur *img_mat,
                          unsigned int f)
  {
  if (!img_mat)
    return MErreur("Erreur code",540);
  ech(NULL,f,f);
//  TVecteur A(ABCD.A), B(ABCD.B), D(ABCD.D);
  TVecteur a(ech(img_mat,0,0)->position),
           b(ech(img_mat,f-1,0)->position),
           d(ech(img_mat,0,f-1)->position);
//  return signe((B-A)^(D-A))==signe((b-a)^(d-a));
  return ((b-a)^(d-a)) > 0.0;
/* L'chantillonage est direct si les sens de parcours du quadrilatere ABCD (de
l'image) et abcd (de l'chantillonneur) sont les mmes.
  Cette procdure ne marche que si les secteurs angulaires (DAB) et (dab) ne
sont pas dgnrs.  */
  }

int Charge_mat_Echantillonneur(TDataMatrix *pDM, echantillonneur *img_mat)
  {
  int f=pDM->wFrequence, i, j, K=0;
  unsigned char *liste_ndg, uMin=0, uMax=0;
  echantillonneur *cellule;
  float limite;

  ech(NULL,f,f);
  if ((liste_ndg=(unsigned char *) malloc(f*f*sizeof(unsigned char)))==NULL)
    return MErreur("Allocation refuse.",548);
  if (img_mat==NULL || pDM->Matrice==NULL)
    return MErreur("Pas de Chpliz dans les Jingouz. (LANLLECT)",553);
  for (i=0;i<(int)f;i++)
    for (j=0;j<(int)f;j++)
      {
      cellule=ech(img_mat,i,j);
      if (cellule->surf_cumulee>0.0)
	{
// Normalisation des ndg de l'chantillonneur par rapport  la surface cumule
	liste_ndg[K]=i2uc(NReduceR((cellule->ndg /= cellule->surf_cumulee), 0,255));
// Etablissement de la liste des ndg des cellules de surface non nulle.
	if (!K || liste_ndg[K]>uMax)
	  uMax = liste_ndg[K];
	if (!K || liste_ndg[K]<uMin)
	  uMin = liste_ndg[K];
	K++; // Compte les cellules  la surface cumule non nulle.
	}
      else
	cellule->ndg =-1;
      }
  if (K)
    limite = Moyenne_courbe(liste_ndg,K);
// Il serait peut-tre utile ici d'utiliser des algos plus efficaces,
// dont par exemple un algo de suillage pas mode.
  else
    {
    MErreur("Toutes cellules de surface nulle",614);
    limite=128;
    }

  for (i=0;i<f;i++)
    for (j=0;j<f;j++)
      {
      cellule=ech(img_mat,i,j);
      if (cellule->ndg < 0.0)
	(pDM->Matrice)[j*f+i]=NB_INCONNU;
      else if (cellule->ndg <=limite) // Seuillage par rapport  la valeur de "limite"
	(pDM->Matrice)[j*f+i]=NOIR;
      else
	(pDM->Matrice)[j*f+i]=BLANC;
      }
  free(liste_ndg);
  return SUCCES;
  }
/*----------------------------------------------------------*//*
char Lecture_symbole_persp_reg_CV_HF(
  unsigned int f,
  wwQuadrilatere ABCD,
  vecteur Pf_AB, vecteur Pf_AD,
  char fAD_Converge, char fAB_Converge,
  echantillonneur *img_mat)
  {
  vecteur A, B, C, D;
  wwCoordonnee AN, BN, CN, DN;
  unsigned int I, J, I0, J0, If, Jf;
  echantillonneur *cellule;
  vecteur P;
  vecteur Norm_h, Norm_v;
  float t1h, t2h, Dth=1.0, z1h, z2h, Dzh=1.0, t1v, t2v, Dtv=1.0, z1v, z2v, Dzv=1.0;
  float th, tv, zh, zv, nh, nv;
  int i, j;
  long int course;
  float avancement;
  unsigned char bufretic[9];

  if (img_mat==NULL)
    {
    MErreur("The vampires will attack this night. (LANLLECT)",473);
    return ECHEC;
    }
  Cv_Quad4PointsR(ABCD, &A, &B, &C, &D);
  Norm_h=VecteurOrthogonal(Pf_AB);
  Norm_v=VecteurOrthogonal(Pf_AD);
  if (fAB_Converge)
    {
    if (!OrientationVecteur(Cv_2PointsVecteur(Pf_AB,A), &t1h) ||
	!OrientationVecteur(Cv_2PointsVecteur(Pf_AB,D), &t2h))
      MErreur("Ratage intersectif.", 451,TERMINAL);
    Dth=t2h-t1h;
    if (Dth <= - M_PI)
      Dth=Dth+2.0*M_PI;
    else if (Dth > M_PI)
      Dth=Dth-2.0*M_PI;
    }
  else
    {
    /* La distance algbrique non norme sert de repre pour la position de la case. *//*
    z1h=ProdScal(Norm_h,A);
    z2h=ProdScal(Norm_h,D);
    Dzh=z2h-z1h;
    }

  if (fAD_Converge)
    {
    if (!OrientationVecteur(Cv_2PointsVecteur(Pf_AD,A), &t1v) ||
	!OrientationVecteur(Cv_2PointsVecteur(Pf_AD,B), &t2v))
      MErreur("Ratage intersectif vertical.", 469,TERMINAL);
    Dtv=t2v-t1v;
    if (Dtv <= - M_PI)
      Dtv=Dtv+2.0*M_PI;
    else if (Dtv > M_PI)
      Dtv=Dtv-2.0*M_PI;
    }
  else
    {
    /* La distance algbrique non norme sert de repre pour la position de la case. *//*
    z1v=ProdScal(Norm_v,A);
    z2v=ProdScal(Norm_v,B);
    Dzv=z2v-z1v;
    }

  if (Dth ==0.0 || Dtv == 0.0 || Dzh == 0.0 || Dzv==0.0)
    MErreur("Trou noir dans une puce.", 455,TERMINAL);
  Cv_Quad4Points(ABCD, &AN, &BN, &CN, &DN);
  I0=min(min(AN.ligne,BN.ligne),min(CN.ligne,DN.ligne));
  J0=min(min(AN.colonne,BN.colonne),min(CN.colonne,DN.colonne));
  If=max(max(AN.ligne,BN.ligne),max(CN.ligne,DN.ligne));
  Jf=max(max(AN.colonne,BN.colonne),max(CN.colonne,DN.colonne));
  if (!(course=(Jf-J0+1)*(If-I0+1)))
    {
    MErreur("Marathon compress  0 m ! (LANLLECT)",543);
    return ECHEC;
    }
  for (I=I0;I<=If;I++)
    for (J=J0;J<=Jf;J++)
      {
      P=Cv_PointVecteur(Cv_2EntiersCoord(I,J));
      if (fAB_Converge)
	{
	if (!OrientationVecteur(Cv_2PointsVecteur(Pf_AB,P), &th))
	  MErreur("Semoule mystique dans les vecteurs.",577,TERMINAL);
	nh=NFloorR((th-t1h)/Dth*f);
	}
      else
	{
	zh=ProdScal(Norm_h,P);
	nh=NFloorR((zh-z1h)/Dzh*f);
	}
      if (nh<0)
	nh=-1;
      else if (nh >= f)
	nh=f;

      if (fAD_Converge)
	{
	if (!OrientationVecteur(Cv_2PointsVecteur(Pf_AD,P), &tv))
	  MErreur("Choucroute mystique dans les vecteurs.",591,TERMINAL);
	nv=NfarroundR((tv-t1v)/Dtv*f-0.5);
	}
      else
	{
	zv=ProdScal(Norm_v,P);
	nv=NfarroundR((zv-z1v)/Dzv*f-0.5);
	}
      if (nv<0)
	nv=-1;
      else if (nv >= f)
	nv=f;

      cellule=ech(img_mat,nv,nh);
      if (tracage)
	{
	Sauveretic(source, bufretic,J,I);
	Ecriretic(bufretic,J,I);
	}
      cellule->ndg += source[(I<<8)+J];
      (cellule->surf_cumulee)++;
      avancement=((float)(I-I0)*(Jf-J0+1)+(J-J0))*100.0/course;
      MErreurfr("Niveau d'avancement : ",avancement,613,LEGER);
      }
  return SUCCES;
  }
/*-------------------------------------------------------------*/
int Lecture_symbole_persp_hyp_CV_HF(
  unsigned int f,
  TQuadrilatere ABCD,
  TVecteur Pf_AB, TVecteur Pf_AD,
  int fAD_Converge, int fAB_Converge,
  echantillonneur *img_mat,
  TDroite drAB, TDroite drBC, TDroite drCD, TDroite drAD,
  unsigned char *puSource, unsigned char *puCible)
  {
//  TVecteur A, B, C, D;
  TVecteur xyM, xyMh, xyMb; /* Points en haut et en bas du point xyM  tudier. */
  TDroite drMhMb;
  TVecteur xyAD, xyAB;
//  TCoordonnee AN, BN, CN, DN;
  unsigned int iI, iJ, iI0, iJ0, iIf, iJf;
  int fVerrouBF=VRAI;
  echantillonneur *cellule;
  float x_nh, x_nv;
//  float x_nh, x_dnh, x_nv, x_dnv;
  long int lCourse;
//  unsigned char uAvancement, uAv2=0;
//  unsigned char auBufRetic[9];

  if (!drAB.Existe() || !drBC.Existe() || !drCD.Existe() || !drAD.Existe() ||
      !img_mat)
    return MErreur("Attack of the killing tomatoes.",600);
  _Trace("Entre en analyse persp. hyp.",622);
//  Cv_Quad4PointsR(ABCD, &A, &B, &C, &D);
//  Cv_Quad4Points(ABCD, &AN, &BN, &CN, &DN);
  iI0=min(min(ABCD.A.y,ABCD.B.y),min(ABCD.C.y,ABCD.D.y));
  iJ0=min(min(ABCD.A.x,ABCD.B.x),min(ABCD.C.x,ABCD.D.x));
  iIf=max(max(ABCD.A.y,ABCD.B.y),max(ABCD.C.y,ABCD.D.y));
  iJf=max(max(ABCD.A.x,ABCD.B.x),max(ABCD.C.x,ABCD.D.x));
  if (!(lCourse=(iJf-iJ0+1)*(iIf-iI0+1)))
    {
    MErreur("xyMarathon compress  0 mm ! (LANLLECT)",631);
    return ECHEC;
    }
  _Trace("Entre en boucle.",636);

  for (iI=iI0;iI<=iIf;iI++)
    for (iJ=iJ0;iJ<=iJf;iJ++)
      {
      xyM.Set(iI,iJ);

      CalcAbscisseHyperboliqueDansABCD(xyM, Pf_AB,drAB, drAD, drBC,
          fAB_Converge, f,fVerrouBF,&x_nh);
#if 0

      if (fAB_Converge)
	{
	if (!(drMhMb=TDroite(xyM, Pf_AB)).Existe())
	  x_nh=0; /* xyM=Pf_AB. */
        xyMh=drMhMb.Intersection(drAD);
        xyMb=drMhMb.Intersection(drBC);
	if (!xyMh.Existe() || !xyMb.Existe())
	  x_nh=-1; /* xyM est hors dusymbole (pour quadrilatre non crois). */
	}
      else /* Pas de point de fuite (drAB). */
	{
	if (!(xyAB=drAB.VecteurPorteur()).Existe() ||
	    ! (xyMh=drAD.ProjectionPtVect(xyM,xyAB)).Existe() ||
	    ! (xyMb=drBC.ProjectionPtVect(xyM,xyAB)).Existe() ||
	    ! (drMhMb=TDroite(xyMh,xyMb)).Existe()
	   )
	  MErreur("Harre Krishna (dans les intersectionde LANLECT).",682);
	}
// x_nh: abscisse hyperbolique raporte  la frqeunce.
      if (xyMh.Existe() && xyMb.Existe() && drMhMb.Existe() && Pf_AB.Existe())
        x_nh=CalcAbscisseHyperbolique(drMhMb, Pf_AB, xyMh,xyMb,xyM,fAB_Converge)*(float)f;

// Analyse de la valeur
      x_dnh=x_nh-NFloorR(x_nh);  // Partie dcimale
      if (fVerrouBF && (x_dnh<0.33 || x_dnh > 0.67)) // abscisse proche d'une abscisse entire
	x_nh=-1;  // Rejet de la valeur.
      else
	x_nh=NFloorR(x_nh);
      if (x_nh<0)
	x_nh=-1;
      else if (x_nh > f)
	x_nh=f;
      Trace("Calcul de x_nh :",x_nh, 664);
#endif
/*      CalcAbscisseHyperboliqueDansABCD(xyM, Pf_AB,drAB, drAD, drBC,
          fAB_Converge, f,fVerrouBF,&x_nh);*/
      CalcAbscisseHyperboliqueDansABCD(xyM, Pf_AD,drAD, drAB, drCD,
          fAD_Converge, f,fVerrouBF,&x_nv);
#if 0
      if (fAD_Converge)
	{
	if (!(drMhMb=TDroite(xyM, Pf_AD)).Existe())
	  x_nv=0;
	if (!(xyMh=drMhMb.Intersection(drAB)).Existe()
	    || !(xyMb=drMhMb.Intersection(drCD)).Existe())
	  x_nv=-1;
	}
      else /* Pas de point de fuite (drAD). */
	{
	if (!(xyAB=xyAD.VecteurPorteur()).Existe() ||
	    ! (xyMh=drAB.ProjectionPtVect(xyM,xyAD)).Existe() ||
	    ! (xyMb=drCD.ProjectionPtVect(xyM,xyAD)).Existe() ||
	    ! (drMhMb=TDroite(xyMh,xyMb)).Existe()
	   )
	  MErreur("L'univers est en expension.",868);
	}
      x_nv=CalcAbscisseHyperbolique(drMhMb, Pf_AD, xyMh,xyMb,xyM,fAD_Converge)*(float)f;
      x_dnv=x_nv-NFloorR(x_nv);
      if (fVerrouBF && (x_dnv<0.33 || x_dnv > 0.67))
	x_nv=-1;
      else
	x_nv=NFloorR(x_nv);
      if (x_nv<0)
	x_nv=-1;
      else if (x_nv >= f)
	x_nv=f;
      Trace("Valcul de x_nv :",x_nv, 686);
#endif
      cellule=ech(img_mat,x_nv,x_nh);
      if (fTracage)
        DessineRetic(puSource,TCoordonnee(cellule->position),puCible);
      cellule->ndg += puSource[(iI<<8)+iJ];
      Trace("Niveau de gris local :",source[(iI<<8)+iJ], 694);
      (cellule->surf_cumulee)++;
      AvanceRuban(((float)(iI-iI0)*(iJf-iJ0+1)+(iJ-iJ0))*100.0/lCourse);
      }
  return SUCCES;
  }
/*-------------------------------------------------------------*/
/* Lecture_symbole_persp_hyp_CV_HF_balay_smb (Lecture symbole en perspective
     hyperbolique (supports du quadrilatre convergents), pour haute
     frquences, balayage par symbole)
float tm : Priode spatiale minimale.

     */
// C1 est quasi-parallle  BC et C2 est quasi-parallle  AB.
char Lecture_symbole_persp_hyp_CV_HF_balay_smb(
  unsigned int f,
  TQuadrilatere ABCD,
  TVecteur Pf_AB, TVecteur Pf_AD, /* Points ou directions de fuites */
  char fAB_Converge, char fAD_Converge,
  echantillonneur *img_mat,
  TDroite AB, TDroite BC, TDroite CD, TDroite AD,  /* Droites supports du quad. */
  unsigned char *puSource,
  unsigned char *puCible,
  float *axCellTableC1, float *axCellTableC2,
  TBipoint pbipCellBearerC1, TBipoint pbipCellBearerC2)
  {
  TVecteur A(ABCD.A), B(ABCD.B), C(ABCD.C), D(ABCD.D);
  float tm=0.0; /* Priode spatiale minimale. */
  int nb_couches_limite=3, nc=0, k=0, larg=0, m=0;
  unsigned int i=0,j=0;
  TCoordonnee M0;
  echantillonneur *cellule=NULL;;
  unsigned char pxi=0, pxj=0;
  BOOL fRes=SUCCES;

  if (!AB.Existe() || !BC.Existe() || !CD.Existe() || !AD.Existe() ||
      !img_mat || !f || !puCible || (!axCellTableC1) != (!axCellTableC2))
    return MErreur("Attack of the Blob.",773);
#if 256-SIZE_OF_PICTURES  // true if  SIZE_OF_PICTURES!=256
  return MErreur("Fonction calibre pour 256 pixels",850);
#endif
//  Trace("Entre en analyse persp. hyp. (balayage symbole, LANLLECT)",776);
  /* Calcul des coordonnes de la grille d'chantillonnage. */
  MTrace("Dgrillage",846);
  if (axCellTableC1)
    fRes=Degrillage_symbole(A, B, pbipCellBearerC1,pbipCellBearerC2,
        Pf_AB, Pf_AD, f,
        fAB_Converge, fAD_Converge, img_mat, axCellTableC1, axCellTableC2);
  else
    fRes=Degrillage_symbole(A,B,D, AB, AD, Pf_AB, Pf_AD, f, fAB_Converge,
        fAD_Converge,img_mat);
  /* tm : priode spatiale minimale dtermine en fonction de la taille du quadrilatre. */
  if (!fRes)
    return MErreur("Unknown error in Degrillage_symbole",911);
  tm=DeterminePeriodeSpatialeMin(A,B,C,D,f);
  Trace("DeterminePeriodeSpatialeMin ",tm,851);
/* Le nombre de couches de la tche sous laquelle l'image est chantillonne
dpend de tm : nc=E(0.67*tm/2). */
  nc=NReduceR(NFloorR(tm/3.0)-1,0,nb_couches_limite);
//  if (tracage)
  //  MErreurir("Nombre de couches : ",nc,807);
  Trace("Nombre de couches ",nc,884);
  ActiveRuban("Lecture");
  for (i=0;i<f;i++)
    for (j=0;j<f;j++)
      {
      cellule=ech(img_mat,i,j); // Renvoie un pointeur sur la cellule.
      M0=TCoordonnee(cellule->position);
      /* Position du centre de la case. */
/* L'imbriquage des boucle suivantes permet de balayer une tche de type 2
(losange) centre sur le centre de la case, et ayant un nombre de couche=nc. */
      for (k=-nc;k<=nc;k++)
/* k : distance verticale entre le point courant et le centre de la tche. */
	     if (M0.y-k>=0 && M0.y-k <=SIZE_OF_PICTURES-1)
	  /* Pour ne pas sortir de l'image. */
	       {
	       pxi=M0.y-k; /* ligne du point courant. */
	       larg=nc-abs(k); /* demi-largeur de la tche sur la ligne courante. */
	       for (m=-larg;m<=larg;m++)
/* m : distance horizontale entre le point courant et le centre de la tche. */
	         if (M0.x-m>=0 && M0.x-m <=SIZE_OF_PICTURES-1)
	           {
	           pxj=M0.x-m; /* colonne du point courant. */
	           cellule->ndg += puSource[pxi*SIZE_OF_PICTURES+pxj];
	           (cellule->surf_cumulee)++;
	           }
	       }
      if (fTracage)
        {
        DessineRetic(puSource,M0,puCible);
//        Trace("pt ",M0,j);
        }
      AvanceRuban(100*(i*f+j)/f/f);
      }
  FermeRuban();
  return SUCCES;
  }
/*-------------------------------------------------------------*/
int TransformationRaideVersMatriceCarree(
  unsigned int f, // Ct de la matrice
  TQuadrilatere ABCD,  //  Quadrilatre
  TVecteur Pf_AB, TVecteur Pf_AD, /* Points ou directions de fuites */
  char fAB_Converge, char fAD_Converge,
  TDroite AB, TDroite BC, TDroite CD, TDroite AD,  /* Droites supports du quad. */
  unsigned char *puSource, // Image source de taille 256*256
  unsigned char *puCible  // Table cible de taille f*f
  )
  {
  TVecteur A(ABCD.A), B(ABCD.B), C(ABCD.C), D(ABCD.D);
//  unsigned int i=0,j=0;
  TCoordonnee M0;

  if (!AB.Existe() || !BC.Existe() || !CD.Existe() || !AD.Existe() || !f || !puCible )
    return MErreur("Attack of the Blob.",1032);
#if 256-SIZE_OF_PICTURES  // true if  SIZE_OF_PICTURES!=256
  return MErreur("Fonction calibre pour 256 pixels",850);
#endif
//  Trace("Entre en analyse persp. hyp. (balayage symbole, LANLLECT)",776);
// Calcul des coordonnes de la grille d'chantillonnage. 
  void *paArg[3]={(void *)puSource, (void *)puCible, (void *)&f};
  if (!DegrillageSymbole(A,B,D, AB, AD, Pf_AB, Pf_AD, f, fAB_Converge,
        fAD_Converge,paArg,MatriceurEchantillonneur))
    return MErreur("Unknown error in Degrillage_symbole",911);
  return SUCCES;
  }
/*-------------------------------------------------------------*/
BOOL TQuadrilatere::DroitesPorteuses
      (TDroite *pAB, TDroite *pBC, TDroite *pCD, TDroite *pAD)
  {
  TVecteur vA(A),vB(B),vC(C),vD(D), u;
  char AeB, BeC, CeD, AeD;

  AeB= A==B;
  BeC= B==C;
  CeD= C==D;
  AeD= A==D;

  if (AeB && CeD)
    return MErreur("Repliement multi-perspectif et cadre de symbole non dfini.",333);
  if (AeB) /* A=B et C!=D. *//*
/* Si une droite n'est pas dfinie, on la prend parallle  sa vis--vis. */
    {
    *pCD=TDroite(C,D);
    *pAB=TDroite(A,D-C,DROITE_POINT_VECTEUR);
    }
  else if (CeD) /* (C=D et A!=B) */
    {
    *pAB=TDroite(A,B);
    *pCD=TDroite(C,B-A,DROITE_POINT_VECTEUR);
    }
  else /* (C!=D et A!=B) */
    {
    *pAB=TDroite(A,B);
    *pCD=TDroite(C,D);
    }
  if (!pCD->Existe() || !pAB->Existe())
    return MErreur("Panique sur Mercure",355);
  if (AeD && BeC)
    return MErreur("Repliement anti-perspectif.",367);
  if (AeD) /* A=D et C!=B. *//*
/* Si une droite n'est pas dfinie, on la prend parallle  sa vis--vis. */
    {
    *pBC=TDroite(B,C);
    *pAD=TDroite(A,C-B,DROITE_POINT_VECTEUR);
    }
  else if (BeC) /* (C=B et A!=D) */
    {
    *pAD=TDroite(A,D);
    *pBC=TDroite(A,D-A,DROITE_POINT_VECTEUR);
    }
  else /* (C!=B et A!=D) */
    {
    *pAD=TDroite(A,D);
    *pBC=TDroite(B,C);
    }
  if (!pBC->Existe() || !pAD->Existe())
    return MErreur("Panique sur Neptune.",392);
/* Les 4 droites sont toutes dfinies ainsi que leurs orientations. */
  return SUCCES;
  }

/* Calcule le point ou la direction de fuite d'un faisceau de deux droites.
  Si les droites sont parallles, le commutateur "fini" est mis  VRAI et
la valeur renvoye est un vecteur porteur de la direction de fuite. *//*

char CalculeFuiteFaisceau_2Droites(
  triplet Dr1, triplet Dr2,
  vecteur *ptrF, char *Fini)
  {

   if (ptrF==NULL || !DroiteExiste(Dr1) || !DroiteExiste(Dr2))
    {
    MErreur("Entits non dfinies.", 635);
    return ECHEC;
    }
  *Fini=!Paralleles(Dr1, Dr2);
  if (*Fini)
    {
    if (!Intersection(Dr1, Dr2, ptrF))
      MErreur("Ratage intersectif malheureux.", 644,TERMINAL);
    if (tracage)
      TracePoint(*ptrF);
    }
  else
    {
    ptrF->x=-Dr1.b;
    ptrF->y=Dr1.a;
    }
  return SUCCES;
  }

float Calc_Abscisse_Hyperbolique(triplet axe, vecteur Pf, vecteur M0,
  vecteur M1, vecteur M, char CV)
  {
  float unit_hyper, abs_hyper_Pf, abs_hyper_M;
/*  if (!DroiteExiste(axe)) /* vrification faite dans "PenteDouce". *//*/*
    MErreur("Echec calcul d'abscisse hyperbolique.",799,TERMINAL); *//*
  if (PointsEgaux(M0,M1))
    MErreur("Echec calcul d'abscisse hyperbolique.",801,TERMINAL);
  if (CV)
    {
    if (PointsEgaux(Pf,M))
      MErreur("Abscisse hyperbolique infinie.",805,TERMINAL);
    if (!PenteDouce(axe))
      {
      unit_hyper=M1.y-M0.y;
      abs_hyper_Pf=(Pf.y-M0.y)/unit_hyper;
      abs_hyper_M=(M.y-M0.y)/unit_hyper;
      }
    else
      {
      unit_hyper=M1.x-M0.x;
      abs_hyper_Pf=(Pf.x-M0.x)/unit_hyper;
      abs_hyper_M=(M.x-M0.x)/unit_hyper;
      }
    return abs_hyper_M*((abs_hyper_Pf-1)/(abs_hyper_Pf-abs_hyper_M));
    }
  else /* Pas de point de fuite. *//*
    {
    if (!PenteDouce(axe))
      return (M.y-M0.y)/(M1.y-M0.y);
    else
      return (M.x-M0.x)/(M1.x-M0.x);
    }
  }
*/
void RaZech(echantillonneur *img_mat, unsigned int f)
  {
  int i, j;
  echantillonneur *cellule;

  if (img_mat==NULL)
    {
    MErreur("What's the bloody point ! (LANLLECT); blocage imminent.",822);
    return;
    }
  ech(NULL,f,0); // Initialisation de la variable statique de l'chantillonnage.
  for (i=-1;i<=(int)f;i++)
    for (j=-1;j<=(int)f;j++)
      {
      cellule=ech(img_mat,i,j);
      cellule->ndg = 0.0 ;
      cellule->surf_cumulee = 0.0;
      cellule->position.Set();
      cellule->rayon = 0.0;
      }
  }
/*-------------------------------------------------------------*/
/* Degrillage_symbole (dgrillage symbole)
Calcul des coordonnes de la grille d'chantillonnage.
*/
BOOL Degrillage_symbole(TVecteur /*xyA_*/, TVecteur /*xyB_*/,
    TBipoint pbipCellBearerC1, TBipoint pbipCellBearerC2,
    TVecteur Pf_AB, TVecteur Pf_BC,
    unsigned int f,
    char fAB_Converge, char BC_converge, echantillonneur *img_mat,
    float *axCellTableC1, float *axCellTableC2)
  {
  if ((!axCellTableC1) != (!axCellTableC2))
    return MErreur("Tables de cellules non cohrentes",1081);
    /*
  float *hyperabs_AB=NULL, *hyperabs_AD=NULL; */
  TDroite *droite_PfAB_H=NULL, droite_PfBC_Gi=DroiteErreur;

  unsigned int i=0, j=0;
  TVecteur  xyC1ParalBC(pbipCellBearerC1), xyC2ParalAB(pbipCellBearerC2),
    xyC1a(pbipCellBearerC1.left,pbipCellBearerC1.top),xyC2a(pbipCellBearerC2.left,pbipCellBearerC2.top);
//  TVecteur H, vecAB(B-A), vecAD(D-A), Gi, M;
//  echantillonneur *cellule=NULL;
  BOOL fRes=SUCCES;

  /* Tableaux des abscisses des points d'chantillonages sur les axes (AB)
et (CD). */
  if (NULL==(droite_PfAB_H=(TDroite *)malloc(f*sizeof(TDroite))))
    return MErreur("Allocation impossible",1137);
  do // executed once.
    {
  /* Tableau des droites du faisceau AB. */
  /* Calcul du faisceau AB. */
    for (j=0;j<f && fRes;j++)
      {
    /* H : Point de la porteuse de cellule d'[AB] d'indice j*/
      if (!(droite_PfAB_H[j]=
          TDroite(xyC1a+ xyC1ParalBC * axCellTableC1[j],
                  Pf_AB,!fAB_Converge)).Existe()) // TDroite construite sur 2points ou 1point et un vecteur selon que le faisceau converge ou pas.
        {
        fRes=MErreur("Echec au calcul du faisceau de droites // [AB].",1110);
        break; // Sortie boucle locale "for"
        }
      }
/* Les points de la grille sont  l'intersection du faisceau AB et du
faisceau AD. */
/* On connat les deux droites des ligne i et colonne j, leur intersection
est le point (i,j). */
/* "cellule": pointeur sur l'chantillonneur de la case (i,j). */
    for (i=0;i<f && fRes;i++)
      {
      if (!(droite_PfBC_Gi=
          TDroite(xyC2a+ xyC2ParalAB*axCellTableC2[i],
                  Pf_BC,!BC_converge)).Existe()) // TDroite construite sur 2points ou 1point et un vecteur selon que le faisceau converge ou pas.
        {
        fRes=MErreur("Echec au calcul du faisceau de droites [BC].",1132);
        break; // Sortie boucle locale "for"
        }
      for (j=0;j<f && fRes;j++)
        if (!(ech(img_mat,i,j)->position=droite_PfBC_Gi.Intersection(droite_PfAB_H[j])).Existe())
          {
	  fRes=MErreur("Echec au calcul des intersection de faisceaux.",1133);
          break; // Sortie boucle locale imbrique "for"
          }
      }
    }
  while (FAUX); // Boucle xecute une fois;
  free(droite_PfAB_H);
  return fRes;
  }
BOOL Degrillage_symbole_old(
       TVecteur A, TVecteur B, TVecteur D,
       TDroite AB, TDroite AD, TVecteur Pf_AB, TVecteur Pf_AD,
       unsigned int f,
       char fAB_Converge, char fAD_Converge, echantillonneur *img_mat)
  {
  float *hyperabs_AB=NULL, *hyperabs_AD=NULL;
  TDroite *droite_PfAB_H, droite_PfAD_Gi;
  unsigned int i=0, j=0;
  TVecteur H, vecAB(B-A), vecAD(D-A), Gi, M;
  echantillonneur *cellule=NULL;
  BIT fRes=SUCCES;

  /* Tableaux des abscisses des points d'chantillonages sur les axes (AB)
et (CD). */
  if (NULL==(hyperabs_AB=(float *)malloc(f*sizeof(float))))
    return MErreur("Allocation impossible",1082);
  else if (NULL==(hyperabs_AD=(float *)malloc(f*sizeof(float))))
    {
    free (hyperabs_AB);
    return MErreur("Allocation impossible",1086);
    }
  else if (NULL==(droite_PfAB_H=(TDroite *)malloc(f*sizeof(TDroite))))
    {
    free (hyperabs_AD);
    free (hyperabs_AB);
    return MErreur("Allocation impossible",1092);
    }
  do
    {
    /* Calcul des hyperabs. */
    if (!Decoupage_axe_fuyant(A,B,AB,Pf_AB,hyperabs_AB,fAB_Converge,f) ||
        !Decoupage_axe_fuyant(A,D,AD,Pf_AD,hyperabs_AD,fAD_Converge,f) )
      {
      fRes=MErreur("Echec au dcoupage de l'axe.",1085);
      break; // Sortie totale
      }
  /* Tableau des droites du faisceau AB. */
  /* Calcul du faisceau AB. */
    TVecteur Hinterm;
    for (j=0;j<f && fRes;j++)
      {
    /* H : Point d'(AD) de la colonne j. */
      Hinterm=vecAD*hyperabs_AD[j];
      H=Hinterm+A;
      if (fAB_Converge)
        {
      /* Cas convergent : la droite de la colonne j passe par H et Pfj=PfAB. */
        if (!(droite_PfAB_H[j]=TDroite(Pf_AB,H)).Existe())
	  {
          fRes=MErreur("Echec au calcul du faisceau de droites.",1110);
          break; // Sortie boucle locale "for"
          }
        }
      else
      /* Cas non convergent : la droite de la colonne j passe par H et
	 est parallle au vecteur Pfj=PfAB qui est vecteur directeur de la
	 direction de fuite. */
        {
        if (!(droite_PfAB_H[j]=TDroite(H,Pf_AB,DROITE_POINT_VECTEUR)).Existe())
          {
	  fRes=MErreur("Echec au calcul du faisceau de droites.",1110);
          break; // Sortie boucle locale "for"
          }
        }
      }
/* Les points de la grille sont  l'intersection du faisceau AB et du
faisceau AD.
  Le faisceau AB a t calcul.
  */
    for (i=0;i<f && fRes;i++)
      {
/*
  Pour chaque ligne i, on calcule sa droite et on calcule ses intersection
avec chaque droite du faisceau AB.
  Une fois ceci fait, on oublie la ligne i et on calcule la ligne i+1.
*/
/* Gi : Point d'(AB) de la ligne i. */
      Gi=vecAB*hyperabs_AB[i]+A;
      if (fAD_Converge)
        {
      /* Cas convergent : la droite de la ligne i passe par Gi et Pfi=PfAD. */
        if (!(droite_PfAD_Gi=TDroite(Pf_AD,Gi)).Existe())
          {
	  fRes=MErreur("Echec au calcul du second faisceau de droites.",1123);
          break; // Sortie boucle locale "for"
          }
        }
      else
        {
      /* Cas non convergent : la droite de la ligne i passe par Gi et
	 est parallle au vecteur Pfi=PfAB qui est vecteur directeur de la
	 direction de fuite. */
        if (!(droite_PfAD_Gi=TDroite(Gi,Pf_AD,DROITE_POINT_VECTEUR)).Existe())
          {
	  fRes=MErreur("Echec au calcul du faisceau de droites.",1110);
          break; // Sortie boucle locale "for"
          }
        }
      for (j=0;j<f;j++)
        {
/* On connat les deux droites des ligne i et colonne j, leur intersection
est le point (i,j). */
/* "cellule": pointeur sur l'chantillonneur de la case (i,j). */
        cellule=ech(img_mat,i,j);
        if (!(M=droite_PfAD_Gi.Intersection(droite_PfAB_H[j])).Existe())
          {
	  fRes=MErreur("Echec au calcul des intersection de faisceaux.",1133);
          break; // Sortie boucle locale imbrique "for"
          }
        cellule->position=M;
        }
      }
    }
  while (FAUX); // Boucle xecute une fois;
  free(droite_PfAB_H);
  free(hyperabs_AD);
  free(hyperabs_AB);
  return fRes;
  }

int DegrilleurEchantillonneur(TVecteur xyM, unsigned int wI, unsigned int wJ,
           void *pArg)
  {
  echantillonneur *sC=ech((echantillonneur *)pArg,wI,wJ);
  if (sC)
    sC->position=xyM;
  return !!sC;
  }
int MatriceurEchantillonneur(TVecteur xyM, unsigned int wI, unsigned int wJ,
           void *paArg)
  {
  void **apArg=(void**)paArg;
  unsigned char *puSource=(unsigned char *)apArg[0];
  unsigned char *puCible=(unsigned char *)apArg[1];
  unsigned int f= *((unsigned int *)apArg[2]);
  puCible[wI*f+wJ]=puSource[NFarRoundR(xyM.y)*SIZE_OF_PICTURES + NFarRoundR(xyM.x)];
  return SUCCESS;
  }
BOOL Degrillage_symbole(
       TVecteur A, TVecteur B, TVecteur D,
       TDroite AB, TDroite AD, TVecteur Pf_AB, TVecteur Pf_AD,
       unsigned int f,
       char fAB_Converge, char fAD_Converge, echantillonneur *img_mat)
  {
  return DegrillageSymbole(A,B,D,AB,AD,Pf_AB,Pf_AD,f,fAB_Converge, fAD_Converge,
    (void *) img_mat, DegrilleurEchantillonneur);
  }
BOOL DegrillageSymbole(
       TVecteur A, TVecteur B, TVecteur D,
       TDroite AB, TDroite AD, TVecteur Pf_AB, TVecteur Pf_AD,
       unsigned int f,
       char fAB_Converge, char fAD_Converge, void *pArg,
       int (*fProcessCell)(TVecteur xyM, unsigned int wI, unsigned int wJ,
           void *pArg))
  {
  /* Tableaux des abscisses des points d'chantillonages sur les axes (AB)
et (CD). */
  float *hyperabs_AB=(float *)malloc(f*sizeof(float));
  if (!hyperabs_AB)
    return MErreur("Allocation impossible",1082);
  float *hyperabs_AD=(float *)malloc(f*sizeof(float));
  if (!hyperabs_AD)
    {
    free (hyperabs_AB);
    return MErreur("Allocation impossible",1086);
    }
  TDroite *droite_PfAB_H=(TDroite *)malloc(f*sizeof(TDroite));
  if (!droite_PfAB_H)
    {
    free (hyperabs_AD);
    free (hyperabs_AB);
    return MErreur("Allocation impossible",1092);
    }
  TDroite droite_PfAD_Gi;
  unsigned int i=0, j=0;
  TVecteur H, vecAB(B-A), vecAD(D-A), Gi, M;
  BIT fRes=SUCCES;

  do
    {
    /* Calcul des hyperabs. */
    if (!Decoupage_axe_fuyant(A,B,AB,Pf_AB,hyperabs_AB,fAB_Converge,f) ||
        !Decoupage_axe_fuyant(A,D,AD,Pf_AD,hyperabs_AD,fAD_Converge,f) )
      {
      fRes=MErreur("Echec au dcoupage de l'axe.",1085);
      break; // Sortie totale
      }
  /* Tableau des droites du faisceau AB. */
  /* Calcul du faisceau AB. */
    TVecteur Hinterm;
    for (j=0;j<f && fRes;j++)
      {
    /* H : Point d'(AD) de la colonne j. */
      Hinterm=vecAD*hyperabs_AD[j];
      H=Hinterm+A;
      if (fAB_Converge)
        {
      /* Cas convergent : la droite de la colonne j passe par H et Pfj=PfAB. */
        if (!(droite_PfAB_H[j]=TDroite(Pf_AB,H)).Existe())
	  {
          fRes=MErreur("Echec au calcul du faisceau de droites.",1110);
          break; // Sortie boucle locale "for"
          }
        }
      else
      /* Cas non convergent : la droite de la colonne j passe par H et
	 est parallle au vecteur Pfj=PfAB qui est vecteur directeur de la
	 direction de fuite. */
        {
        if (!(droite_PfAB_H[j]=TDroite(H,Pf_AB,DROITE_POINT_VECTEUR)).Existe())
          {
	  fRes=MErreur("Echec au calcul du faisceau de droites.",1110);
          break; // Sortie boucle locale "for"
          }
        }
      }
/* Les points de la grille sont  l'intersection du faisceau AB et du
faisceau AD.
  Le faisceau AB a t calcul.
  */
    for (i=0;i<f && fRes;i++)
      {
/*
  Pour chaque ligne i, on calcule sa droite et on calcule ses intersection
avec chaque droite du faisceau AB.
  Une fois ceci fait, on oublie la ligne i et on calcule la ligne i+1.
*/
/* Gi : Point d'(AB) de la ligne i. */
      Gi=vecAB*hyperabs_AB[i]+A;
      if (fAD_Converge)
        {
      /* Cas convergent : la droite de la ligne i passe par Gi et Pfi=PfAD. */
        if (!(droite_PfAD_Gi=TDroite(Pf_AD,Gi)).Existe())
          {
	  fRes=MErreur("Echec au calcul du second faisceau de droites.",1123);
          break; // Sortie boucle locale "for"
          }
        }
      else
        {
      /* Cas non convergent : la droite de la ligne i passe par Gi et
	 est parallle au vecteur Pfi=PfAB qui est vecteur directeur de la
	 direction de fuite. */
        if (!(droite_PfAD_Gi=TDroite(Gi,Pf_AD,DROITE_POINT_VECTEUR)).Existe())
          {
	  fRes=MErreur("Echec au calcul du faisceau de droites.",1110);
          break; // Sortie boucle locale "for"
          }
        }
      for (j=0;j<f;j++)
        {
/* On connat les deux droites des ligne i et colonne j, leur intersection
est le point (i,j). */
/* "cellule": pointeur sur l'chantillonneur de la case (i,j). */
        if (!(M=droite_PfAD_Gi.Intersection(droite_PfAB_H[j])).Existe())
          {
	  fRes=MErreur("Echec au calcul des intersection de faisceaux.",1133);
          break; // Sortie boucle locale imbrique "for"
          }
        else
          fProcessCell(M, i, j, pArg);
        }
      }
    }
  while (FAUX); // Boucle xecute une fois;
  free(droite_PfAB_H);
  free(hyperabs_AD);
  free(hyperabs_AB);
  return fRes;
  }
/* Decoupage_axe_fuyant (dcoupage axe fuyant)
  Calcul des hyperabs. */
char Decoupage_axe_fuyant(
       TVecteur A, TVecteur B, TDroite droite_AB, TVecteur Pf,
       float *hyperabs, char convergence, unsigned int f)
  {
  float HAF=0.0; // Initialisation anti-bogues
  int fwm1d=0;

  if (!droite_AB.Existe())
	 return MErreur("Erreur sur le code",1106);
  if (convergence)
	 {
/* Si (AB) et (CD) convergent, alors les abscisses se calculent selon la
  formule hyperbolique. */
	 if (droite_AB.FaiblePente())
/*
  HAF est l'hyper-abscisse de fuite (anscisse du point de fuite sur (AB);
en valeur algbrique : HAF=APf/AB.
  Utilisation de ABx ou ABy selon l'orientation du vecteur. */
		HAF=(Pf.x-A.x)/(B.x-A.x);
	 else
		HAF=(Pf.y-A.y)/(B.y-A.y);
/*
  "w" est l'abscisse sur le symbole, de 0  1.
  On cherche l'abscisse sur (AB) au centre des cases. Le numro d'une case
vaut f*w-1/2 si w est l'abscisse du centre de la case.
  On appelle fwm1d=f*w-0.5. En consquence, l'abscisse sur le symbole du
centre d'une case vaut (fwm1d +0.5)/f.
*/
	 for (fwm1d=0;fwm1d<f;fwm1d++)
		hyperabs[fwm1d]=(HAF*(fwm1d+0.5))/(fwm1d+0.5+f*(HAF-1.0));
	 }
  else
	 {
/* Pas de convergence, rpartition rgulire. */
    for (fwm1d=0;fwm1d<f;fwm1d++)
      hyperabs[fwm1d]=(fwm1d+0.5)/f;
    }
  return SUCCES;
  }

float DeterminePeriodeSpatialeMin(
        TVecteur A, TVecteur B, TVecteur C, TVecteur D, unsigned int f)
  {
  float ABc, BCc, CDc, DAc, dmin;
  if (!f)
    return 0;
  ABc=A.DistanceCarree(B);
  BCc=B.DistanceCarree(C);
  CDc=C.DistanceCarree(D);
  DAc=D.DistanceCarree(A);
  dmin=min(ABc,min(BCc,min(CDc,DAc)));
  return sqrt(dmin)/f;
  }

/*
void MErreur(char *szMessage,int ref, int value)
  {
  char *MessageLocal;
//  long Nvalue=NfarroundR(value);
  MessageLocal=(char *)malloc(strlen(szMessage)+20);
  wsprintf(MessageLocal,"%s (WANALLEC.CPP)",szMessage);
  if (!value)
    Trace(MessageLocal,ref);
/*
  else if (fabs((float)Nvalue-value)<epsilon)
    Trace(MessageLocal,Nvalue,ref);  *//*
  else
    Trace(MessageLocal,value,ref);
  free(MessageLocal); MessageLocal=NULL; // Initialisation anti alas.
  }
*/
/*
Calcule l'abscisse hyperbolique d'un point sur un axe tant donn cet axe avec son point de fuite, le point donn, et les donnes sur l'axe: origine et popint d'abscisse 1.
*/
float CalcAbscisseHyperbolique(TDroite drAxe, TVecteur xyPf, TVecteur xyM0,
  TVecteur xyM1, TVecteur xyM, int fCV)
  {
  float unit_hyper, abs_hyper_Pf, abs_hyper_M;
  if (!drAxe.Existe()) /* vrification faite dans "PenteDouce". */
    return MErreur("Echec calcul d'abscisse hyperbolique.",799);
  else if (xyM0==xyM1)
    return MErreur("Echec calcul d'abscisse hyperbolique.",801);
  if (fCV)
    {
    if (xyPf==xyM)
      return MErreur("Abscisse hyperbolique infinie.",805);
    if (!drAxe.FaiblePente())
      {
      unit_hyper=xyM1.y-xyM0.y;
      abs_hyper_Pf=(xyPf.y-xyM0.y)/unit_hyper;
      abs_hyper_M=(xyM.y-xyM0.y)/unit_hyper;
      }
    else
      {
      unit_hyper=xyM1.x-xyM0.x;
      abs_hyper_Pf=(xyPf.x-xyM0.x)/unit_hyper;
      abs_hyper_M=(xyM.x-xyM0.x)/unit_hyper;
      }
    return abs_hyper_M*((abs_hyper_Pf-1)/(abs_hyper_Pf-abs_hyper_M));
    }
  else /* Pas de point de fuite. */
    {
    if (!drAxe.FaiblePente())
      return (xyM.y-xyM0.y)/(xyM1.y-xyM0.y);
    else
      return (xyM.x-xyM0.x)/(xyM1.x-xyM0.x);
    }
  }

int CalcAbscisseHyperboliqueDansABCD(TVecteur xyM, TVecteur xyPf,
    TDroite drAB, TDroite drAD, TDroite drBC, int fConverge, float xNorme,
    int fVerrouBF,
    float *pxNh)
  {
  TDroite drMhMb;
  TVecteur xyMh, xyMb, xyAB;
  float xdNh;
  if (fConverge)
    {
    if (!(drMhMb=TDroite(xyM, xyPf)).Existe())
      *pxNh=0; /* xyM=Pf_AB. */
    xyMh=drMhMb.Intersection(drAD);
    xyMb=drMhMb.Intersection(drBC);
    if (!xyMh.Existe() || !xyMb.Existe())
      *pxNh=-1; /* xyM est hors dusymbole (pour quadrilatre non crois). */
    }
  else /* Pas de point de fuite (drAB). */
    {
    if (!(xyAB=drAB.VecteurPorteur()).Existe() ||
        ! (xyMh=drAD.ProjectionPtVect(xyM,xyAB)).Existe() ||
	! (xyMb=drBC.ProjectionPtVect(xyM,xyAB)).Existe() ||
	! (drMhMb=TDroite(xyMh,xyMb)).Existe()
       )
      return MErreur("Harre Krishna (dans les intersections).",682);
    }
// *pxNh: abscisse hyperbolique raporte  la frqeunce.
  if (xyMh.Existe() && xyMb.Existe() && drMhMb.Existe() && xyPf.Existe())
    *pxNh=CalcAbscisseHyperbolique(drMhMb, xyPf, xyMh,xyMb,xyM,fConverge)*xNorme;
// Analyse de la valeur
  xdNh=*pxNh-NFloorR(*pxNh);  // Partie dcimale
  if (fVerrouBF && (xdNh<0.33 || xdNh > 0.67)) // abscisse proche d'une abscisse entire
    *pxNh=-1;  // Rejet de la valeur.
  if (*pxNh<0)
    *pxNh=-1;
  else if (*pxNh > xNorme)
    *pxNh=xNorme+1.0;
  Trace("Calcul d'xNh :",*pxNh, 664);
  return SUCCESS;
  }
