/**********************************************************************/
/*                       W I R I S       . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fonctions conversationnelles pour Iris         */
/*                                                                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste MARCEL       			      	       */
/*    Dvelopp le   : Printemps 1996                                 */
/*    Dernire modif.: voir date fichier                              */
/**********************************************************************/
/*
// Inclusions bibliothques standards
#include <math.h>
#include <values.h>
*/
//  Inclusions bibliothques Object Windows
#include <owl\applicat.h>
#include <owl\controlb.h> /*
#include <owl\button.h> /* NCtrl *//*
#include <owl\dc.h> */
#include <owl\decframe.h>  /*
#include <owl\dialog.h>    */
#include <owl\framewin.h>    /*
#include <owl\gadgetwi.h> /* NCtrl *//*
#include <owl\inputdia.h> */
#include <owl\menu.h>
#include <owl\opensave.h>   /*
#include <owl\owlpch.h>
#include <owl\point.h> /* NCtrl *//*
#include <owl\scrollba.h>
#include <owl\radiobut.h>
#include <owl\scroller.h>
#include <owl\static.h>  */
#include <owl\statusba.h>
#include <owl\textgadg.h>
                            /*
// Inclusions bibliothques DOS
#include <stdio.h> /* NCtrl *//*
#include <dir.h> /* NCtrl *//*
*/
// Inclusion bibliothques Image
#include "wappbase.h"
/*#include "wgttsi.h"
#include "wlfilt.h" /* NCtrl *//*
#include "wlmodif.h" /* NCtrl *//*
#include "wmain.h"
*/
//  Inclusions bibliothques Iris
#include "base.h" /*
#include "wmathdiv.h"
#include "wsymbole.h"

#include "sysctr.h" */
#include "wiris.h"
#include "wirisder.h"
/*
#include "wiris.rc"
#include "wcontour.h"
/*-----------------------------------------------------------------------*/
/*                     Constantes locales                                */
/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*                     Classes locales                                   */
/*-----------------------------------------------------------------------*//*
/*-----------------------------------------------------------------------*/
/*                     Variables globales                                */
/*-----------------------------------------------------------------------*/
TFenIrisNouvelle *pFenetreIrisNouvelle;
TAppIrisNouvelle *pApplicationIrisNouvelle;
TCadIrisNouvelle *pCadreIrisNouvelle;
/*-----------------------------------------------------------------------*/
/*                     Classe Fenetre (TFenIris)                         */
/*--Systme--------------------------------------------------------------*/
TFenIrisNouvelle::TFenIrisNouvelle():TFenIris()
  {
  pFenetreIrisNouvelle=this;
  }
/*-----------------------------------------------------------------------*/
/*                     Classe application (TAppIris)                     */
/*--Systme--------------------------------------------------------------*/
TAppIrisNouvelle::TAppIrisNouvelle() : TAppIris()
	 {
    pApplicationIrisNouvelle=this;
	 }

TAppIrisNouvelle::~TAppIrisNouvelle()
	 {
	 }

void TAppIrisNouvelle::InitMainWindow()
  {
  new TCadIrisNouvelle(NULL,TitreApplication,new TFenIrisNouvelle,TRUE);
  TAppIris::InitMainWindow();
  }
/*-----------------------------------------------------------------------*//*
/*                     Classe Cadre (TCadIris)                           *//*
/*--Systme--------------------------------------------------------------*/
TCadIrisNouvelle::TCadIrisNouvelle(TWindow *Parent, char far *Title, TWindow *Client,
                   BOOL trackMenuSelection)
    : TCadIris (Parent, Title, Client, trackMenuSelection)
  {
  pCadreIrisNouvelle=this;
  }
/*-----------------------------------------------------------------------*//*
/*                     Classe Fenetre (TFenIris)                         *//*
/*--Nouvelles fonctionalits---------------------------------------------*//*
/*-----------------------------------------------------------------------*//*
/*                     Classe application (TAppIris)                     *//*
/*--Nouvelles fonctionalits---------------------------------------------*//*
/*-----------------------------------------------------------------------*//*
/*                     Classe Cadre (TCadIris)                           *//*
/*--Nouvelles fonctionalits---------------------------------------------*//*
/*-----------------------------------------------------------------------*//*
/*       						Programme OwlMain                             *//*
/*-----------------------------------------------------------------------*/
int OwlMain(int /*argc*/, char* /*argv*/ [])
{
  if (DemarrageCarte())
    {
    strcpy(TitreApplication,"Iris - Analyse de codes symboliques");
    strcpy(TexteAbout,"Version : 1996\n\nAuteur : Baptiste MARCEL");
    return TAppIrisNouvelle().Run();           // Lancement du programme
    }
  else
    return 0;
}
/*-----------------------------------------------------------------------*//*
/*       						Fonctions  exporter                          *//*
/*-----------------------------------------------------------------------*/





