#include "baptiall.h"
#include "cattoall.h"
#pragma hdrstop

#define MODULE_NAME "WIRSPICK.CPP"
////////////////////////////////////////////////////////////////////////
//                      WIRSPICK
//                      Regroupe les fentres de type pickup.
////////////////////////////////////////////////////////////////////////
//    Auteur         : Baptiste MARCEL
//    Dvelopp le   : Printemps 1996
//    Dernire modif.: voir date fichier
////////////////////////////////////////////////////////////////////////
/*
// Inclusions bibliothques standards
#include <stdio.h>
#include <dir.h>
/*#include <io.h>
#include <math.h>
#include <values.h>

//  Inclusions bibliothques Object Windows
#include <owl\applicat.h>
#include <owl\inputdia.h>
#include <owl\combobox.h>
#include <owl\scroller.h>
*/
/*
#include <owl\dc.h>
#include <owl\dialog.h>
#include <owl\edit.h>
#include <owl\framewin.h>
#include <owl\inputdia.h>
#include <owl\static.h>

#include <osl\geometry.h>
/*

// Inclusions bibliothques DOS
#include <stdio.h>

// Inclusion bibliothques Image
*//*
#include "wsysutil.h"
#include "wappbase.rh"
#include "wappbase.h"
#include "wgttsi.h"
#include "wmain.h"

*/
//  Inclusions bibliothques Iris
//#include "wanlfreq.h"
//#include "wanallec.h"
#include "base.h"
#include "sysctr.h"
/*#include "wcontour.h"
*/
#include "iris.rc"
#include "piadiv.h"
#include "scaltool.h"
#include "strutil.h"
#include "wgeometr.h"
#include "wirspick.h"
#include "wiris.h"
#include "wirsutil.h"
#include "wsystool.h"



//  Inclusions bibliothques Sbastien
 #include "ctxoutil.h"

//-----------------------------------------------------------------------
//BOOL Eirspick(char *szMessage="",int ref=0);
unsigned char TPickupPolygone::uLargeurAffichagePolygone=0;

/////////////////////////////////////////////////////////////////////////
//                   Nouvelle classe TPickupPolygone
////Systme//////////////////////////////////////////////////////////////
DEFINE_RESPONSE_TABLE1(TPickupPolygone, TAssociatif)
  EV_COMMAND_AND_ID(CM_PK_ChargePolygone, CmMenuEnvironnement),
  EV_COMMAND_AND_ID(CM_PK_SauvegardePolygone, CmMenuEnvironnement),
  EV_COMMAND_AND_ID(CM_PQ_TracePolygone, CmMenuEnvironnement),
  EV_COMMAND_AND_ID(CM_PQ_ExportPolygone, CmMenuEnvironnement),
  EV_COMMAND_AND_ID(CM_PQ_ImportPolygone, CmMenuEnvironnement),

  EV_COMMAND(CM_NouveauPoint, NouveauPoint),
  EV_COMMAND(ID_PK_St+0, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+1, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+2, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+3, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+4, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+5, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+6, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+7, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+8, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+9, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+10, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+11, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+12, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+13, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+14, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+15, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+16, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+17, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+18, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+19, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+20, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+21, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+22, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+23, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+24, ModificationCoordonnee),
  EV_COMMAND(ID_PK_St+25, ModificationCoordonnee),
END_RESPONSE_TABLE;

//TPickupPolygone *pPickupPolygone=NULL;
#if 0
void Ev_ClicForceDragNouveauPoint(TPoint &pt,int etatsouris)

  {
#if 0
  if (etatsouris & 0/*SOURIS_DOWN_BG*/)
    TAffimPtr[0]->EvLButtonDown(0,pt);
  else
#endif
    Ev_ClicNoDragNouveauPoint(pt,etatsouris);
  }
#endif
extern int fAutoSouris;
#pragma ("prototype provisoire")
TPickupPolygone::TPickupPolygone(TWindow* parent, char szTitre[],
    unsigned char uNbPoints_in, char *szLibellePolygone_in, char cType)
  : TAssociatif(parent, szTitre,cType),
    rAffichagePolygone(CoordonneeErreur,CoordonneeErreur)
  {
//  pPickupPolygone=this;
//  fAutoSouris=0;
  picn=new TIcon(*GetApplication(), "UBI_DM_SCAN" );
  fShowPolygon=fShowMenu=fLinkAffim=TRUE; // Default is TRUE (inhibition flags).
  uLargeurAffichagePolygone=11*uLargeurCar;
  uNbPoints=uNbPoints_in;
  if (!uNbPoints)
    ShutDownWindow();
  apstAffichagePolygone=(TEditCR **)malloc(uNbPoints*sizeof(TEditCR *));
  for (unsigned char u=0;u<uNbPoints;u++)
    apstAffichagePolygone[u]=new TEditCR(this,ID_PK_St+u,"",0,0,
        uLargeurAffichagePolygone-2*uLargeurCar,uHauteurEdit,16);
  aptPolygone=(TCoordonnee *)malloc(uNbPoints*sizeof(TCoordonnee));
  strcpy(szLibellePolygone,szLibellePolygone_in);
  GetPrivatePolygon(aptPolygone,uNbPoints,Title, szLibellePolygone,
      CoordonneeErreur, szINIFileName); // If no polygon specified, their value is "CoordonneeErreur"
  SetAffichagePolygone(SW_HIDE,CoordonneeErreur);

  Ajoute_Fonction(Ev_ClicNoDragNouveauPoint,GEO_DROITE,RETIC,this);   // wmain
  }

void TPickupPolygone::SetupWindow()
  {
  TAssociatif::SetupWindow();
  if (PolygoneExiste(aptPolygone,uNbPoints))
    NouveauPolygone();
  }
void TPickupPolygone::GenereMenuFlottant(TPopupMenu *pmnuFlot)
  {
  TAssociatif::GenereMenuFlottant(pmnuFlot);
  if (pmnuFlot && fShowMenu)
    {
    char sz[USUALMAXLENSTRING];
    wsprintf(sz,"&Charge %s",szLibellePolygone);
    pmnuFlot->AppendMenu(MF_STRING, CM_PK_ChargePolygone, sz);
    wsprintf(sz,"&Sauvegarde %s",szLibellePolygone);
    pmnuFlot->AppendMenu(MF_STRING, CM_PK_SauvegardePolygone, sz);
    wsprintf(sz,"&Trace %s",szLibellePolygone);
    pmnuFlot->AppendMenu(MF_STRING, CM_PQ_TracePolygone, sz);
    wsprintf(sz,"&Exporte %s",szLibellePolygone);
    pmnuFlot->AppendMenu(MF_STRING, CM_PQ_ExportPolygone, sz);
    wsprintf(sz,"&Importe %s",szLibellePolygone);
    pmnuFlot->AppendMenu(MF_STRING, CM_PQ_ImportPolygone, sz);
    }
  }
void TPickupPolygone::Paint(TDC& dc, BOOL erase, TRect& rect)
  {
  TAssociatif::Paint(dc,erase,rect);
  dc.SetBkMode(TRANSPARENT);
  char sz[3]="A:\0";
  if (fShowPolygon)
    for (unsigned char u=0;u<uNbPoints;u++)
      {
      *sz='A'+u;
      dc.TextOut(rAffichagePolygone.TopLeft().OffsetBy(0,u*uHauteurEdit
               +uDLE),sz);
      }
  }
TPickupPolygone::~TPickupPolygone()
  {
  TRect rInvalidated;
  AcquisitionPolygone(aptPolygone,uNbPoints, CoordonneeErreur,source,
      &rInvalidated);
  if (!IsPoint(rInvalidated))
    rInvalidated.Inflate(1,1);
  if (TAffimPtr[0])
    TAffimPtr[0]->InvalidateRect(rInvalidated,false);
  free(aptPolygone);
  delete picn;
//  pPickupPolygone=NULL;
  Enleve_Fonction(this);   // wmain
  }
char *TPickupPolygone::GetClassName()
  {
  return "TPickupPolygone";
  }
void TPickupPolygone::GetWindowClass( WNDCLASS& wc )
  {
  TAssociatif::GetWindowClass( wc );
  wc.hIcon=*picn;
  }

//--Nouvelles fonctionalits---------------------------------------------
void TPickupPolygone::SetAffichagePolygone(int cmdShow,
    TPoint ptAffichagePolygone)
  {
  if (TCoordonnee(ptAffichagePolygone).Existe())
    {
    rAffichagePolygone.Set(ptAffichagePolygone.x,ptAffichagePolygone.y,
                         ptAffichagePolygone.x+uLargeurAffichagePolygone,
                         ptAffichagePolygone.y+uHauteurEdit*uNbPoints);
    for (unsigned char u=0;u<uNbPoints;u++)
      {
      apstAffichagePolygone[u]->Attr.X=ptAffichagePolygone.x+2*uLargeurCar;
      apstAffichagePolygone[u]->Attr.Y=ptAffichagePolygone.y+u*uHauteurEdit;
      }
    }
  else
    {
    rAffichagePolygone.SetNull();
    }
  for (unsigned char u=0;u<uNbPoints;u++)
    apstAffichagePolygone[u]->Show(fShowPolygon?cmdShow:SW_HIDE);
  }
void TPickupPolygone::CmMenuEnvironnement(WPARAM id)
  {
  switch (id)
    {
    case CM_PK_SauvegardePolygone:
      WritePrivatePolygon(Title,szLibellePolygone,aptPolygone,
          uNbPoints,szINIFileName);
      break;
    case CM_PQ_ExportPolygone:
      WritePrivatePolygon("general data",szLibellePolygone,aptPolygone,
          uNbPoints,szINIFileName);
      break;
    case CM_PK_ChargePolygone:
      GetPrivatePolygon(aptPolygone,uNbPoints,Title, szLibellePolygone, CoordonneeErreur, szINIFileName);
//      if (PolygoneExiste(aptPolygone,uNbPoints))
        NouveauPolygone();
/*      else
        fConsistance=0; */
      break;
    case CM_PQ_ImportPolygone:
      GetPrivatePolygon(aptPolygone,uNbPoints,"general data", szLibellePolygone, CoordonneeErreur, szINIFileName);
//      if (PolygoneExiste(aptPolygone,uNbPoints))
        NouveauPolygone();
/*      else
        fConsistance=0; */
      break;
    case CM_PQ_TracePolygone :
      {
      Copie_plan(source,destin);
      BOOL f;
      if (uNbPoints==2 && aptPolygone)
        f=DessineLigne(source,TBipoint(aptPolygone[0],aptPolygone[1]),destin);
      else
        f=DessinePolygone(source,aptPolygone,uNbPoints,destin,POLY_FERME);
      if (f)
        {
        Calsuiv();
        sprintf(TableFich[plan],"%.40s (avec %s)",TableFich[(plan-1)%nbplan],szLibellePolygone);
        Fenetre->Visim(this,0,source);
        }
      break;
      }
    default :
      ErreurCode(1174);
    }
  }
void TPickupPolygone::NouveauPolygone()
  {
//  Trace("TPickupPolygone::NouveauPolygone");
  AfficheValPolygone(aptPolygone,uNbPoints,(TStatic **) apstAffichagePolygone);
  }
void TPickupPolygone::ModificationCoordonnee()
  {
  ReleveValPolygone(aptPolygone,uNbPoints,
      (TStatic **)apstAffichagePolygone);
  if (PolygoneExiste(aptPolygone,uNbPoints))
    NouveauPolygone();
  }

void TPickupPolygone::NouveauPoint()
  {
  TRect rInvalidated;
  if (!fLinkAffim)  // Inhibated
    return;
  AcquisitionPolygone(aptPolygone,uNbPoints,TCoordonnee(posx,posy),source,
      &rInvalidated);
  if (!IsPoint(rInvalidated))
    rInvalidated.Inflate(1,1);
  if (TAffimPtr[0])
    TAffimPtr[0]->InvalidateRect(rInvalidated,false);
  if (PolygoneExiste(aptPolygone,uNbPoints))
    NouveauPolygone();
/* L'affichage AfficheValPolygone est ralis par NouveauPolygone dans ce
  cas. */
  else
    AfficheValPolygone(aptPolygone,uNbPoints,(TStatic **) apstAffichagePolygone);
  }

/*--Classe TPickupPoint---------------------------------------------------*/
TPickupPoint::TPickupPoint(char szTitre[], char cType)
  : TPickupPolygone(Fenetre, szTitre,1,"point",cType),
    pM(CoordonneeErreur)
  {
  }

void TPickupPoint::NouveauPolygone()
  {
  TPickupPolygone::NouveauPolygone();
  if (PolygoneExiste(aptPolygone,uNbPoints))
    pM=aptPolygone[0];
  }
/*--Classe TPickupLine---------------------------------------------------*/
TPickupLine::TPickupLine(TWindow* parent, char szTitre[], char cType, TLigne lgn_)
  : TPickupPolygone(parent, szTitre,2,"ligne",cType),
    lgn(CoordonneeErreur,CoordonneeErreur)
  {
  aptPolygone[0]=lgn_.A;
  aptPolygone[1]=lgn_.B;
  }

void TPickupLine::NouvelleLigne()
  {
  }
void TPickupLine::NouveauPolygone()
  {
  TPickupPolygone::NouveauPolygone();
//  AcquisitionLigne(&lgn,TCoordonnee(posx,posy));
  if (PolygoneExiste(aptPolygone,uNbPoints))
    {
    lgn.A=aptPolygone[0];
    lgn.B=aptPolygone[1];
    NouvelleLigne();
    }
  }
//-----------------------------------------------------------------------
//                   Nouvelle classe TPickupQuad
//--Systme--------------------------------------------------------------
TPickupQuad::TPickupQuad(TWindow* parent, char szTitre[], char cType)
  : TPickupPolygone(parent, szTitre,4,"ABCD",cType),
    ABCD(CoordonneeErreur,CoordonneeErreur,CoordonneeErreur,CoordonneeErreur)
  {
  }

void TPickupQuad::NouveauPolygone()
  {
  TPickupPolygone::NouveauPolygone();
/*  if (PolygoneExiste(aptPolygone,uNbPoints))
    {*/
    ABCD.A=aptPolygone[0];
    ABCD.B=aptPolygone[1];
    ABCD.C=aptPolygone[2];
    ABCD.D=aptPolygone[3];
    NouveauQuad();
//    } 
  }

//--Nouvelles fonctionalits---------------------------------------------
void TPickupQuad::NouveauQuad()
  {
  }
//-----------------------------------------------------------------------
//      		   Fonctions hors classes
//-----------------------------------------------------------------------
/*-------------------------------------------------------------*/
void ReleveValPoint(TPoint *pptValue, TStatic *pstEtiquette)
  {
  if (!pstEtiquette || !pptValue)
    return;
  char szTamp0[64];
  pstEtiquette->GetText(szTamp0,sizeof(szTamp0));
  if (GetIntegerList(szTamp0,(int *)pptValue, 2)!=2)
    *pptValue=CoordonneeErreur;
  AfficheValPoint(*pptValue, pstEtiquette);
  }

void AfficheValPoint(TPoint ptValue, TStatic *pstEtiquette)
  {
  if (!pstEtiquette)
    return;
  else if (TCoordonnee(ptValue).Existe())
    {
    char szTamp0[64];
    wsprintf(szTamp0,"%d;%d",ptValue.x,ptValue.y);
    pstEtiquette->SetText(szTamp0);
    }
  else
    pstEtiquette->Clear();
  }
void AfficheValPoint(TPoint ptValue, TPoint ptPosition, TDC& dc, char cNom)
  {
  char szTamp0[USUALMAXLENSTRING];
  if (TCoordonnee(ptValue).Existe())
    wsprintf(szTamp0,"%c:%d;%d",cNom,ptValue.x,ptValue.y);
  else
    wsprintf(szTamp0,"%c",cNom);
  dc.TextOut(ptPosition,szTamp0);
  }
void AfficheValLigne(TLigne lgn, TPoint ptPos, TDC& dc)
  {
  AfficheValPoint(lgn.A,ptPos,dc,'A');
  AfficheValPoint(lgn.B,ptPos.OffsetBy(0,uHauteurLigne),dc,'B');
  }
void AfficheValQuad(TQuadrilatere ABCD, TPoint ptPos, TDC& dc)
  {
  AfficheValPoint(ABCD.A,ptPos,dc,'A');
  AfficheValPoint(ABCD.B,ptPos.Offset(0,uHauteurLigne),dc,'B');
  AfficheValPoint(ABCD.C,ptPos.Offset(0,uHauteurLigne),dc,'C');
  AfficheValPoint(ABCD.D,ptPos.Offset(0,uHauteurLigne),dc,'D');
  }

void AfficheValPolygone(TCoordonnee *aptPolyg, unsigned char uNbPoints,
    TPoint ptPos, TDC& dc)
  {
  if (!aptPolyg)
    return;
  for (unsigned char u=0;u<uNbPoints;u++)
    AfficheValPoint(aptPolyg[u],ptPos.OffsetBy(0,u*uHauteurLigne),dc,'A'+u);
  }
void AfficheValPolygone(TCoordonnee *aptPolyg, unsigned char uNbPoints,
    TStatic **apstAffichagePolygone)
  {
  if (!aptPolyg || !apstAffichagePolygone)
    return;
  for (unsigned char u=0;u<uNbPoints;u++)
    AfficheValPoint(aptPolyg[u],apstAffichagePolygone[u]);
  }
void ReleveValPolygone(TCoordonnee *aptPolyg, unsigned char uNbPoints,
    TStatic **apstAffichagePolygone)
  {
  if (!aptPolyg || !apstAffichagePolygone)
    return;
  for (unsigned char u=0;u<uNbPoints;u++)
    ReleveValPoint(aptPolyg+u,apstAffichagePolygone[u]);
  }


