/**********************************************************************/
/*                       W G T T S I . H		                      	 */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le          */
/*                     traitement d'images                            */
/*--------------------------------------------------------------------*/
/*    Auteur         : MC 		               			      	       */
/*    Dvelopp le   : 13/11/1995                                     */
/*    Dernire modif.: 02/01/1998                                     */
/**********************************************************************/
#if !defined(WGTTSI_H)
#define WGTTSI_H

extern void far Inicarte(void);
extern void far Inivsc(void);
extern void far Inipia(void);
extern void far Regplan(void);
extern int far Iniimage(int nbplan2=8);
extern int far Acmn(unsigned char far *pointim);
extern int far Atim(void);
extern void far Transfert(unsigned char far *image);
extern void far Eff(unsigned char far *image);
extern void far Mirexy(char c,unsigned char far *image);
extern void far Histo(unsigned int bufhist[256],unsigned int bufrepa[256],
			unsigned char far *ptsource=0);
extern void far Vishist(unsigned int bufhist[256],unsigned int bufrepa[256],
			unsigned char far *ptdestin=0);
extern void far Calhist(unsigned int bufhist[256],unsigned int bufrepa[256],
		unsigned char far *image);
extern void far Seuillage(int seuil,unsigned char far *ptsource=0,
		unsigned char far *ptdestin=0);
extern void far Calplans(void);
extern void far Calsuiv(void);
extern void far Copie_plan(unsigned char far *ptsource,
						unsigned char far *ptdestin);
extern int far WMN(char nomfich[20],unsigned char far *);
extern int far RMN(char nomfich[20],unsigned char far *);
extern void far Transcoul(void);
extern void far Hiscou(char c);
extern int far Ecr_bmp(char nomfich[20],unsigned char far *image);
extern float far Variance_courbe(unsigned char *x,long taille);
extern float far Moyenne_courbe(unsigned char *x,long taille);
extern void far Negatif(unsigned char far *ptsource=0,unsigned char far *ptdestin=0);
extern void far Rotat(float angle,int xcent,int ycent,float grandx,float grandy,
			char type,unsigned char far *ptsource=0,unsigned char far *ptdestin=0);
extern void far Droite(int x0,int y0,int x1,int y1,unsigned char far *pointim,
		int msk);
extern void far Un_rect(int xmin,int xmax,int ymin,int ymax,int msk,
				unsigned char far *image);
extern void far Zero_rect(int xmin,int xmax,int ymin,int ymax,int msk,
				unsigned char far *image);
extern void far Remp_rect(int xmin,int xmax,int ymin,int ymax,int z,
				unsigned char far *image);
extern void far Trfen(int xmin,int xmax,int ymin,int ymax,int msk,
		unsigned char far *image);
extern void far Trfret(unsigned char far *image,int xretic,int yretic);
extern void far Stat_image(unsigned char far *ptsource=0);
extern void far Min_max(unsigned char *x,int *min,int *max,long taille);
extern void far Cooccurence(int depx,int depy,unsigned char far *ptsource=0,
unsigned char far *ptdestin=0);
extern void far Covariance(float cov[8][8],int taille,unsigned char far *ptsource=0);
extern void far Opera(char c,unsigned char far *ptsource=0,
unsigned char far *ptdestin=0);
extern void far Correction(unsigned char far *ptsource=0,
unsigned char far *ptdestin=0);
extern int far Lec_bmp(char nomfich[20],unsigned char far *image);
extern long far Caltime(void);
extern void far delay100(unsigned int temp);
extern int far Testacq(void);
extern unsigned char *PlanSuiv(unsigned char *puCourant, char cN=1);
extern unsigned char DemarrageCarte(int nbplan2=8);
extern void Calsuiv(char cN);
extern int far Acqui(void);
extern void far Initabret(int tabx[9],int taby[9]);
unsigned char far *Adresseplan(char c);
char Numeroplan(unsigned char *plan);
int far Testvoie(int voie);
void Reset_carte(void);

/**********************************************************************/

extern unsigned char *image0;          /* zone image0 */
extern unsigned char *image1;          /* zone image1 */
extern unsigned char *image2;          /* zone image2 */
extern unsigned char *image3;          /* zone image3 */
extern unsigned char *image4;          /* zone image4 */
extern unsigned char *image5;          /* zone image5 */
extern unsigned char *image6;          /* zone image6 */
extern unsigned char *image7;          /* zone image7 */

extern unsigned char *source;          /* pointeur source */
extern unsigned char *destin;          /* pointeur destination */

extern int piax;		/* Adresse PIA          */
extern int piay;
extern int piaze;
extern int piazs;

extern int modseq;
extern int presacq;

extern int modvis;		/*  mode de visualisation  */
extern int modsor;   	     	/*  mode de sortie         */
extern int modcoul;  	     	/*  N-B ou couleur         */
extern int visnb;               /*  Visu NB                */
extern int parite;  		/*  commande acquisition   */
extern int voiecam;		/*  numro voie camra     */
extern int nbint;        	/* nombre d'intgrations   */
extern int camcoul;             /* prsence camra couleur */
extern int connex; 	   	/* Type de connexit       */

extern int plan;		/*  plan courant           */
extern int planvis;             /*  plan visualis         */
extern int plantrav;            /*  plan accd en visu    */
extern int nbplan;       /* nb. de plans allous */

extern float moy_image;          /* statistique des images 	     */
extern float ec_type_image;
extern float entropie_image;
extern int min_image;
extern int max_image;

extern unsigned int bufhist[],bufrepa[];
extern float cov[8][8];
													  // Pour geom
extern int xcent,ycent;
extern float angle,grandx,grandy;
extern char typeinter;
extern struct ftime ft,tc;            // date & heure

/**********************************************************************/
#endif  //WGTTSI_H
