/*----------------------------------------------*/
/*		Procdures du programme         	   		*/
/*                    WLCARPRO.CPP             */
/*----------------------------------------------*/
// 21/06/96
#if !defined(WLCARPRO_H)
#define WLCARPRO_H

#define PI 3.14159
#define RAC2 1.414

typedef struct {int xmin,xmax,ymin,ymax,nbtrous,longueur,largeur;
		long sur,cgx,cgy,mu11,mu20,mu02,mu12,mu21,mu03,mu30;
		float per,compac,orien,t_concav;
		double n11,n20,n02,n12,n21,n30,n03,q1,q2,q3,q4,q5,q6;
		} car_obj;

extern unsigned long far tabsur[256];               // Table de surfaces
extern unsigned long far tabcgx[256],tabcgy[256];   // Tables C.G.
extern unsigned char far tabxmi[256],tabxma[256],   // Rect. d'encadrement 				  tabymi[256],tabyma[256];
				  tabymi[256],tabyma[256];
extern int far tabtrous[256];                       // Table Nb de trous
extern int eti,dep;                             // Etiquette, dpas.
extern int nbobj;                               // Nombre d'objets
extern int nbtrous;                             // Nombre de trous
extern int totaltrous;                          // Nb total de trous
extern int far taboeg[256],taboed[256];    			  // Obj. equ.
extern int far tabpceg[256],tabpced[256];  			  // PCE
extern int xmin,xmax,ymin,ymax;                 // Pour rectangle
extern unsigned int Nb_cont;                    // Nb de pts de contour

extern car_obj OBJ,EC;                          // Structures objet
extern car_obj *obj,*ec;

extern int far TABX[2048],TABY[2048];  /* Tables coordonnes contour extrieur */
extern char far TABSOM[2048];	    /* Table des sommets    */
extern long seuil_dis;              /* Seuil distance 	    */

extern unsigned int far Perim(int xmi,int xma,int ymi,int yma,float *per,int msk);
extern void far Surf(int xmin,int xmax,int ymin,
	    int ymax,long *sur,long *cgx,long *cgy,int msk);
extern void far Const_Obj(int xmin,int xmax,int ymin,
	    int ymax,int eti,int msk);
extern void far Const_Obj_Equ(int xmin,int xmax,int ymin,int ymax,int msk,
	int taboeg[256],int taboed[256]);
extern void far Decod_Seg(int ymin,int ymax,int msk,
	int tabg[256],int tabd[256]);
extern void far Const_Pce(int ymin,int ymax,
	int taboeg[256],int taboed[256],
	int tabpceg[256],int tabpced[256]);
extern void far Moments(car_obj *obj,int msk);
extern void far Moments_gen(car_obj *obj);
extern void far Const_Concav(int xmin,int xmax,int ymin,
	    int ymax,int msk1,int msk2,int msk3);
extern void far Cal_orien(car_obj *obj);
extern void far Conto(int xmi,int xma,int ymi,int yma,int msk,int msk2);
extern unsigned int far Constab_context(car_obj *obj,int msk,
			unsigned char far *image,int TABX[],int TABY[],
			int connex,float *per_ext);
extern void far Decod_context(int tabx[],int taby[],unsigned char far *image,
		int msk,unsigned int Nb);
extern void far Cal_l_h_rectmin(car_obj *obj,unsigned int Nb,
			int TAB_X[],int TAB_Y[]);
extern long far Dist_max(int i,int j,int *k);
extern void far Remp_tabsom(int Nb);
extern void far Decoup_tabsom(int i,int j);
extern unsigned int far Cal_nbsom(unsigned int Nb);
extern unsigned int far Decod_tabsom(unsigned char far *image,
		int msk,unsigned int Nb);
extern unsigned int far Decod_som(unsigned char far *image,
		int msk,unsigned int Nb);
extern void far Const_Tab_Inter(int TAB[], unsigned int Nb_cont,
				unsigned int Nb_interp,float *TAB1);
extern int far Erod(int xmin,int xmax,int ymin,int ymax,int num,int msk1,int msk2);
extern void far Const_squel(int xmin,int xmax,int ymin,int ymax,int msk1,int msk2);

//----------------------------------------------------------------------------
#endif  //WLCARPRO_H
