/*----------------------------------------------*/
/*																*/
/*		Procdures du programme         				*/
/*                    WLCOMP.C                  */
/*																*/
/*----------------------------------------------*/
#if !defined(WLCOMP_H)
#define WLCOMP_H

#define TAILBUF1 65535U      	/* Taille du buffer de codes */

typedef struct {
					char run;
					int level;
					}
					event;


extern float C[8][8],Base[8][8];      // matrices de base   C=(Base) T
extern long Cint[8][8],Baseint[8][8]; // matrices de base   Cint=(Baseint) T
extern long Q[8][8];           		 // matrice de quantif
extern int Z[64];                     // indices du zig-zag
extern int Statac[16][16],Statdc[16];  	  // Statistique des vnements
extern int Tabac0[16][16],Tabdc0[16];   // Tableaux de longueur de code

extern long far Compress(char modcal,int qualite,
						unsigned char far *ptsource=0,unsigned char far *ptdestin=0);
extern void far Inicoeff(void);
extern void far Iniquant(int qualite);
extern void far Mulmat(float X[8][8],float Y[8][8],float Z[8][8]);
extern void far Fdct1(float im[8][8],float tcos[8][8],float C[8][8],float Base[8][8]);
extern void far Idct1(float im[8][8],float tcos[8][8],float C[8][8],float Base[8][8]);
extern void far Transpmat(float X[8][8],float Y[8][8]);
extern void far Mulmatint(long X[8][8],long Y[8][8],long Z[8][8]);
extern void far Transpmatint(long X[8][8],long Y[8][8]);
extern void far Fdctint1(long imint[8][8],long tcosint[8][8],long Cint[8][8],
		long Baseint[8][8]);
extern void far Idctint1(long imint[8][8],long tcosint[8][8],long Cint[8][8],
		long Baseint[8][8]);
extern void far Divmatint(long X[8][8]);
extern void far Dequant(long coeff[8][8],float tcos[8][8],long Q[8][8]);
extern void far Quantif(long coeff[8][8],float tcos[8][8],long Q[8][8]);
extern void far Quantifint(long coef[8][8],long tcosint[8][8],long Q[8][8]);
extern void far Dequantint(long coef[8][8],long tcosint[8][8],long Q[8][8]);
extern char far Codzz(long coef[8][8],event *tabev,
	  unsigned int *nbit,int *pred);
extern void far Decodzz(long coef[8][8],event *tabev,int *pred,char nbcouple);
extern void far Razstat(void);

extern unsigned int far Code_dct(char modcal,int qualite,unsigned char far *image,unsigned char *tabcode);
extern void far Decode_dct(char modcal,int qualite,unsigned char far *image,unsigned char *tabcode);

//----------------------------------------------------------------------------
#endif  //WLCOMP_H
