/*******************|*******************************************/
/*                  W C R T X T F C . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Outils de travail sur caractres,       */
/*                     chanes de caractres et fichiers.      */
/*                                                             */
/* Fichier prototype WCRTXTFC.H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : hivers 1994/1995                        */
/***************************************************************/

#include <stdio.h>
#include "base.h"
/*-------------------------------------------------------------*/
/*			   constantes                                         */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	            prototypes de variables                         */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*	            prototypes de fonctions                         */
/*-------------------------------------------------------------*/
int LigneOiseuse (char *ligne);
char *fgetlline(FILE *canal, int limite);
char *fgetlaline(FILE *canal, int limite, char *ligne);
char *fgetslline(FILE *canal, int limite);
char *fgetltext(FILE *canal, int limite);
char *fgetlaltext(FILE *canal, unsigned int limite, char *texte);
char *fgetlltext(FILE *canal, int limite);
char *fGetLineContaining(FILE *pfilSource, char *sz, unsigned int wLen,
    char *szMark);
int fcontchar(FILE *canal);
int fcontcharline(FILE *canal);
int fcontline(FILE *canal);
int StatFile(char *szFile, unsigned long *pdwNbChar,
      unsigned long *pdwNbLine, unsigned long *pdwNbMaxCharPerLine);
int StatFile(FILE *pFileStream, unsigned long *pdwNbChar,
      unsigned long *pdwNbLine, unsigned long *pdwNbMaxCharPerLine);
unsigned long CountRealChar(FILE *canal);
unsigned long CountRealCharCR(FILE *canal);
//void intgcvt (int n, int taille, char *mot);

// Utiliser fnsplit et fnmerge.

//BIT nom_fichier_conforme(char *szFileName);
//BIT chem_nom_fichier_conforme(char *chemin_nom);
//BIT Extension_nom_etendu_est(char *nom_chemin_fichier,char *extension);
int IsFileExtension(char *szFileName,char *szExtension);
int SetFileExtension(char *szFileName,char *szExtension, unsigned int wLen); // protected
void SetFileExtension(char *szFileName,char *szExtension);
int SplitTextFile(char *szSource, unsigned int wSplit /* Number of parts */,
    unsigned long *pdwNbMaxCharPerLine=NULL);
char *SplitTextFileTellFileName(
  char *szSource,
  unsigned int wNumber,
  char *szSlice); // Tell the filename of the part to process
int SplitINITextFile(char *szSource, unsigned int w);// idem SplitTextFile but for INI files

/*char Extension_est(char *nom_fichier,char *extension):
char chem_nom_fichier_conforme(char *chemin_nom);
char *Extrait_nom_fichier(char *nom_chemin_fichier);
char Modifie_extension(char *nom_chemin_fichier, char *extension);
*/
