#error Obsolete: use wsysutil instead.
/*******************|*******************************************/
/*                  W I N U T I L   . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Outils graphiques                       */
/*                                                             */
/* Fichier prototype WINUTIL .H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : printemps 1996                          */
/***************************************************************/
#ifndef WEDTDERV_H
#define WEDTDERV_H


#include <owl\combobox.h>
#include <owl\edit.h>
#include "wsysutil.h"

/*-------------------------------------------------------------*/
/*			   constantes                          */
/*-------------------------------------------------------------*/
#define CM_NextFocus   298
#define CM_PredFocus   299
/*-------------------------------------------------------------*/
/*	            prototypes de variables                    */
/*-------------------------------------------------------------*/
extern unsigned char uHauteurEdit;
extern unsigned char uDLE; // DcalageLigneEdition

extern TControl *pFocusedControl;
/*-------------------------------------------------------------*/
/*                     Classes  exporter                      */
/*--TEditNum---------------------------------------------------*/
// classe pour zone numrique
/*
class TEditNum : public TEdit
  {
    void EvChar(UINT key, UINT repeatCount, UINT flags);
  public :
    TEditNum(TWindow *Parent, int Id, float xValue, int X, int Y,
           int W, int H, UINT Taille=0, BOOL Multi=FALSE);
    TEditNum(TWindow *Parent, int Id, float xValue, TRect r, UINT Taille=0, BOOL Multi=FALSE);
    void SetValue(float xyValue=0.0);
//    void SetValue(long lValue=0);
    BOOL GetValue(unsigned char *puValue);
    BOOL GetValue(char *pcValue);
    BOOL GetValue(int *piValue);
    BOOL GetValue(float *pxyValue);

    DECLARE_RESPONSE_TABLE(TEditNum);
};
*/
/*-------------------------------------------------------------*/
/*                     Classes  exporter                      */
/*--TEditCR----------------------------------------------------*/

class TEditCR : public TEdit
  {
  public :
    TEditCR(TWindow *Parent, int Id, char far *Texte, int X, int Y,
	  int W, int H, UINT Taille=0, BOOL Multi=FALSE);
    TEditCR(TWindow *Parent, int Id, char far *Texte,
            TRect rPosition, UINT Taille=0, BOOL Multi=FALSE);
    BOOL fInhibRC;
    BOOL fInhibTab;
  protected :
    int code;
    TWindow *pt;
    virtual void EvKeyUp(UINT key, UINT repeatCount, UINT flags);
    virtual void EvChar(UINT key, UINT repeatCount, UINT flags);
    virtual UINT EvGetDlgCode(MSG far *);
    DECLARE_RESPONSE_TABLE(TEditCR);
};
/*--TEditNum---------------------------------------------------*/
// classe pour zone numrique

class TEditNumCR : public TEditCR
  {
  virtual void EvChar(UINT key, UINT repeatCount, UINT flags);
  public :
    TEditNumCR(TWindow *Parent, int Id, float xValue, int X, int Y,
           int W, int H, UINT Taille=0, BOOL Multi=FALSE);
    TEditNumCR(TWindow *Parent, int Id, float xValue, TRect r, UINT Taille=0, BOOL Multi=FALSE);
    void SetValue(float xyValue=0.0);
    inline void SetClearValue(float xyValue=0.0)
      {
      if (xyValue)
        SetValue(xyValue);
      else
        Clear();
      }
    BOOL GetValue(unsigned char *puValue);
    BOOL GetValue(char *pcValue);
    BOOL GetValue(unsigned int *pwValue);
    BOOL GetValue(int *piValue);
    BOOL GetValue(float *pxyValue);

    DECLARE_RESPONSE_TABLE(TEditNumCR);
};
// ComboBox avec articles accessibles par tiquettes ("Item").
class TComboBoxItems : public TComboBox
  {
  public :
    TComboBoxItems(TWindow* parent, int id, int x, int y,
      int w, int h, uint32 style, uint textLen, TModule* module = 0);
    TComboBoxItems(TWindow* parent, int id, TRect rPosition,
      uint32 style, uint textLen, TModule* module = 0);
    virtual DWORD GetSelItem (void);
    virtual int AddItem(DWORD dItemValue, const char * string);
    virtual int SetSelItem(DWORD dItemValue);
  };

/*--TLabeledEditNum---------------------------------------------*/
//
/*
TLabeledEdit(Num) is container of one TEdit(Num)CR and one TStatic.
  This container is supposed to make programmer'slife easiest providing him default settings
for labeld one-lined TEdit control windows.
  The constructor needs:
     parent window, label (for TStatic), value (numeric or string for TEdit),
     position of the container, width of the label and the TEdit.
  The constructors computes the height of both TStatic and TEdit for one-line height.

  Programmer can access the member function "Show" that works the same as TWindow::Show.

*/
class TLabeledEdit
  {
  public :
    TEditCR e;
    TStatic st;
    TLabeledEdit(TWindow *pwParent, char *szEtiquette, int Id, char *szText,
           /* position: */int X, int Y,
           /* widths: */int iWst, int iWe, UINT Taille=0, uint textLen=0, BOOL Multi=FALSE,
           TModule* module=0):
           e(pwParent,Id,szText,X+iWst,Y,iWe,uHauteurEdit,Taille,Multi),
           st(pwParent,0,szEtiquette,X,Y+uDLE,iWst,uHauteurLigne, textLen, module){}
    void Show(int cmd){e.Show(cmd);st.Show(cmd);}
  };

class TLabeledEditNum
  {
  public :
    TEditNumCR e;
    TStatic st;
    TLabeledEditNum(TWindow *Parent, char *szEtiquette, int Id, float xValue, int X, int Y,
           int iWst, int iWe, UINT Taille=0, uint textLen=0, BOOL Multi=FALSE,
           TModule* module=0);
  };

inline TLabeledEditNum::TLabeledEditNum(TWindow *pwParent, char *szEtiquette, int Id, float xValue, int X, int Y,
           int iWst, int iWe, UINT Taille, uint textLen, BOOL Multi,
           TModule* module):
  e (pwParent,Id,xValue,X+iWst,Y,iWe,uHauteurEdit,Taille,Multi),
  st (pwParent,0,szEtiquette,X,Y+uDLE,iWst,uHauteurLigne, textLen, module){}

#endif // WINUTIL_H
