#error Obsolete, remplac par scaltool.h
/*******************|*******************************************/
/*                  W M A T H D I V . H                        */
/*-------------------------------------------------------------*/
/*    Fonction       : Fonctions mathmatiques.                */
/*                                                             */
/*                                                             */
/* Fichier prototype WMATHDIV.H.                               */
/* (contient les prototypes des objets  exporter)             */
/*-------------------------------------------------------------*/
/*    Auteur         : Baptise MARCEL                          */
/*    Dvelopp le   : t     1994/1995                       */
/***************************************************************/
#if !defined(WSCALMAT_H)
#define WSCALMAT_H

#include <complex.h>
#include <limits.h>

#if _Windows
#include <owl\point.h>
#endif

#include "sysctr.h"
/*-------------------------------------------------------------*/
/*			   constantes                                         */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*		    nouveaux types  exporter                  */
/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*		    Nouvelles classes  exporter               */
/*-------------------------------------------------------------*/
/*	                   fonctions pour changements de reperes
  Nous avons 2 repres dans le plan: Ra et Rb.
  On initialise les paramtres de TReperage en faisant
SetRa(complex zOrigine, complex zVecX, complex zVecY) en lui passant les
coordonnes de repre Ra (origine, vecteur unit Ex et Ey) dans le repre Rb.
  Les fonctions Ra2Rb donnent les coordonne d'un point dans l'autre repre.
  GetRa et GetRb donnent les coordonnes de repre Ra (exprimm par rapport
 Rb) et Rb (par rapport  Ra).

*/
class TReperage
  {
  public :
    complex zOa, zXa, zYa, zOb, zXb, zYb;
    TReperage(complex zAOrigine, complex zAVecX, complex zAVecY,
              complex zBOrigine, complex zBVecX, complex zBVecY)
      {zOa=zAOrigine ; zXa=zAVecX ; zYa=zAVecY ; zOb=zBOrigine ; zXb=zBVecX ; zYb= zBVecY;}
    void SetRa(complex zOrigine, complex zVecX, complex zVecY);
    void SetRa()
      {complex O(0.0,0.0),x(1.0,0.0),y(0.0,1.0);SetRa(O,x,y);}
    TReperage(complex zOrigine, complex zVecX, complex zVecY)
      {SetRa(zOrigine,zVecX,zVecY);}
    TReperage(){SetRa();}
    void SetRaFromTGeom(complex zG, double dAlpha, complex zC);
    void GetRa(complex &zOrigine, complex &zVecX, complex &zVecY)
      {zOrigine=zOa;zVecX=zXa;zVecY=zYa;}
    void GetRb(complex &zOrigine, complex &zVecX, complex &zVecY)
      {zOrigine=zOb;zVecX=zXb;zVecY=zYb;}
    TReperage GetRb()
      {return TReperage(zOb,zXb,zYb,zOa,zXa,zYa);}
    complex Ra2Rb (complex za);



    complex Rb2Ra (complex zb);
    double TellTGeom(complex *zG, double *dAlphaX,double *dAlphaY, complex *zC);
#if _Windows
    complex Ra2Rb (TPoint pa);
    TPoint NRa2Rb (complex za);
    TPoint NRa2Rb (float xa, float ya);
    complex Rb2Ra (TPoint pb);
    TPoint NRa2Rb (TPoint pa);
    TPoint NRb2Ra (complex zb);
    TPoint NRb2Ra (float xb, float yb);
    TPoint NRb2Ra (TPoint pb);
#endif
  };
/*-------------------------------------------------------------*/
/*	                 prototypes de variables               */
/*-------------------------------------------------------------*/
extern float epsilon;
//extern complex zOa, zXa, zYa, zOb, zXb, zYb;
/*-------------------------------------------------------------*/
/*	                 prototypes de fonctions               */
/*-------------------------------------------------------------*/
/*	                   fonctions de contrle               */
/*	                   fonctions scalaires                 */
unsigned int PlusProchePuissanceDe2(unsigned int i);
int EstUnePuissanceDe2(unsigned int u);
unsigned long long_random (unsigned long l);
//	              Inline functions
inline char signe(float x)
  {
  return (x<0) ? -1 : (x>0);
  }

inline char signe(int n)
  {
  return (n<0) ? -1 : (n>0);
  }
inline float max (float first, float last)
  {
  return ( (first > last) ? first : last);
  }
/* NFloorR (floor (rel -> entier))
  Prend un flottant, l'arrondi par dfaut (vers l'entier infrieur) et le
renvoit en entier.
*/
inline int NFloorR (float x)
  {
  if (x<-32768.0 || x>=32768.0)
    MErreur("Conversion hors champ",268);
  return (int)floor((double)x);
  }

/* NCeilR (ceil (rel -> entier))
  Prend un flottant, l'arrondi par exces (vers l'entier suprieur) et le
renvoit en entier.
*/
inline int NCeilR (float x)
  {
  if (x<-32768.0 || x>32767.0)
    MErreur("Conversion hors champ",279);
  return (int)ceil((double)x);
  }

/* NUpRoundR (Round (rel-> entier))
  Prend un flottant, l'arrondi au plus proche (demi arrondi  l'unit sup.)
et le renvoit en entier. Fonction configure pour les ngatifs avec des
spcifications dont la fonction "PlusProcheImpair" dpend (arrondi de -0.5 donne 0).
*/
inline int NUpRoundR (float x)
  {
  if (x<-32768.0 || x>32767.0)
    MErreur("Conversion hors champ",291);
  return (int)floor((double)(x+0.5));
  }

/* NFarRoundR (Round (rel-> entier))
  Prend un flottant, l'arrondi au plus proche (demi arrondi  l'unit la plus loin de 0)
et le renvoit en entier. Fonction configure pour les ngatifs avec arrondi de -0.5 donne -1.
*/
inline int NFarRoundR (float x)
  {
  return (x>=0) ? NUpRoundR(x) : -NUpRoundR(-x);
  }


/* RReduceR (R Reduce R)
  Renvoit le mme flottant si il est dans l'intervalle spcifi,
ramne sa valeur  la limite dpasse sinon.
  "first" doit tre infrieur  "last".
*/
inline float RReduceR (float x, float first, float last)
  {
//  return max(first,min(last,x));
  float mi=last<x?last:x;
  return first>mi?first:mi;
  }

inline int NReduceR (float x, int first, int last)
  {
  float xMin=(float)last<x?(float)last:x;
  return NFarRoundR((float)first>xMin?(float)first:xMin);
  }

/* RReduceR (R Reduce R)
  Renvoit le mme flottant si il est dans l'intervalle spcifi,
ramne sa valeur  la limite dpasse sinon.
  "first" doit tre infrieur  "last".
*/
inline float NReduceN (int x, int first, int last)
  {
  int iMin=last<x?last:x;
  return first<iMin?first:iMin;
  }
/* PlusProcheImpair (Plus proche impair)
  Renvoit l'entier impair le plus proche de la valeur donne (suprieur pour
les cas limite d'un argument entier pair. Par ex. : 2 -> 3, 0 -> 1 et
-2 -> -1).
  Attention : 255 renvoit 256 (ce qui est 0 si la variable cible est char.
*/
inline int PlusProcheImpair(float fr)
  {
  return  (NUpRoundR( (fr-1.0)/2.0)  * 2 + 1);
  }

inline unsigned char i2uc(int n)
  {
  if (n<0 || n>255)
    MErreur("Conversion hors champ from WSC",343);
  return (unsigned char)n;
  }

inline char i2c(int n)
  {
  if (n < -128 || n>127)
    MErreur("Conversion hors champ",350);
  return (char)n;
  }
inline int ul2i(unsigned long l)
  {
  if (l > INT_MAX)
    MErreur("Conversion hors champ (SCALTOOL.H).",156);
  return (int)l;
  }
#endif // __WSCALMAT_H


