#include "baptiall.h"

#pragma hdrstop

/**********************************************************************/
/*                       W I R I S C T R . C P P                      */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fonctions de contrle pour Iris dtournables   */
/*                     pour d'autres applications.                    */
/*--------------------------------------------------------------------*/
/*    Auteur         : Baptiste MARCEL       			      */
/*    Dvelopp le   : Printemps 1996                                 */
/**********************************************************************/
/*
   // Inclusions bibliothques standards
   //#include <stdio.h>
   
   //  Inclusions bibliothques Object Windows
   #include <owl\inputdia.h>
   #include <owl\button.h>
   #include <owl\window.h>
   //#include <owl\point.h>
   // Inclusions bibliothques DOS
   */
// Inclusion bibliothques Image
#include "wsysutil.h"
//#include "wmain.h"
//  Inclusions bibliothques Iris
#include "base.h"
#include "strtool.h"
#include "wsystool.h"

//#include "wedtder2.h"
/*-----------------------------------------------------------------------*/
/*                     Constantes locales                                */
/*-----------------------------------------------------------------------*/
#define ID_BOUTON 50
#define ID_A 51
 /*-----------------------------------------------------------------------*/ /*                     Variables globales                                */ /*-----------------------------------------------------------------------*/ 

unsigned char uLargeurAscenseurs = GetSystemMetrics(SM_CXSIZE);
unsigned char uHauteurAscenseurs = GetSystemMetrics(SM_CYSIZE);
unsigned char uMargeTEdit = 4 ;
unsigned char uHauteurEdit = 24 ;
unsigned char uLargeurMaxCar = 5 ;
unsigned char uDLE = (uHauteurEdit - uHauteurLigne) / 2 ; //uDecalageLigneEdition
int           fDemarrPleinEcr = MARCHE ;
TSize         sMarges (MARGE_H, MARGE_V) ;
TWindow       *pFenetreControle = NULL ;

//inline
BOOL WritePrivate ( char *szSection, char *szEntry, TPoint pValue
    , char *szFilename )
{
return WritePrivatePoint(szSection, szEntry, pValue, szFilename);
}

int GetText ( TWindow *parent, char *szTitre, char *szTexte
    , char *szReponse, unsigned int wLg )
{
if ( !wLg ) 
  return ECHEC ;

//  *szReponse=0;
if ( (TInputDialog(parent, szTitre, szTexte, szReponse, wLg)).Execute()
      == IDOK ) 
  return SUCCES ;
else 
  return ECHEC ;
}

int GetFloatValue ( TWindow *parent, char *szTitre, char *szTexte
    , float *px )
{
char  szInputText [USUALMAXLENSTRING] = "";

if ( !GetText(parent, szTitre, szTexte, szInputText, sizeof(szInputText)) ) 
  return ECHEC ;
else 
  return ExtractValue(szInputText, px);
}

int GetIntValue ( TWindow *parent, char *szTitre, char *szTexte, char *pc )
{
return GetIntishValue(parent, szTitre, szTexte, pc); /*
                                                        int i;
                                                        char fRes;
                                                        if ((fRes=GetIntValue(parent,szTitre,szTexte, &i))!=0)
                                                          *pc=(char)i;  // Uniquement si succes.
                                                        return fRes;
                                                        */ 
}

int GetIntValue ( TWindow *parent, char *szTitre, char *szTexte
    , unsigned int *pw )
{
int   i ;
char  fRes ;

if ( (fRes = GetIntValue(parent, szTitre, szTexte, &i)) != 0 ) 
  *pw =  (unsigned int)(max(i, 0)); // Uniquement si succes.
return fRes ;
}

int GetIntValue ( TWindow *parent, char *szTitre, char *szTexte
    , unsigned char *pu )
{
int   i ;
char  fRes ;

if ( (fRes = GetIntValue(parent, szTitre, szTexte, &i)) != 0 ) 
  *pu =  (char)i ; // Uniquement si succes.
return fRes ;
}

int GetIntValue ( TWindow *parent, char *szTitre, char *szTexte, int *pi
    , char *szDef )
{
char  szInputText [USUALMAXLENSTRING] = "";

if ( szDef ) 
  strNcpy(szInputText, szDef, sizeof(szInputText));
if ( !GetText(parent, szTitre, szTexte, szInputText, sizeof(szInputText)) ) 
  return ECHEC ;
else 
  return ExtractValue(szInputText, pi);
}

int IsPoint ( TRect r )
{
return r.top == r.bottom && r.left == r.right ;
}

TPoint GetPrivate ( char *szSection, char *szEntry, TPoint ptDefault
    , char *szFileName )
{
return GetPrivatePoint(szSection, szEntry, ptDefault, szFileName);
}

TPoint GetPrivatePoint ( char *szSection, char *szEntry, TPoint ptDefault
    , char *szFileName )
{
char  szLigne [USUALMAXLENSTRING * 2];

if ( !szSection || !szEntry || !szFileName ) 
  return ptDefault ;
else 
  GetPrivateString(szSection, szEntry, "", szLigne, USUALMAXLENSTRING * 2
    , szFileName);

TPoint  p ;

if ( String2PointEF(szLigne, &p) ) 
  return p ;
else 
  return ptDefault ;
}

BOOL WritePrivatePoint ( char *szSection, char *szEntry, TPoint pValue
    , char *szFilename )
{
char  sz [14];

wsprintf(sz, "%d,%d", pValue.x, pValue.y);
return WritePrivateString(szSection, szEntry, sz, szFilename);
}

// ppcNext is authorized null.
BOOL ExtractPointValue ( char *pcFirst, TPoint *ppt, char **ppcNext )
{
if ( !pcFirst ) 
  return FAILURE ;

char  *pcInterm = NULL ;
BOOL  fLec1 = ExtractValue(pcFirst, &(ppt -> x), &pcInterm);

if ( !fLec1 || !pcInterm ) 
  
  // Failure in 1st reading or only one int
  return FAILURE ;
return ExtractValue(pcInterm, &(ppt -> y), ppcNext);
}

//----------------------------------------------------------------------------
//						Programme AppelChoixDial
//----------------------------------------------------------------------------
BOOL AppelDialChoice ( TWindow *Parent, char titre [], char tabchoix []
    , char *pcRes, TRect fen )
{
int iRes = TDialChoice(Parent, titre, tabchoix, fen).Execute();

if ( !pcRes || iRes == 'f' || iRes == 'F' || iRes == 0x02 ) 
  
  // Annulation ou
  return FALSE ; // Fermeture
else 
  {
  *pcRes =  iRes & 0xFF ;
  return TRUE ;
  }
}

//----------------------------------------------------------------------------
//						Programme TDialChoice
//----------------------------------------------------------------------------
DEFINE_RESPONSE_TABLE1 (TDialChoice, TDialog) EV_COMMAND (ID_A, EvA)
  , EV_COMMAND(ID_A + 1, EvB), EV_COMMAND(ID_A + 2, EvC)
  , EV_COMMAND(ID_A + 3, EvD), EV_COMMAND(ID_A + 4, EvE)
  , EV_COMMAND(ID_A + 5, EvF), EV_COMMAND(ID_A + 6, EvG)
  , EV_COMMAND(ID_A + 7, EvH), EV_COMMAND(ID_A + 8, EvI)
  , EV_COMMAND(ID_A + 9, EvJ), EV_COMMAND (ID_BOUTON, EvBouton)
  , END_RESPONSE_TABLE ;

TDialChoice::TDialChoice ( TWindow *Parent, char titre [], char tabchoix []
    , TRect fen )
  : TDialog(Parent, "DIALBOX")
{
int   TailleBouton ;
int   LargeurFen ;
int   maxl = 0 ;
int   i, x0, y0, l, j ;
int   xmax, ymax ;  // Largeur & hauteur fentre
int   Fx, Fy = 25 ; // Tailles fentres
char  *pt, *tab ;
int   nbchoix ;

SetCaption(titre);
l   =  strlen(tabchoix);
tab =  (char *)malloc(l + 1);
pt  =  tab ;
strcpy(pt, tabchoix);
nbchoix =  1 ;
for ( i = 0 ; i < l ; i++ ) 
  if ( pt [i] == '\n' ) 
    {
    pt [i] =  0 ;
    nbchoix++ ;
    }
if ( nbchoix > 10 ) 
  nbchoix =  10 ; // Limite le nb total de choix
if ( fen.IsNull() ) // On calcule le format
                      {
                      for ( i = 0 ; i < nbchoix ; i++ ) 
                        {
                        
                        // calcul du max
                        l    =  strlen(pt);
                        maxl =  (l > maxl) ? l : maxl ;
                        pt   += l + 1 ;
                        }
                      TailleBouton =  maxl * 8 + 8 ;
                      LargeurFen   =  TailleBouton * nbchoix + 30 ;
                      l            =  strlen(titre) * 8 + 100 ; // Min 100
                      if ( LargeurFen < l ) 
                        LargeurFen =  l ;
                      Format
                        =  TRect(320 - LargeurFen / 2, 200
                            , 320 + LargeurFen / 2, 300)
                          & TRect(0, 0, 640, 480);
                      }
else 
  Format =  fen ; // On prend le format
xmax =  Format.Width() - GetSystemMetrics(SM_CXBORDER) * 2 ;
ymax 
  =  Format.Height() - GetSystemMetrics(SM_CYBORDER) * 2
    - GetSystemMetrics(SM_CYMENU);
Fx   =  (xmax - 30) / nbchoix ;
if ( Fx > 160 ) 
  Fx =  160 ; // Si trop grand : pas joli !!!
x0 =  (xmax - Fx * nbchoix) >> 1 ; // centre horizontal
y0 =  (ymax - 2 * Fy) >> 1 ; // position verticale
pt =  tab ;
for ( i = 0 ; i < nbchoix ; i++ ) 
  {
  new TButton(this, ID_A + i, pt, x0 + i * Fx, y0, Fx - 1, Fy - 1, FALSE);
  l          =  strlen(pt);
  tabret [i] =  pt [0]; // Par dfaut
  for ( j = 0 ; j < l ; j++ ) 
    if ( pt [j] == '&' ) 
      tabret [i] =  pt [j + 1];
  pt += l + 1 ;
  }
new TButton(this, ID_BOUTON, "&FERMER", x0, y0 + Fy, - 1 + nbchoix * Fx
  , Fy - 1, FALSE);
free(tab);
}

void TDialChoice::EvA ()
{
EvCommun(tabret [0]);
}

void TDialChoice::EvB ()
{
EvCommun(tabret [1]);
}

void TDialChoice::EvC ()
{
EvCommun(tabret [2]);
}

void TDialChoice::EvD ()
{
EvCommun(tabret [3]);
}

void TDialChoice::EvE ()
{
EvCommun(tabret [4]);
}

void TDialChoice::EvF ()
{
EvCommun(tabret [5]);
}

void TDialChoice::EvG ()
{
EvCommun(tabret [6]);
}

void TDialChoice::EvH ()
{
EvCommun(tabret [7]);
}

void TDialChoice::EvI ()
{
EvCommun(tabret [8]);
}

void TDialChoice::EvJ ()
{
EvCommun(tabret [9]);
}

void TDialChoice::EvBouton ()
{
CloseWindow(int('F')); // F-> FERMER
}

void TDialChoice::EvCommun ( char c )
{
CloseWindow(int(c));
}

void TDialChoice::SetupWindow ()
{
TDialog::SetupWindow();
MoveWindow(Format, FALSE);
}

void TDialChoice::CloseWindow ( int ret )
{
TDialog::CloseWindow(ret); // fermer la bote de dialogue
}
